//判断本种族是否可用该技能，可以使用则返回true
function checkRace(skillName, msg){
    const flag = !!races[data.race.name || '人类'].skills[skillName];
    if(!flag && msg){
        winMsg('你的种族不能使用该技能', false, false)
    }
    return flag;
}

const skills = {
    //公共技能
    '技能石：重击' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 100,
        voidDust : 20,
        quality : 1,
        gold : 250,
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1.3)
        },
        text : '造成人物攻击+武器攻击之和的1.3倍伤害'
    }),
    '技能石：治愈术' : new Element({
        canUse :true,
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        func : function(){
            let addHp = data.atk + (data.weapon ? data.weapon.getAtk(data.weapon) : 0)
            addHp *= 2;
            const text = `使用了治愈术，恢复${battleAddHp(data, addHp)}HP`;
            winMsg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return (data.atk + (data.weapon ? data.weapon.getAtk(data.weapon) : 0)) * 2;
        },
        text : '恢复相当于人物攻击力+装备攻击力2倍的的血量'
    }),
    '技能石：灵魂鞭挞' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        noSuck :true,
        endurance : 50,
        voidDust : 20,
        quality : 1,
        gold : 250,
        preFunc : function(){
            if(randomNum(1,100) <= 30){
                addBattleLog(`使用了灵魂鞭挞，${data.battleMonster.showName || data.battleMonster.name}被附加了眩晕状态。`)
                addStatus(data.battleMonster, getStatus('眩晕', {num : 2}));
            }

            return true;
        },
        myAtk : function(){
            return data.level * 10 + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0))
        },
        text : '固定造成等级*10的伤害，无视防御，并且有30%概率使对方陷入眩晕，持续2回合。本技能无法触发吸血。'
    }),
    '技能石：晶甲守护' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        func : function(){
            if(data.battleMonster.jjsh){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }

            data.battleMonster.jjsh = true;
            data.reduceHart += 0.15;
            const text = `使用了晶甲守护，增加15%减伤`;
            addBattleLog(text)
            return true;
        },
        text : '增加15%减伤，每场战斗只能使用一次'
    }),
    '技能石：荒芜大地' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        func : function(){
            if(data.battleMonster.hwdd){
                winMsg('你已经使用了荒芜大地', false, false)
                return false;
            }
            data.battleMonster.hwdd = true;

            let text = `使用了荒芜大地，${data.battleMonster.showName || data.battleMonster.name}被附加了枯萎状态。`;
            addStatus(data.battleMonster, getStatus('枯萎', {keep : true, num : 1, harm : data.level * 3}));
            data.battleMonster.def -= data.level * 2;
            text += `并且防御力减少${data.level * 2}。`;
            addBattleLog(text)
            return true;
        },
        text : '为对方附加枯萎状态，每回合减少你的相当于你的等级*3的生命值，该状态不会自动消失。并减少对方相当于你等级*2的防御力，每场战斗只能使用一次'
    }),
    '技能石：威吓' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        func : function(){
            if(!data.battleMonster.wh){
                data.battleMonster.wh = 0;
            }
            const num = 100 - data.battleMonster.wh;
            if(num <= 0){
                winMsg('对方已经习惯了你的威吓')
                return false;
            }

            if(randomNum(1,100) > num){
                addBattleLog(`你使用了威吓，但是${data.battleMonster.showName || data.battleMonster.name}没有受到影响。`)
                data.battleMonster.wh += 10;
                return true;
            }

            if(data.battleMonster.startAttrs){
                data.battleMonster.wh += 10;
                data.battleMonster.atk = data.battleMonster.startAttrs.atk;
                data.battleMonster.def = data.battleMonster.startAttrs.def;
                addBattleLog(`你使用了威吓，${data.battleMonster.showName || data.battleMonster.name}的属性被重置了。`)
            }else{
                addBattleLog(`这个怪物没有读取到初始属性，无法使用威吓`)
                return false;
            }
            return true;
        },
        text : '使对方的攻击和防御属性变为战斗开始时的基础值（像陷阱大师这种开局会先减少怪物50%防御之类的情况，基础值就是减少了50%之后的防御）。第一次使用100%成功，每使用过一次后，无论成功失败，成功率都会降低10%。当成功率降低为0%，则不可以使用了'
    }),
    '技能石：灵魂折磨' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        noSuck : true,
        endurance : 50,
        voidDust : 20,
        quality : 1,
        gold : 250,
        preFunc : function(){
            addStatus(data.battleMonster, getStatus('痛苦'));
            if(randomNum(1,100) <= 20){
                addBattleLog(`使用了灵魂折磨，${data.battleMonster.showName || data.battleMonster.name}被附加了眩晕状态。`)
                addStatus(data.battleMonster, getStatus('眩晕', {num : 3}));
            }

            return true;
        },
        myAtk : function(){
            return parseInt(data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0) + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0)))
        },
        text : '造成人物攻击+武器攻击之和的伤害，无视防御，并给对方附加痛苦状态，生命值恢复减少75%，持续3回合。并且有20%概率使对方陷入眩晕，持续3回合。本技能无法触发吸血。'
    }),
    '技能石：生死转换' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        func : function(){
            const addAtk = data.def > 0 ? parseInt(data.def * 0.5) : 0;
            const addHp = data.def > 0 ? data.def * 20 : 0;
            data.atk += addAtk;
            data.maxHp += addHp;
            data.def = 0;
            addBattleLog(`使用了生死转换，你的防御力变为0，攻击力增加${addAtk}，生命上限增加${addHp}`)
            return true;
        },
        text : '你的防御力变为0，每减少了1防御，增加0.5攻击和20生命上限，如果防御力为负数则不会增加攻击和生命，防御依旧会变为0'
    }),
    '技能石：圣光之心' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        func : function(){
            if(data.battleMonster.sgzx >= 3){
                winMsg('每场战斗只能使用3次',false,false)
                return false;
            }

            if(!data.battleMonster.sgzx){
                data.battleMonster.sgzx = 1;
            }else{

                data.battleMonster.sgzx += 1;
            }

            const addHp = data.maxHp
            const text = `使用了圣光之心，恢复${battleAddHp(data, addHp)}HP`;
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return data.maxHp;
        },
        text : '恢复100%的血量，每场战斗只能使用3次'
    }),
    '技能石：洗涤' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            removeAllDebuff(data);
            addBattleLog( `你使用了洗涤，清除了所有负面状态`)
            return true;
        },
        text : '清除所有负面状态。'
    }),
    '技能石：驱散' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            removeAllBuff(data.battleMonster);
            addBattleLog( `你使用了驱散，清除了${data.battleMonster.showName || data.battleMonster.name}所有正面状态`)
            return true;
        },
        text : '清除怪物所有正面状态。'
    }),

    //种族技能
    //人类系列技能
    '技能石：血气斩' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        myAtk : function(){
            if(!checkRace('血气斩')){
                return 0;
            }
            return parseInt(data.maxHp / 20) + parseInt(data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0));
        },
        text : '人类种族技能，生命上限每有20点，额外造成1点伤害'
    }),
    '技能石：舍生忘死' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            const needHp = parseInt(data.maxHp * 0.3);
            if(data.hp <= needHp){
                winMsg('生命值不足', false, false)
                return false;
            }

            if(!confirm('是否确认使用舍生忘死？')){
                return false;
            }

            data.hp -= needHp;
            addBattleLog(`你使用了舍生忘死，消耗了${needHp}HP`)
            return true;
        },
        myAtk : function(){
            if(!checkRace('舍生忘死')){
                return 0;
            }
            return parseInt(data.maxHp * 0.3) * 3 + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0));
        },
        text : '该技能已废弃。'
    }),
    '技能石：搏命一击' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!confirm('是否确认使用搏命一击？')){
                return false;
            }

            const needHp = data.hp - 1;
            data.hp = 1;
            addBattleLog(`你使用了搏命一击，消耗了${needHp}HP`)
            return true;
        },
        myAtk : function(){
            if(!checkRace('搏命一击')){
                return 0;
            }
            return (data.hp - 1) * 5 + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0));
        },
        text : '该技能已废弃。'
    }),
    '技能石：浴血奋战' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        myAtk : function(){
            if(!checkRace('浴血奋战')){
                return 0;
            }
            const atk = parseInt(data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0));
            return atk + parseInt(atk * (1 - (data.hp / data.maxHp)) * 3)
        },
        text : '人类-战士种族技能，满血时造成人物攻击+武器攻击之和的伤害。每损失了1%生命值，本技能造成的伤害提高3%。'
    }),
    '技能石：狂暴治疗' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('狂暴治疗', true)){
                return false;
            }
            let addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
            addHp *= 2;
            const text = `使用了狂暴治疗，恢复${battleAddHp(data, addHp)}HP`;
            winMsg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return parseInt((data.maxHp - data.hp) * 0.2);
        },
        text : '人类-神孽种族技能，恢复当前已损失生命值20%的生命值'
    }),
    '技能石：寒冰箭' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('寒冰箭', true)){
                return false;
            }

            if(hasStatus(data, '念咒') || data.race.name === '人类-元素师'){
                if(data.spi < 3){
                    winMsg('精神不足', false, false);
                    return false;
                }
                data.spi -= 3;
                if(randomNum(1,100) <= 35){
                    addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被附加了冰冻状态。`)
                    addStatus(data.battleMonster, getStatus('冰冻'));
                }
                removeStatus(data, '念咒')

                return true;
            }else{
                if(data.spi < 3){
                    winMsg('精神不足', false, false);
                    return false;
                }
                addStatus(data, getStatus('念咒'))
                addBattleLog('你开始念咒')
                monsterAtk();
                return false;
            }
        },
        myAtk : function(){
            if(!checkRace('寒冰箭')){
                return 0;
            }
            return parseInt(data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0) + data.level * 30)
        },
        text : '人类-法师种族技能，如果没有念咒状态，则给自己增加1层念咒状态，有念咒状态则消耗掉念咒状态，并消耗3精神释放一道寒冰箭，造成玩家攻击+武器攻击+等级*30的伤害，并有35%几率给怪物附加冰冻状态，持续1回合。该技能无法触发吸血。'
    }),
    '技能石：火球术' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('火球术', true)){
                return false;
            }

            if(hasStatus(data, '念咒') || data.race.name === '人类-元素师'){
                if(data.spi < 5){
                    winMsg('精神不足', false, false);
                    return false;
                }
                data.spi -= 5;
                if(randomNum(1,100) <= 50){
                    addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被附加了燃烧状态。`)
                    addStatus(data.battleMonster, getStatus('燃烧',{harm : parseInt(this.myAtk() * 0.3)}));
                }
                removeStatus(data, '念咒')

                return true;
            }else{
                if(data.spi < 5){
                    winMsg('精神不足', false, false);
                    return false;
                }
                addStatus(data, getStatus('念咒'))
                addBattleLog('你开始念咒')
                monsterAtk();
                return false;
            }
        },
        myAtk : function(){
            if(!checkRace('火球术')){
                return 0;
            }
            return parseInt(data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0) + data.level * 50)
        },
        text : '人类-法师种族技能，如果没有念咒状态，则给自己增加1层念咒状态，有念咒状态则消耗掉念咒状态，并消耗5精神释放一个火球攻击敌人，造成玩家攻击+武器攻击+等级*50的伤害，并有50%几率给怪物附加燃烧状态，每回合造成本次伤害30%的伤害，持续3回合。该技能无法触发吸血。'
    }),
    '技能石：寒冰爆发' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('寒冰爆发', true)){
                return false;
            }

            if(data.spi < 20){
                winMsg('精神不足', false, false);
                return false;
            }
            data.spi -= 20;

            if(randomNum(1,100) <= 70){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被附加了冰冻状态。`)
                addStatus(data.battleMonster, getStatus('冰冻', {num : 1}));
            }

            return true;
        },
        myAtk : function(){
            if(!checkRace('寒冰爆发')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1) + data.level * 30
        },
        text : '该技能已废弃'
    }),
    '技能石：爆炎术' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('爆炎术', true)){
                return false;
            }

            if(data.spi < 30){
                winMsg('精神不足', false, false);
                return false;
            }
            data.spi -= 30;

            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被附加了燃烧状态。`)
            addStatus(data.battleMonster, getStatus('燃烧',{harm : parseInt(this.myAtk() * 0.2)}));

            return true;
        },
        myAtk : function(){
            if(!checkRace('爆炎术')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1) + data.level * 40
        },
        text : '该技能已废弃'
    }),

    //史莱姆系列技能
    '技能石：吞噬' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('吞噬')){
                return false;
            }

            data.mucus += getNumByBag('粘液') + (getNumByBag('史莱姆精华') * 5)
            reduceItem('粘液', getNumByBag('粘液'));
            reduceItem('史莱姆精华', getNumByBag('史莱姆精华'));
            return true;
        },
        text : '史莱姆种族技能，吞噬背包中所有的粘液和史莱姆精华，每吞噬1粘液获得1粘液值，每吞噬1史莱姆精华获得5粘液值。'
    }),
    '技能石：消化' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('消化')){
                return false;
            }

            if(data.mucus <= 0){
                const text = `你没有粘液值了`;
                winMsg(text, false, false);
                return false;
            }

            const need = data.level > data.mucus ? data.mucus : data.level;
            const addHp = need * 10;
            const text = `你使用了消化，恢复${battleAddHp(data, addHp)}HP`;
            winMsg(text);
            addBattleLog(text)
            data.mucus -= need;

            return true;
        },
        myHp : function(){
            const need = data.level > data.mucus ? data.mucus : data.level;
            const addHp = need * 10;
            return addHp;
        },
        text : '史莱姆种族技能，消耗相当于你等级的粘液值（不足则消耗所有粘液值），恢复消耗粘液值*10的血量。'
    }),
    '技能石：腐蚀' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('腐蚀', true)){
                return false;
            }

            if(data.mucus < 5){
                const text = `你的粘液值不足`;
                winMsg(text, false, false);
                return false;
            }
            data.mucus -= 5;

            data.battleMonster.def -= 5;
            const text = `使用了腐蚀，${data.battleMonster.showName || data.battleMonster.name}减少了5点防御力`;
            addBattleLog(text)
            return true;

        },
        myAtk : function(){
            if(!checkRace('腐蚀')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 0.8)
        },
        text : '史莱姆种族技能，消耗5粘液值，减少怪物5点防御力，造成人物攻击+武器攻击之和0.8倍的伤害'
    }),
    '技能石：强酸腐蚀' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('强酸腐蚀', true)){
                return false;
            }

            if(data.mucus < 20){
                const text = `你的粘液值不足`;
                winMsg(text, false, false);
                return false;
            }
            data.mucus -= 20;

            data.battleMonster.def -= 10;
            const text = `使用了强酸腐蚀，${data.battleMonster.showName || data.battleMonster.name}减少了10点防御力`;
            addBattleLog(text)
            return true;
        },
        myAtk : function(){
            if(!checkRace('强酸腐蚀')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1)
        },
        text : '史莱姆种族技能，消耗20粘液值，减少怪物10点防御力，造成人物攻击+武器攻击之和1倍的伤害'
    }),
    '技能石：强酸生产' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('强酸生产', true)){
                return false;
            }

            const need = 100;
            if(data.hp > need){
                data.hp -= need;
                addItem('强酸粘液', 10)
                return true;
            }else{
                const text = `无法使用强酸生产，HP不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '该技能已废弃'
    }),
    '技能石：强酸护甲' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('强酸护甲', true)){
                return false;
            }

            if(data.mucus < 30){
                const text = `你的粘液值不足`;
                winMsg(text, false, false);
                return false;
            }
            data.mucus -= 30;

            data.def += 10;
            addStatus(data, getStatus('强酸', {returnHarm : data.level, num : 99}));
            addBattleLog('使用了强酸护甲，防御力+10，获得强酸状态')
            return true;
        },
        text : '史莱姆-强酸种族技能，消耗30粘液值，增加10防御力，并给自己附加强酸状态，敌人攻击你时会受到同等于你等级伤害，持续99回合'
    }),
    '技能石：枯朽' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('枯朽', true)){
                return false;
            }

            if(data.mucus < 50){
                const text = `你的粘液值不足`;
                winMsg(text, false, false);
                return false;
            }
            data.mucus -= 50;

            const num = getNumByBag('枯朽粘液');

            addStatus(data.battleMonster, getStatus('中毒', {num : 5, harm : data.level * 10}))
            data.battleMonster.def -= data.level;
            const text = `使用了枯朽，${data.battleMonster.showName || data.battleMonster.name}减少了${data.level}点防御力`;
            addBattleLog(text)
            return true;
        },
        myAtk : function(){
            if(!checkRace('枯朽')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1)
        },
        text : '史莱姆-毒液种族技能，消耗50粘液值，减少怪物同等于你等级的防御力，造成人物攻击+武器攻击之和1倍的伤害，并给怪物附加中毒状态，每回合造成等级*10的伤害，持续5回合'
    }),
    '技能石：分裂' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('分裂', true)){
                return false;
            }

            const need = parseInt(data.maxHp * 0.3);
            if(data.hp <= need){
                const text = `无法使用分裂，HP不足`;
                winMsg(text, false, false);
                return false;
            }

            if(getNumByBag('神性结晶') < 1){
                winMsg('神性结晶不足', false, false)
                return false;
            }

            data.hp -= need;
            reduceItem('神性结晶')
            addItem('史莱姆之心')
            return true;
        },
        text : '史莱姆-巨化种族技能，消耗30%血量和1个神性结晶，制造一个史莱姆之心'
    }),
    '技能石：王者护卫' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('王者护卫', true)){
                return false;
            }

            if(!data.battleMonster.wzhw){
                data.battleMonster.wzhw = 0;
            }
            data.battleMonster.wzhw++;
            let returnHarm = data.battleMonster.wzhw * (data.level * 5);
            data.def -= data.level;

            removeStatus(data, '护卫')
            addStatus(data, getStatus('护卫', {num : 10, returnHarm}))
            addBattleLog('一批史莱姆护卫加入战场')

           return true;
        },
        text : '史莱姆-王者种族技能，召唤史莱姆保护自己，给自己附加护卫状态，对攻击者造成等级*5伤害，每使用一次，防御力减少等级*1的值，护卫状态造成的伤害增加等级*5，持续10回合'
    }),

    //神性史莱姆系列技能
    '技能石：凝结' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('凝结', true)){
                return false;
            }

            if(data.divinity >= 10){
                data.divinity -= 10;
                addItem('神性结晶')
                return true;
            }else{
                const text = `无法使用凝结，神性不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '神性史莱姆种族技能，消耗10点神性，制造一个神性结晶'
    }),
    '技能石：分泌' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('分泌', true)){
                return false;
            }

            const need = parseInt(data.maxHp * 0.6);
            if(data.hp > need){
                data.hp -= need;
                addItem('神性液体')
                return true;
            }else{
                const text = `无法使用分泌，HP不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '该技能已废弃'
    }),
    '技能石：神疗术' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('神疗术', true)){
                return false;
            }
            if(getStatuNum(data, '饱和') >= 10){
                winMsg('你体内的神力已经饱和', false, false)
                return false;
            }

            if(data.divinity >= 5){
                data.divinity -= 5;
                if(inBattle()){
                    addStatus(data, getStatus('饱和'))
                }
                const text = `使用了神疗术，恢复${battleAddHp(data, this.myHp ? this.myHp() : elementCfgs[this.name].myHp())}HP`;
                msg(text);
                addBattleLog(text)
                return true;
            }else{
                const text = `无法使用神疗术，神性不足`;
                winMsg(text, false, false);
                return false;
            }

        },
        myHp : function(){
            return parseInt((data.maxHp * (1 - (getStatuNum(data, '饱和') * 0.1))).toFixed(0));
        },
        text : '神性史莱姆种族技能，消耗5神性，恢复所有血量，战斗中使用时为自己附加饱和状态，每有1层饱和状态，治疗量降低10%'
    }),
    '技能石：净化' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('净化', true)){
                return false;
            }

            removeAllDebuff(data);
            addBattleLog( `你使用了净化，清除了所有负面状态`)
            return true;
        },
        text : '神性史莱姆种族技能，清除所有负面状态。'
    }),
    '技能石：神性爆发' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('神性爆发', true)){
                return false;
            }

            if(data.divinity < 10){
                winMsg('神性不足')
                return false;
            }
            if(data.battleMonster.sxbf){
                winMsg('你正处于神性爆发状态', false, false)
                return false;
            }

            data.battleMonster.sxbf = true

            removeAllDebuff(data);
            let need = data.divinity;
            if(need > 300){
                need = 300;
            }

            battleAddHp(data, data.maxHp)
            data.atk += need;
            data.def += need;
            addBattleLog(`使用了神性爆发，生命值完全恢复，攻击力和防御力增加${need}`)
            data.divinity -= need;
            return true;

        },
        myHp : function(){
            return data.maxHp;
        },
        text : '神性史莱姆种族技能，消耗所有神性（最少10，最多300），恢复所有血量，清除所有负面状态，攻击力和防御力增加消耗的神性的值，一场战斗只能使用1次'
    }),
    '技能石：索求' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('索求', true)){
                return false;
            }

            if(data.deitys['水之女神'].godFavor < 50){
                winMsg('神眷不足', false, false)
                return false;
            }

            if(!data.divinity){
                data.divinity = 0;
            }
            data.deitys['水之女神'].godFavor -= 50;
            data.divinity += 10;
            winMsg('使用了索求，获得10神性');

            return true;
        },
        text : '神性史莱姆-神化种族技能，减少水之女神的50神眷，获得10神性'
    }),
    '技能石：律令死亡' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('律令死亡', true)){
                return false;
            }
            if(data.battleMonster.type === '神话'){
                winMsg('律令死亡对神话怪无效', false, false)
                return false;
            }

            const need = data.battleMonster.type === '传说' ? 50 : data.battleMonster.type === '精英' ? 15 : 1;

            if(data.divinity >= need){
                data.divinity -= need;
                return 'win';
            }else{
                const text = `神性不足，需要${need}点神性`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '神性史莱姆-神化种族技能，消耗神性(普通1点，精英15点，传说50点)，直接杀死战斗对象，对神话怪无效。'
    }),
    '技能石：祈祷' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('祈祷', true)){
                return false;
            }
            let need = (data.level - 100) * 5;
            if(need < 10){
                need = 10;
            }
            if(data.divinity < need){
                winMsg(`神性不足，需要${need}点神性`, false, false);
                return false;
            }

            data.divinity -= need;
            data.exp += data.race.getLevelUpExp();
            level();
            return true;
        },
        text : '神性史莱姆-半神种族技能，消耗（当前等级-100）*5的神性，直接提升1级，至少需要消耗10点神性。'
    }),
    '技能石：奉献' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('奉献', true)){
                return false;
            }

            if(data.divinity < 10){
                winMsg('神性不足', false, false)
                return false;
            }

            data.divinity -= 10;
            data.deitys['水之女神'].godFavor += 50;
            data.deitys['水之女神'].belief += 50;
            winMsg('使用了奉献，获得水之女神的50信仰和50神眷');

            return true;
        },
        text : '神性史莱姆-亵渎种族技能，奉献10神性，换取水之女神的50信仰和50神眷'
    }),
    '技能石：狩神' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('狩神', true)){
                return false;
            }
            if(data.battleMonster.type !== '神话'){
                winMsg('只能对神话生物使用', false, false)
                return false;
            }
            return true;
        },
        myAtk : function(){
            if(!checkRace('狩神')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 5)
        },
        text : '神性史莱姆-狩神者种族技能，只能对神话生物使用，造成5倍伤害。'
    }),

    //哥布林系列技能
    '技能石：偷袭' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('偷袭', true)){
                return false;
            }

            if(data.battleMonster.hp < data.battleMonster.maxHp){
                winMsg('只能在怪物满血时使用', false, false);
                return false;
            }

            return true;

        },
        myAtk : function(){
            if(!checkRace('偷袭')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 3)
        },
        text : '哥布林种族技能，发动一次偷袭，造成3倍伤害。只能在怪物满血时使用。'
    }),
    '技能石：寻宝' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        weight : 0,
        func : function(){
            if(!checkRace('寻宝', true)){
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }

            const itemName = goods[data.worldIndex][Object.keys(goods[data.worldIndex]).getRandom()].getRandom();
            addItem(itemName,1);
            winMsg(`你找到了1个${itemName}`)
            return true;
        },
        text : '该技能已废弃。'
    }),
    '技能石：伪装求饶' : new Element({
        battleUse :true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        weight : 0,
        func : function(){
            if(!checkRace('伪装求饶', true)){
                return false;
            }
            if(data.battleMonster.hp < data.battleMonster.maxHp){
                winMsg('只能在怪物满血时使用', false, false);
                return false;
            }
            if(!confirm('是否确认使用伪装求饶？')){
                return false;
            }
            msg('对方无视了你，把你放走了');
            battleEnd();
            setTimeout(function(){timeLapses(battleRunMin);},100)
            return true;
        },
        text : '哥布林种族技能，伪装弱小的样子求饶，利用敌人对哥布林的蔑视，趁机逃走，只能在对方满血时使用。'
    }),
    '技能石：偷窃' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('偷窃', true)){
                return false;
            }

            //不同职阶的怪物需要多少偷窃技能石
            const typeMapping = {
                '精英' : 2,
                '传说' : 3,
                '神话' : 5,
            };

            //需要多少技能石
            const need = typeMapping[data.battleMonster.type] || 1;
            //获取拥有的技能石数量
            const had = getNumByBag('技能石：偷窃');

            if(need > had){
                winMsg(`技能石不足，需要${need}个`, false, false);
                return false;
            }
            reduceItem('技能石：偷窃', need - 1)


            const names = monsterCfgs[data.battleMonster.name].items.map(e => e.name).filter(e => !e.endsWith('神力精华'));
            const items = data.battleMonster.items.filter(e => names.indexOf(e.name) !== -1);
            const item = items.getRandom();
            if(item && randomNum(item.minNum, item.maxNum) > 0){
                addItem(item.name);
                item.minNum--;
                item.maxNum--;
                addBattleLog(`你使用了偷窃，偷到了1个${item.name}`)
            }else{
                addBattleLog(`你使用了偷窃，但是什么也没偷到`)
            }

            return true;
        },
        text : '哥布林种族技能，尝试偷取战斗对象的掉落物，普通怪物消耗1个技能石，精英2个，传说3个，神话5个。使用偷窃时会随机获取战斗对象其中一个掉落物（只能偷到图鉴里能看到怪物掉落的物品，偷不到神力精华、镶嵌物和变异核心等额外附加的物品），然后进行判定，偷取的成功率和该物品的爆率完全相同。如果偷取成功，该物品的掉落上限和下限都-1。该技能也会尝试偷取掉落上限已经变为0的物品，但是永远都偷不到'
    }),
    '技能石：神之手指' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('神之手指', true)){
                return false;
            }

            const names = monsterCfgs[data.battleMonster.name].items.map(e => e.name).filter(e => !e.endsWith('神力精华'));
            const items = data.battleMonster.items.filter(e => names.indexOf(e.name) !== -1).filter(e => e.maxNum > 0);
            if(items.length === 0){
                winMsg('目标身上已经没有任何物品了', false, false);
                return false;
            }

            const item = items.getRandom();
            const number = randomNum(1, item.maxNum);
            addItem(item.name, number);
            item.minNum -= number;
            item.maxNum -= number;
            addBattleLog(`你使用了神之手指，偷到了${number}个${item.name}`)

            return true;
        },
        text : '哥布林种族技能，偷取战斗对象随机一个掉落上限大于0掉落物，100%偷取成功。使用神之手指偷窃时会随机获取战斗对象其中一个掉落上限大于0的掉落物（只能偷到图鉴里能看到怪物掉落的物品，偷不到神力精华、镶嵌物和变异核心等额外附加的物品），然后进行随机偷取1~掉落上限个数的物品（例如随机到的某物品掉落原本为-80~100，那么就随机获得1-100个），然后该物品的掉落上限和下限都减少获得的个数的值。'
    }),
    '技能石：行商' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        gold : 0,
        func : function(){
            if(!checkRace('行商', true)){
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不能使用`, false, false);
                return false;
            }
            isGoblinExchange = true;
            renderGoblinExchange();
            $('.exchange').show();
            $('.item-use-win-modal').hide();
            $('.item-use-win').hide();
            return true;
        }, text : '哥布林-商人种族技能，打开一个哥布林-商人的专属次元商店页面，里面可以无限制购买本层所有的物品，且出售时以半价出售物品。'
    }),
    '技能石：金钱至上' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        gold : 0,
        func : function(){
            if(!checkRace('金钱至上', true)){
                return false;
            }
            const need = data.race.getLevelUpExp() - data.exp;
            if(!data.gold || data.gold < need){
                winMsg(`金币不足`, false, false);
                return false;
            }

            data.gold -= need;
            data.gold = parseFloat2Fiexd(data.gold);
            data.exp += need;
            level();

            return true;
        }, text : '哥布林-神壕种族技能，消耗金币代替经验，直接提升1级。'
    }),
    '技能石：抽刀' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('抽刀', true)){
                return false;
            }

            if(data.battleMonster.hp < data.battleMonster.maxHp){
                winMsg('只能在怪物满血时使用', false, false);
                return false;
            }

            return true;

        },
        myAtk : function(){
            if(!checkRace('抽刀')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 20)
        },
        text : '哥布林-卑劣者种族技能，假装没有武器，趁敌人不注意突然抽刀一击，造成20倍伤害。只能在怪物满血时使用。'
    }),
    '技能石：夺目' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('夺目', true)){
                return false;
            }

            const rate = data.level > data.battleMonster.level ? (data.level - data.battleMonster.level) * 5 : 0

            if(randomNum(1,100) <= 10 + rate){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被附加了目盲状态。`)
                addStatus(data.battleMonster, getStatus('目盲', {reduceHitRate : 70, num : 1, keep : true}));
            }

            return true;
        },
        myAtk : function(){
            if(!checkRace('夺目')){
                return 0;
            }

            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 0.8)
        },
        text : '哥布林-卑劣者种族技能，发起一次瞄准眼睛的攻击，造成0.8倍的伤害，有几率(基础概率10%，你每比对方高1级，概率提高5%)使对方陷入目盲状态，降低70%命中率，该状态不会自动消失。'
    }),
    '技能石：放血' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('放血', true)){
                return false;
            }
            if(randomNum(1,100) <= 10){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被附加了流血状态。`)
                let harm = parseInt(data.battleMonster.maxHp * 0.2);
                if(harm > data.level * 100){
                    harm = data.level * 100;
                }
                addStatus(data.battleMonster, getStatus('流血', {num : 1, harm}));
            }

            return true;
        },
        myAtk : function(){
            if(!checkRace('放血')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)))
        },
        text : '哥布林-卑劣者种族技能，发起一次瞄准血管的攻击，造成1倍的伤害，有10%几率使对方陷入流血状态，每回合损失对方最大生命值20%的血量，但是最多不能超过自己等级*100的血量，持续1回合。'
    }),
    '技能石：疯狂连击' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('疯狂连击', true)){
                return false;
            }
            if(randomNum(1,100) <= 30){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被附加了眩晕状态。`)
                addStatus(data.battleMonster, getStatus('眩晕'));
            }

            return true;
        },
        myAtk : function(){
            if(!checkRace('疯狂连击')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)))
        },
        text : '哥布林-恶徒种族技能，造成1倍的伤害，有30%几率使对方陷入眩晕状态，持续1回合。'
    }),

    //巨龙系列技能
    '技能石：龙威' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('龙威', true)){
                return false;
            }
            if(data.battleMonster.lw){
                winMsg('你已经使用过龙威了', false, false);
                return false;
            }

            data.battleMonster.lw = true;
            data.battleMonster.def -= data.atk;
            addBattleLog(`你使用了龙威，${data.battleMonster.showName || data.battleMonster.name}的防御力减少${data.atk}`)

            return true;
        },
        text : '巨龙种族技能，使战斗对象的防御力减少我方属性面板上攻击力的数值。每场战斗只能使用一次。'
    }),
    '技能石：烈焰' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        noSuck : true,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('烈焰', true)){
                return false;
            }
            addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被附加了燃烧状态。`)
            addStatus(data.battleMonster, getStatus('燃烧',{harm : parseInt(this.myAtk() * 0.3)}));

            return true;
        },
        myAtk : function(){
            if(!checkRace('烈焰')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 2)
        },
        text : '巨龙-红龙种族技能，造成2倍伤害，并有给怪物附加燃烧状态，每回合造成本次伤害30%的伤害，持续3回合。本技能无法触发吸血。'
    }),
    '技能石：凋零' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck :true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('凋零', true)){
                return false;
            }
            data.battleMonster.def -= 15;
            addBattleLog(`你使用了凋零，${data.battleMonster.showName || data.battleMonster.name}减少了15防御`)

            return true;
        },
        myAtk : function(){
            if(!checkRace('凋零')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1.5)
        },
        text : '巨龙-黑龙种族技能，造成1.5倍伤害，并减少怪物15防御力。本技能无法触发吸血。'
    }),
    '技能石：三色龙息' : new Element({
        onlyOne :true,
        isWeapon : true,
        noSuck :true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('三色龙息', true)){
                return false;
            }

            addStatus(data.battleMonster, getStatus('燃烧',{harm : parseInt(this.myAtk() * 0.3)}));
            data.battleMonster.def -= 15;
            let text = '';
            if(randomNum(1,100) <= 30){
                addStatus(data.battleMonster, getStatus('冰冻'));
                text += '，并且被冰冻了';
            }
            addBattleLog(`你使用了三色龙息，${data.battleMonster.showName || data.battleMonster.name}被附加了燃烧状态，减少了15防御${text}`)

            return true;
        },
        myAtk : function(){
            if(!checkRace('三色龙息')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1.5)
        },
        text : '巨龙-三头龙种族技能，造成1.5倍伤害，给怪物附加燃烧状态，每回合造成本次伤害30%的伤害，持续3回合，减少怪物15防御力，有30%几率使对面冰冻1回合。本技能无法触发吸血。'
    }),

    //亡灵族系列技能
    '技能石：提取肉' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        func : function(){
            if(!checkRace('提取肉', true)){
                return false;
            }

            const num = getNumByBag('肉');
            if(num >= 5){
                const getNum = parseInt(num / 5);
                reduceItem('肉', getNum * 5);
                addItem('灵魂碎片', getNum)
                return true;
            }else{
                const text = `无法使用提取肉，肉不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '亡灵族技能，消耗背包中所有肉，每消耗5个肉，提取出1个灵魂碎片。'
    }),
    '技能石：提取魔兽肉' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        func : function(){
            if(!checkRace('提取魔兽肉', true)){
                return false;
            }

            const num = getNumByBag('魔兽肉');
            if(num >= 5){
                const getNum = parseInt(num / 5);
                reduceItem('魔兽肉', getNum * 5);
                addItem('灵魂残骸', getNum)
                return true;
            }else{
                const text = `无法使用提取魔兽肉，魔兽肉不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '亡灵族技能，消耗背包中所有魔兽肉，每消耗5个魔兽肉，提取出1个灵魂残骸。'
    }),
    '技能石：提取亚龙肉' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        func : function(){
            if(!checkRace('提取亚龙肉', true)){
                return false;
            }

            const num = getNumByBag('亚龙肉');
            if(num >= 5){
                const getNum = parseInt(num / 5);
                reduceItem('亚龙肉', getNum * 5);
                addItem('残缺灵魂', getNum)
                return true;
            }else{
                const text = `无法使用提取亚龙肉，亚龙肉不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '亡灵族技能，消耗背包中所有亚龙肉，每消耗5个亚龙肉，提取出1个残缺灵魂。'
    }),
    '技能石：死魂灵' : new Element({
        canUse : true,
        voidDust : 0,
        func : function(){
            if(!checkRace('死魂灵', true)){
                return false;
            }
            if(data.soul < 100){
                winMsg('灵魂不足', false, false);
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }

            const monsterList = [];
            //获取怪物配置
            const mapName = data.map[data.location[1]][data.location[0]];//地图名
            const monsters = terrainElements[mapName] ? terrainElements[mapName].monster : {};
            //循环怪物配置
            for(let i = 0 ; i < 10 ; i++){
                for(const name in monsters){
                    const prob = monsters[name].prob;//出现概率
                    if(randomNum(1,100) <= prob){
                        if(monsters[name].level >= data.world.level[0] - (monsters[name].type ? 10 : 0) && monsters[name].level <= data.world.level[1] && !monsters[name].type && monsters[name].level <= data.level){
                            monsterList.push(`${name}`);
                        }
                    }
                }
            }

            data.soul -= 100;
            monsterList.forEach(e => {
                data.battleMonster = createBattleMonster(e);
                battleWin(true, 0, false);
            })
            winMsg(`你的死魂灵屠戮了${monsterList.length}个生灵`)

            return true;
        },
        text : '亡灵族种族技能，在副本中不可使用，消耗100点灵魂，对当前地形进行一次灵魂屠戮，将进行10次探索模拟，将其中模拟出现的等级不高于自己的普通怪物全部击杀，并获得击杀奖励。该技能杀死的怪物不会获得灵魂'
    }),

    //巫妖系列技能
    '技能石：巫妖学识' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('巫妖学识', true)){
                return false;
            }
            const needExp = parseInt(data.race.getLevelUpExp() * 0.2);
            if(data.exp >= 0){
                data.exp -= needExp;
                data.hp = data.maxHp;
                const text = `使用了巫妖学识，HP回满`;
                msg(text);
                addBattleLog(text)
                renderBag();
                return true;
            }else{
                const text = `无法使用巫妖学识，当前经验值为负数`;
                winMsg(text, false, false);
                return false;
            }

        },
        myHp : function(){
            return data.maxHp;
        },
        text : '巫妖种族技能，减少相当于本级别升级需要经验值20%的经验值，将血量回满。可以将经验值减为负数，但是经验为负数时无法使用该技能。'
    }),
    '技能石：灵魂打击' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        noSuck : true,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('灵魂打击', true)){
                return false;
            }
            const needExp = 10 + (data.level * 3);

            if(data.exp >= 0){
                data.exp -= needExp;
                if(data.race.name === '巫妖-死神' || data.race.name === '巫妖-死亡主宰'){
                    data.battleMonster.maxHp -= data.atk;
                    addObjHp(data.battleMonster, 0)
                }
                return true;
            }else{
                const text = `无法使用灵魂打击，当前经验值为负数`;
                winMsg(text, false, false);
                return false;
            }
        }, myAtk : function(){
            if(!checkRace('灵魂打击')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 2) + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0));
        },
        text : '巫妖种族技能，消耗10+等级*3的经验，进行一次2倍伤害且无视防御的攻击。可以将经验值减为负数，但是经验为负数时无法使用该技能。本技能无法触发吸血。'
    }),
    '技能石：制造命匣' : new Element({
        canUse : true,
        voidDust : 0,
        func : function(){
            if(data.bind){
                winMsg('你已经设置了复活标记了。', false, false);
                return false;
            }
            if(!checkRace('制造命匣', true)){
                return false;
            }

            if(data.attrPoint < 1){
                winMsg('属性点不足', false, false);
                return false;
            }

            data.attrPoint -= 1;
            if(!data.consumePoint){
                data.consumePoint = 0;
            }
            data.consumePoint += 1;

            data.bind = {
                index : data.worldIndex,
                location : data.location,
                race : '巫妖命匣'
            };
            winMsg('命匣安置成功！')
            return true;
        },
        text : '巫妖种族技能，消耗1点属性点，在当前位置安置一个命匣，死亡后在此处完美复活。消耗的属性点为永久消耗，不会以任何方式返还，复活后将显示为负数。命匣在跳周目时将被清空'
    }),
    '技能石：亡灵天灾' : new Element({
        canUse : true,
        voidDust : 0,
        func : function(){
            if(!checkRace('亡灵天灾', true)){
                return false;
            }
            if(data.soul < 200){
                winMsg('灵魂不足', false, false);
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }

            const monsterList = [];
            //获取怪物配置
            const mapName = data.map[data.location[1]][data.location[0]];//地图名
            const monsters = terrainElements[mapName] ? terrainElements[mapName].monster : {};
            //循环怪物配置
            for(let i = 0 ; i < 20 ; i++){
                for(const name in monsters){
                    const prob = monsters[name].prob;//出现概率
                    if(randomNum(1,100) <= prob){
                        if(monsters[name].level >= data.world.level[0] - (monsters[name].type ? 10 : 0) && monsters[name].level <= data.world.level[1] && (!monsters[name].type || monsters[name].type === '精英') && monsters[name].level <= data.level){
                            monsterList.push(`${name}`);
                        }
                    }
                }
            }

            data.soul -= 200;
            monsterList.forEach(e => {
                data.battleMonster = createBattleMonster(e);
                battleWin(true, 0, false);
            })
            winMsg(`你的亡灵天灾毁灭了${monsterList.length}个生灵`)

            return true;
        },
        text : '巫妖种族技能，在副本中不可使用，消耗200点灵魂，对当前地形发动一次亡灵天灾，将进行20次探索模拟，将其中模拟出现的等级不高于自己的普通和精英怪物全部击杀，并获得击杀奖励。该技能杀死的怪物不会获得灵魂'
    }),
    '技能石：灵魂屠戮' : new Element({
        canUse : true,
        voidDust : 0,
        func : function(){
            if(!checkRace('灵魂屠戮', true)){
                return false;
            }
            if(data.soul < 300){
                winMsg('灵魂不足', false, false);
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }

            const monsterList = [];
            //获取怪物配置
            const mapName = data.map[data.location[1]][data.location[0]];//地图名
            const monsters = terrainElements[mapName] ? terrainElements[mapName].monster : {};
            //循环怪物配置
            for(let i = 0 ; i < 20 ; i++){
                for(const name in monsters){
                    const prob = monsters[name].prob;//出现概率
                    if(randomNum(1,100) <= prob){
                        if(monsters[name].level >= data.world.level[0] - (monsters[name].type ? 10 : 0) && monsters[name].level <= data.world.level[1] && monsters[name].type !== '神话' && monsters[name].level <= data.level + 10){
                            monsterList.push(`${name}`);
                        }
                    }
                }
            }

            data.soul -= 300;
            const old = data.soul;
            monsterList.forEach(e => {
                data.battleMonster = createBattleMonster(e);
                battleWin(false, 0, false);
            })
            if(data.soul - old > 200){
                data.soul = old + 200;
            }
            winMsg(`你的灵魂屠戮毁灭了${monsterList.length}个生灵`)
            return true;
        },
        text : '巫妖-魂师种族技能，在副本中不可使用，消耗300点灵魂，对当前地形发动一次灵魂屠戮，将进行20次探索模拟，将其中模拟出现的等级不高于自己10级以上的除了神话怪物之外的所有怪物全部击杀，并获得击杀奖励。该技能杀死的怪物可以获得灵魂，但是一次性获取不超过200点。'
    }),
    '技能石：灵魂爆炸' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        noSuck : true,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('灵魂爆炸', true)){
                return false;
            }
            if(data.soul < 1){
                winMsg('灵魂不足', false, false);
                return false;
            }
            data.soul -= 1;

            if(randomNum(1,100) <= 30){
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}被附加了眩晕状态。`)
                addStatus(data.battleMonster, getStatus('眩晕'));
            }

            return true;
        }, myAtk : function(){
            if(!checkRace('灵魂爆炸')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 3) + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0));
        },
        text : '巫妖-灵魂主宰种族技能，消耗1灵魂，造成3倍伤害，无视防御，30%概率眩晕敌人1回合，无法触发吸血。'
    }),
    '技能石：灵魂提取' : new Element({
        battleUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('灵魂提取', true)){
                return false;
            }
            if(data.battleMonster.noOneKill){
                winMsg('该怪物免疫即死技能', false, false);
                return false;
            }
            if(data.level - data.battleMonster.level < 11){
                winMsg('只能对小于自己10级以上的怪物使用', false, false);
                return false;
            }

            const baseRate = data.battleMonster.type === '神话' ? 0 : data.battleMonster.type === '传说' ? 5 : data.battleMonster.type === '精英' ? 10 : 20;
            const getSoul = parseInt(data.battleMonster.type === '神话' ? data.battleMonster.level / 1 : data.battleMonster.type === '传说' ? data.battleMonster.level / 2 : data.battleMonster.type === '精英' ? data.battleMonster.level / 5 : data.battleMonster.level / 10);
            const addRate = parseInt((data.battleMonster.maxHp - data.battleMonster.hp) / data.battleMonster.maxHp * 100 / 5)

            if(randomNum(1,100) < baseRate + addRate){
                data.soul += getSoul;
                msg(`你使用灵魂提取，提取到了${getSoul}灵魂`)
                return 'win';
            }else{
                addBattleLog(`灵魂提取使用失败`)
            }

            return true;

        },
        text : '巫妖-死神种族技能，尝试提取对方的灵魂，基础成功率：神话0%，传说5%，精英10%，普通20%。对方血量每降低5%，成功率提高1%。提取成功时，敌方直接死亡，你获得对应的灵魂数量奖励：神话(怪物等级/1)，传说(怪物等级/2)，精英(怪物等级/5)，普通(怪物等级/10)。该技能只能对等级低于自己10级以上的对手使用（即80级的玩家，只能对最高69级的怪使用）。该技能无法对神使用'
    }),
    '技能石：灵魂收割' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('灵魂收割', true)){
                return false;
            }
            if(data.battleMonster.noOneKill){
                winMsg('该怪物免疫即死技能', false, false);
                return false;
            }
            const needSoul = parseInt(data.battleMonster.maxHp / 200);

            if(data.soul >= needSoul){
                data.soul -= needSoul;
                return 'win';
            }else{
                const text = `灵魂不足，需要${needSoul}个灵魂`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '巫妖-死神种族技能，直接收割敌人的灵魂，敌人最大生命之每有200点，就需要消耗1点灵魂。本技能无法触发吸血。该技能无法对神使用'
    }),

    //水之神裔系列技能
    '技能石：转换' : new Element({
        canUse :true,
        voidDust : 0,
        weight : 0,
        quality : 1,
        func : function(){
            if(!checkRace('转换', true)){
                return false;
            }

            if(data.water >= 100){
                data.water -= 100;
                data.hunger += 50;
                if(data.hunger > data.maxHunger){
                    data.hunger = data.maxHunger;
                }
                const text = `使用了转换，减少100水分，恢复50饥饿`;
                winMsg(text);
                return true;
            }else{
                const text = `无法使用转换，水分不足`;
                winMsg(text, false, false);
                return false;
            }

            return true;
        },
        text : '水之神裔种族技能，将100点水分转为50点饥饿。'
    }),
    '技能石：水疗术' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('水疗术', true)){
                return false;
            }

            const need = parseInt(data.maxWater * 0.1);
            if(data.water >= need){
                data.water -= need;
                let addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
                const text = `使用了水疗术，恢复${battleAddHp(data, addHp)}HP`;
                msg(text);
                addBattleLog(text)
                renderBag();
                return true;
            }else{
                const text = `无法使用水疗术，水分不足`;
                winMsg(text, false, false);
                return false;
            }

        },
        myHp : function(){
            return  parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1);
        },
        text : '水之神裔种族技能，消耗10%水分，恢复自身攻击力+武器攻击力的血量。'
    }),
    '技能石：水弹' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('水弹', true)){
                return false;
            }
            if(data.water < 30){
                winMsg('水分不足', false, false)
                return false;
            }
            data.water -= 30;
            return true;
        },
        myAtk : function(){
            if(!checkRace('水弹')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1.5)
        },
        text : '水之神裔种族技能，消耗30水分，造成人物攻击+武器攻击之和的1.5倍伤害。本技能无法触发吸血。'
    }),
    '技能石：水甲' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('水甲', true)){
                return false;
            }
            if(data.battleMonster.sj){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
            const need = parseInt(data.maxWater * 0.1);
            if(data.water < need){
                winMsg('水分不足', false, false)
                return false;
            }

            data.battleMonster.sj = true;
            data.water -= need;
            const addDef = data.level;
            data.def += addDef;
            addBattleLog(`使用了水甲，防御力增加${addDef}`)
            return true;
        },
        text : '水之神裔种族技能，消耗10%水分，提高等级*1的防御力，每场战斗只能使用一次'
    }),
    '技能石：花鸟风月' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('花鸟风月', true)){
                return false;
            }

            if(data.deitys['水之女神'].belief < 20){
                winMsg('信仰不足', false, false)
                return false;
            }

            data.deitys['水之女神'].belief -= 20;
            addObjWater(data, 1000)

            return true;
        },
        text : '水之神裔种族技能，消耗20对水之女神的信仰，获得1000水分。'
    }),
    '技能石：浓缩' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('浓缩', true)){
                return false;
            }

            const num = getNumByBag('水');
            const getNum = parseInt(num / 20);
            if(num >= 20){
                reduceItem('水', 20 * getNum);
                addItem('水之精华', getNum)
                return true;
            }else{
                const text = `无法使用浓缩，水不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '水之神裔种族技能，消耗背包中所有水，每消耗20个水，制造一个水之精华。不足20个的水将会保留在背包中，不会被消耗'
    }),
    '技能石：水之神罚' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('水之神罚', true)){
                return false;
            }
            if(data.battleMonster.noOneKill){
                winMsg('神罚技能不能对神使用', false, false);
                return false;
            }

            data.deitys['水之女神'].belief = 0;
            return true;
        },
        myAtk : function(){
            if(!checkRace('水之神罚')){
                return 0;
            }
            return data.deitys['水之女神'].belief * 50;
        },
        text : '该技能已废弃'
    }),
    '技能石：生生不息' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('生生不息', true)){
                return false;
            }

            let addHp = this.myHp ? this.myHp() : elementCfgs[this.name].myHp();
            let needWater = parseInt(addHp / 100) + (addHp % 100 === 0 ? 0 : 1);
            if(needWater > data.water){
                needWater = data.water;
                addHp = needWater * 100;
            }
            data.water -= needWater;

            const text = `使用了生生不息，消耗了${needWater}水分（剩余水分：${data.water}），恢复了${battleAddHp(data, addHp)}生命`;
            winMsg(text);
            addBattleLog(text)
            return true;
        },
        myHp(){
            return data.maxHp - data.hp;
        },
        text : '水之神裔-水法师种族技能，消耗水分值将生命补满，每恢复100点生命值消耗1点水分。如果剩余的水分值不足以补满生命值，则消耗所有水分，每消耗1点水分恢复100生命值。'
    }),
    '技能石：水龙术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('水龙术', true)){
                return false;
            }

            if(hasStatus(data, '念咒')){
                if(data.water < 300){
                    winMsg('水分不足', false, false)
                    return false;
                }
                data.water -= 300;
                if(getStatuNum(data, '强效') < 7){
                    addStatus(data, getStatus('强效'))
                }
                removeStatus(data, '念咒')

                addBattleLog(`你使用了水龙术，${data.battleMonster.showName || data.battleMonster.name}的防御降低了${data.level}点。`)
                return true;
            }else{
                if(data.water < 300){
                    winMsg('水分不足', false, false)
                    return false;
                }
                addStatus(data, getStatus('念咒'))
                addBattleLog('你开始念咒')
                monsterAtk();
                return false;
            }
        },
        myAtk : function(){
            if(!checkRace('水龙术')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * (3 + getStatuNum(data, '强效')))
        },
        text : '水之神裔-水法师种族技能，如果没有念咒状态，则增加1层念咒状态，否则消耗300水分，并清除念咒状态，造成人物攻击+武器攻击之和3倍的伤害，并给自己增加一层强效状态，每有1层强效状态，最高7层，伤害倍数增加1倍。本技能无法触发吸血。'
    }),
    '技能石：源水护盾' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('源水护盾', true)){
                return false;
            }

            if(hasStatus(data, '念咒')){
                if(data.water < data.level){
                    winMsg('水分不足', false, false)
                    return false;
                }
                data.water -= data.level;
                if(getStatuNum(data, '强效') < 7){
                    addStatus(data, getStatus('强效'))
                }
                removeStatus(data, '念咒')

                const addShield = data.level * (30 + (getStatuNum(data, '强效') * 10));
                data.shield += addShield;
                addBattleLog(`使用了源水护盾，获得${addShield}护盾`)
                return true;
            }else{
                if(data.water < data.level){
                    winMsg('水分不足', false, false)
                    return false;
                }
                addStatus(data, getStatus('念咒'))
                addBattleLog('你开始念咒')
                monsterAtk();
                return false;
            }
        },
        text : '水之神裔-水法师种族技能，如果没有念咒状态，则增加1层念咒状态，否则消耗相当于你等级的水分，获得消耗水分*30的护盾值，并给自己增加一层强效状态，每有1层强效状态，获得护盾的倍数增加10倍'
    }),
    '技能石：深海' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('深海', true)){
                return false;
            }
            if(data.battleMonster.sh){
                winMsg('对方已在深海之中', false, false)
                return false;
            }

            data.battleMonster.sh = true;
            addStatus(data.battleMonster, getStatus('深海', {harm : data.water, num : 1, keep : true}))
            data.water = 0;
            addBattleLog(`你将${data.battleMonster.showName || data.battleMonster.name}拉入了深海。`)
            return true;
        },
        text : '水之神裔-海皇种族技能，消耗所有水分，将对方拉入深海，附加深海状态，每回合受到相当于消耗水分值伤害，该状态不会自动消失，每场战斗只能使用一次。'
    }),
    '技能石：凝水成冰' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('凝水成冰', true)){
                return false;
            }

            const num = getNumByBag('水之精华');
            const getNum = parseInt(num / 5);
            if(num >= 5){
                reduceItem('水之精华', 5 * getNum);
                addItem('冰霜结晶', getNum)
                return true;
            }else{
                const text = `无法使用凝水成冰，水之精华不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '水之神裔-冰法师种族技能，消耗背包中所有水之精华，每消耗5个水之精华，制造一个冰霜结晶。不足5个的水之精华将会保留在背包中，不会被消耗'
    }),
    '技能石：冰棱柱' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        noSuck : true,
        weight : 5,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('冰棱柱', true)){
                return false;
            }

            const num = getNumByBag('冰霜结晶');
            if(num >= 1){
                reduceItem('冰霜结晶', 1);
                addStatus(data.battleMonster,  getStatus('刺骨', {num : 2,harm : parseInt(this.myAtk() / 2)}))
                return true;
            }else{
                const text = `冰霜结晶不足`;
                winMsg(text, false, false);
                return false;
            }

        },
        myAtk : function(){
            if(!checkRace('冰棱柱')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 2)
        },
        text : '水之神裔-冰法师种族技能，消耗1个冰霜结晶，造成人物攻击+武器攻击之和2倍的伤害，并附加刺骨效果，每回合造成本次伤害50%的伤害，持续2回合。本技能无法触发吸血。'
    }),
    '技能石：寒冰甲' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('寒冰甲', true)){
                return false;
            }
            if(data.battleMonster.hbj){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }

            const num = getNumByBag('冰霜结晶');
            if(num >= 2){
                data.battleMonster.hbj = true;
                reduceItem('冰霜结晶', 2);
                const addDef = parseInt(data.level * 1.5);
                data.def += addDef;
                addStatus(data, getStatus('冰霜护体', {returnHarm : data.level * 2, num : 1, keep : true}));
                addBattleLog(`你使用了寒冰甲，防御力增加${addDef}，并给自己附加了冰霜护体状态`)
                return true;
            }else{
                const text = `冰霜结晶不足`;
                winMsg(text, false, false);
                return false;
            }
            return true;
        },
        text : '水之神裔-冰法师种族技能，消耗2个冰霜结晶，提高等级*1.5的防御，并给自己附带冰霜护体状态，对攻击者造成相当于自己等级*2的伤害，该状态不会自动消失。每场战斗只能使用一次'
    }),
    '技能石：冰封千里' : new Element({
        canUse : true,
        voidDust : 0,
        func : function(){
            if(!checkRace('冰封千里', true)){
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }

            const num = getNumByBag('冰霜结晶');
            if(num >= 30){
                reduceItem('冰霜结晶', 30);

                const monsterList = [];
                //获取怪物配置
                const mapName = data.map[data.location[1]][data.location[0]];//地图名
                const monsters = terrainElements[mapName] ? terrainElements[mapName].monster : {};
                //循环怪物配置
                const atk = parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 20);
                for(let i = 0 ; i < 20 ; i++){
                    for(const name in monsters){
                        const prob = monsters[name].prob;//出现概率
                        if(randomNum(1,100) <= prob){
                            if(monsters[name].level >= data.world.level[0] - (monsters[name].type ? 10 : 0) && monsters[name].level <= data.world.level[1] && monsters[name].type !== '神话' && monsterCfgs[name].hp <= atk){
                                monsterList.push(`${name}`);
                            }
                        }
                    }
                }

                monsterList.forEach(e => {
                    data.battleMonster = createBattleMonster(e);
                    battleWin(true, 0, false);
                })
                winMsg(`你的冰封千里杀死了${monsterList.length}个怪物`)

                return true;
            }else{
                const text = `冰霜结晶不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '水之神裔-冰法师种族技能，在副本中不可使用，消耗30个冰霜结晶，对当前地形发动一次冰封千里，将进行10次探索模拟，将其中模拟出现的基础血量低于人物攻击+武器攻击之和20倍的非神话怪物全部杀死，并获得击杀奖励'
    }),
    '技能石：寒冰锻造' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('寒冰锻造', true)){
                return false;
            }

            const num = getNumByBag('冰霜结晶');
            if(num >= 100){
                reduceItem('冰霜结晶', 100);
                addItem('冰皇剑')
                return true;
            }else{
                const text = `冰霜结晶不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '水之神裔-冰皇种族技能，消耗100个冰霜结晶，锻造一把固定自带6孔的冰皇剑。'
    }),

    //狩猎神裔系列技能
    '技能石：永恒追猎' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('永恒追猎', true)){
                return false;
            }

            if(data.showMythDay === new Date(data.date).format('yyyyMMdd')){
                winMsg('今天你正在追猎。', false, false);
                return false;
            }
            data.showMythDay = new Date(data.date).format('yyyyMMdd');
            winMsg('追猎开始了！')
            //渲染可前往的地图
            renderCanToMap();
            //渲染地图
            renderMap();
            return true;
        },
        text : '狩猎神裔种族技能，显示当前地图的神话怪物位置，只持续到当天0点。'
    }),
    '技能石：荣耀追猎' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('荣耀追猎', true)){
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }

            const monsters = [];
            terrainArray[data.world.name].forEach(e => {
                Object.keys(terrainElements[e].monster).filter(m => terrainElements[e].monster[m].type === '精英' && (terrainElements[e].monster[m].level >= data.world.level[0] - 10 && terrainElements[e].monster[m].level <= data.world.level[1])).forEach(m => {
                    monsters.push(m);
                })
            })
            startBattle([...new Set(monsters)].getRandom(), true)
            return true;
        },
        text : '狩猎神裔种族技能，在副本中不可使用，触发和当前地图随机一个精英怪物的战斗。'
    }),
    '技能石：狩猎神罚' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('狩猎神罚', true)){
                return false;
            }
            if(data.deitys['狩猎之神'].belief < data.level){
                winMsg(`信仰不足`, false, false);
                return false;
            }

            data.deitys['狩猎之神'].belief -= data.level;
            return true;
        },
        myAtk : function(){
            if(!checkRace('狩猎神罚')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1) + (data.level * 30);
        },
        text : '狩猎神裔种族技能，消耗相当于你等级数值的对狩猎之神的信仰，每消耗1点信仰额外造成30伤害。本技能无法触发吸血。'
    }),
    '技能石：神话狙杀' : new Element({
        canUse :true,
        voidDust : 0,
        weight : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('神话狙杀', true)){
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }

            if(data.deitys['狩猎之神'].belief < 10){
                winMsg('信仰不足', false, false)
                return false;
            }

            const monsters = data.world.mythMonster.filter(e => !e.deathTime);
            if(monsters.length === 0){
                winMsg(`当前地图没有存活的神话怪`, false, false);
                return false;
            }


            data.deitys['狩猎之神'].belief -= 10;
            startBattle(monsters.getRandom().name, true, false, true)

            let atk = parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 10)
            const harm = data.battleMonster.maxHp / 2;
            if(atk < harm){
                atk = harm;
            }
            data.battleMonster.hp -= atk;

            addBattleLog(`你使用了神话狙杀，对${data.battleMonster.showName || data.battleMonster.name}造成了${atk}伤害`)
            addStatus(data.battleMonster, getStatus('封印',{num : 1, keep : true}))
            renderBattlePage();
            if(data.battleMonster.hp <= 0){
                battleWin();
            }

            return true;
        },
        text : '狩猎神裔种族技能，在副本中不可使用，消耗20对狩猎之神的信仰，触发和当前地图随机一个存活中的游荡（请特别注意游荡两个字）的神话怪物的战斗,并对其造成10倍普通攻击的伤害（最少造成其最大血量50%的伤害），该伤害不浮动，无视防御。并给怪物附加封印状态，该状态不会自动消失'
    }),
    '技能石：精英巢穴' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('精英巢穴', true)){
                return false;
            }
            addItem('位面坐标：精英');
            winMsg('获得位面坐标：精英')
            return true;
        },
        text : '狩猎神裔-追猎者种族技能，制造一个位面坐标：精英'
    }),
    '技能石：传说领地' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('传说领地', true)){
                return false;
            }
            addItem('位面坐标：传说');
            winMsg('获得位面坐标：传说')
            return true;
        },
        text : '狩猎神裔-追猎者种族技能，制造一个位面坐标：传说'
    }),
    '技能石：神甲锻造' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('神甲锻造', true)){
                return false;
            }

            const num = getNumByBag('神性结晶');
            if(num >= 10){
                reduceItem('神性结晶', 10);
                addItem('狩猎神甲')
                return true;
            }else{
                const text = `神性结晶不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '狩猎神裔-铠甲神匠技能，消耗10个神性结晶，锻造一件固定自带6孔的狩猎神甲。'
    }),

    //戏命师系列技能
    '技能石：探索命运' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('探索命运', true)){
                return false;
            }

            if(data.level - data.battleMonster.level > 10){
                winMsg('该技能只能对低于自己10级以内的怪物使用', false, false)
                return false;
            }

            let num = parseInt(data.level / 3);
            if(num < 5){
                num = 5;
            }
            data.def -= num;

            addItem('命运硬币', 1)
            addBattleLog(`你使用了探索命运，防御力-${num}，获得了1个命运硬币`)
            return true;

        },
        text : '戏命师种族技能，放弃防御，探索战斗对象的命运，自身防御力减少(等级/3，至少5)，获得一个命运硬币，该技能只能对低于自己10级以内的怪物使用。'
    }),
    '技能石：命运剥夺' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('命运剥夺', true)){
                return false;
            }

            const needHp = parseInt(data.maxHp * 0.1);
            if(data.hp <= needHp){
                winMsg('生命值不足', false, false)
                return false;
            }

            const atk = parseInt(parseInt(randomNum(needHp * 1, needHp * 100)) / 10);
            data.hp -= needHp;
            data.battleMonster.hp -= reduceShield(data.battleMonster, atk);
            addItem('命运硬币', 2)
            addBattleLog(`你使用了命运剥夺，对${data.battleMonster.showName || data.battleMonster.name}造成了${atk}伤害`)
            if(data.battleMonster.hp <= 0){
                return 'win';
            }
            return true;

        },
        text : '戏命师种族技能，献祭10%生命值，剥夺对方的命运，造成[献祭生命值*0.1~献祭生命值*10]的伤害，并获得2个命运硬币。此技能造成的伤害不受攻击浮动影响，无法吸血。'
    }),
    '技能石：命运转盘' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('命运转盘', true)){
                return false;
            }
            const num = getNumByBag('命运硬币');
            if(num < 2){
                winMsg('命运硬币不足', false, false)
                return false;
            }

            reduceItem('命运硬币')

            if(!data.consumePoint){
                data.consumePoint = 0;
            }

            const rate = randomNum(1,6);
            let text = ``;
            if(rate === 1){
                addItem('命运硬币', 2)
                text = `你获得了2个命运硬币`;
            }else if(rate === 2){
                reduceItem('命运硬币')
                text = `你失去了1个命运硬币`;
            }else if(rate === 3){
                data.attrPoint += 1;
                data.consumePoint -= 1;
                text = `你获得了1属性点`;
            }else if(rate === 4){
                data.attrPoint -= 1;
                data.consumePoint += 1;
                text = `你失去了1属性点`;
            }else if(rate === 5){
                if(getNumByBag('神性结晶') > 0){
                    addItem('神性结晶')
                    text = `你获得了1个神性结晶`;
                }else{
                    text = `你试图欺瞒命运，骗取神性结晶，但是什么也没得到`;
                }
            }else{
                if(getNumByBag('神性结晶') > 0){
                    reduceItem('神性结晶')
                    text = `你失去了1个神性结晶`;
                }else{
                    text = `你成功欺瞒了命运，没有神性结晶可以失去`;
                }
            }
            winMsg(text);
            return true;

        },
        text : '戏命师种族技能，身上至少有2个命运硬币时才能使用该技能。消耗1个命运硬币，转动命运转盘，获得下列随机效果之一：1.获得2个命运硬币；2.失去1个命运硬币；3.获得1属性点(洗点后依旧保留)；4.失去1属性点(洗点也无法找回)；5.获得1个神性结晶(获得该效果时，如果背包里没有神性结晶，则触发失败，什么也不会发生)；6.失去1个神性结晶(背包里没有则不会失去)。'
    }),
    '技能石：拨动命运' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('拨动命运', true)){
                return false;
            }
            const num = getNumByBag('命运硬币');
            if(num < 5){
                winMsg('命运硬币不足', false, false)
                return false;
            }
            if(data.battleMonster.changeFate){
                winMsg(`本场战斗的命运已经被拨动`, false, false)
                return false;
            }

            data.battleMonster.changeFate = true;
            const rate = randomNum(1,5);
            let text = ``;
            if(rate === 1){
                const number = parseInt(data.atk * 0.3);
                data.atk += number;
                text = `你的攻击力提高了${number}`;
            }else if(rate === 2){
                const number = parseInt(data.def * 0.3);
                data.def += number;
                text = `你的防御力提高了${number}`;
            }else if(rate === 3){
                const number = parseInt(data.battleMonster.atk * 0.3);
                data.battleMonster.atk -= number;
                text = `${data.battleMonster.showName || data.battleMonster.name}的攻击力降低了${number}`;
            }else if(rate === 4){
                const number = parseInt(data.battleMonster.def * 0.3);
                data.battleMonster.def -= number;
                text = `${data.battleMonster.showName || data.battleMonster.name}的防御力降低了${number}`;
            }else{
                const atkNum = parseInt(data.atk * 0.3);
                const defNum = parseInt(data.def * 0.3);
                data.atk -= atkNum;
                data.def -= defNum;
                text = `你的攻击力降低了${atkNum}，防御力降低了${defNum}`;
            }

            reduceItem('命运硬币', 5)
            addBattleLog(`你拨动了命运，${text}`)
            return true;

        },
        text : '戏命师种族技能，消耗5个命运硬币，随机造成以下效果之一：1.你的攻击提高30%；2.你的防御提高等级30%；3.对方攻击降低30%；4.对方防御降低30%；5.你的攻击和防御同时降低30%。本技能一场战斗只能使用一次。'
    }),
    '技能石：命运回溯' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('命运回溯', true)){
                return false;
            }
            const num = getNumByBag('命运硬币');
            if(num < 3){
                winMsg('命运硬币不足', false, false)
                return false;
            }

            reduceItem('命运硬币', 3)
            let addHp = this.myHp ? this.myHp() : elementCfgs[this.name].myHp();
            const text = `使用了命运回溯，恢复${battleAddHp(data, addHp)}HP`;
            msg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return randomNum(data.level * 1, data.level *20);
        },
        text : '戏命师种族技能，消耗3个命运硬币，恢复[等级*1~等级*20]的血量'
    }),
    '技能石：命运感知' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('命运感知', true)){
                return false;
            }
            showAllMap();
            winMsg('命运指引着你')
            return true;
        },
        text : '戏命师种族技能，直接点亮所有地图'
    }),
    '技能石：命运挽歌' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(data.bind){
                winMsg('你已经设置了复活标记了。', false, false);
                return false;
            }
            if(!checkRace('命运挽歌', true)){
                return false;
            }

            data.bind = {
                index : data.worldIndex,
                location : data.location,
                race : '命运挽歌'
            };
            winMsg('命运的挽歌在此响起，你戏弄了谁的命运？可曾想过你的命运或许只是一场游戏而已。');
            return true;
        },
        myHp : function(){
            return (data.atk + (data.weapon ? data.weapon.getAtk(data.weapon) : 0)) * 2;
        },
        text : '戏命师种族技能，使用后设置一个复活标记，当死亡时，如果随身携带有等级*5的命运硬币，则消耗这些硬币，并原地完美复活。复活一次后复活标记失效，需要重新使用命运挽歌。每复活一次，消耗的硬币数量翻倍（例如，10级复活需要50，复活后，20级再复活，就需要20 * 10 = 200了）'
    }),
    '技能石：命运操控' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('命运操控', true)){
                return false;
            }
            const num = getNumByBag('命运硬币');
            if(num < 1){
                winMsg('命运硬币不足', false, false)
                return false;
            }
            reduceItem('命运硬币', 1)
            return true;
        },
        myAtk : function(){
            if(!checkRace('命运操控')){
                return 0;
            }
            return data.battleMonster ? data.battleMonster.atk * 3 : 0
        },
        text : '戏命师-厄兆种族技能，消耗1个命运硬币，造成对方攻击力*3的伤害。该技能无法吸血'
    }),
    '技能石：恶兆之花' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('恶兆之花', true)){
                return false;
            }
            const num = getNumByBag('命运硬币');
            if(num < 10){
                winMsg('命运硬币不足', false, false)
                return false;
            }

            reduceItem('命运硬币', 10)
            addStatus(data.battleMonster, getStatus('厄运', {num : 1, keep : 1}))
            addBattleLog(`你使用了恶兆之花，给${data.battleMonster.showName || data.battleMonster.name}附加了厄运状态`);
            return true;

        },
        text : '戏命师-厄兆种族技能，消耗10个命运硬币，给对方附加厄运状态，命中率降低30%，该状态不会自动消失'
    }),
    '技能石：灾厄化身' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('灾厄化身', true)){
                return false;
            }
            const num = getNumByBag('命运硬币');
            if(num < 10){
                winMsg('命运硬币不足', false, false)
                return false;
            }

            reduceItem('命运硬币', 10)
            addStatus(data, getStatus('天灾', {returnHarm : data.level * 5, num : 1, keep : true}))
            addBattleLog(`你使用了灾厄化身，获得了天灾状态`);
            return true;

        },
        text : '戏命师-厄兆种族技能，消耗10个命运硬币，给自己附加天灾状态，怪物攻击你时将会受到相当于你等级*5的伤害，该状态不会自动消失'
    }),
    '技能石：同生共死' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('同生共死', true)){
                return false;
            }
            if(data.battleMonster.noOneKill){
                winMsg('该怪物免疫即死技能', false, false);
                return false;
            }
            if(!confirm('是否确认使用同生共死？')){
                return false;
            }
            data.hp = 0;
            return 'win';

        },
        text : '戏命师-厄兆种族技能，自身血量归0，直接杀死当前战斗对象。该技能无法对神和世界BOSS使用'
    }),
    '技能石：迷之蝶' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('迷之蝶', true)){
                return false;
            }
            addStatus(data.battleMonster, getStatus('迷之蝶', {num : 1, keep : true, reduceHitRate : 50}))
            addBattleLog(`你给${data.battleMonster.showName || data.battleMonster.name}附加了迷之蝶状态。`)
            return true;

        },
        text : '戏命师-迷雾种族技能，给怪物附加迷之蝶状态，命中率降低50%，该状态不会自动消失。'
    }),
    '技能石：命运之眼' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('命运之眼', true)){
                return false;
            }
            const num = getNumByBag('命运硬币');
            if(num < 1){
                winMsg('命运硬币不足', false, false)
                return false;
            }
            if(data.battleMonster.lookFate){
                winMsg(`${data.battleMonster.showName || data.battleMonster.name}的命运已经被你看破`, false, false)
                return false;
            }

            data.battleMonster.items.forEach(e => {
                if(e.name === '神话之力'){
                    return;
                }
                if(e.minNum < 0){
                    e.minNum = parseInt(e.minNum / 2);
                }else{
                    e.minNum += 1;
                    e.maxNum += 1;
                }
            });
            data.battleMonster.lookFate = true;
            reduceItem('命运硬币', 1)
            addBattleLog(`你窥探了${data.battleMonster.showName || data.battleMonster.name}的命运`)
            return true;

        },
        text : '戏命师-强运种族技能，消耗1个命运硬币，对方所有掉落物，如果最小掉落数量为负数，则最小掉落数量减半。如果最小掉落数量非负数，则最小掉落数量和最大掉落数量+1。该技能对一个怪物只能使用一次'
    }),
    '技能石：命运连线' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('命运连线', true)){
                return false;
            }
            const num = getNumByBag('命运硬币');
            if(num < 10){
                winMsg('命运硬币不足', false, false)
                return false;
            }
            if(data.battleMonster.fateLine){
                winMsg(`${data.battleMonster.showName || data.battleMonster.name}的命运直线已经被改动`, false, false)
                return false;
            }

            const addNum = getStatuNum(data, '春之歌')
            data.battleMonster.fateLine = true;
            reduceItem('命运硬币', 10)
            let round = parseInt(data.level / 5);
            if(round < 3){
                round = 3;
            }
            if(round > 6){
                round = 6;
            }
            round += addNum * 2;
            const noHarmSta = ['目盲','放血'];
            const stas = ['燃烧','流血', ...noHarmSta];
            stas.forEach(e => {
                addStatus(data.battleMonster, getStatus(e, {num : e === '冰冻' ? 2 : round, harm : noHarmSta.indexOf(e) === -1 ? data.level * (5 + addNum) : null}))
            })
            addStatus(data.battleMonster, getStatus('冰冻', {num : 2}))
            if(addNum > 1){
                addStatus(data.battleMonster, getStatus('封印', {num : parseInt(addNum / 2)}))
            }
            addBattleLog(`你直接操纵了命运之线，给${data.battleMonster.showName || data.battleMonster.name}附加了${stas.join('、')}状态`);
            removeStatus(data, '春之歌')
            return true;

        },
        text : '戏命师-强运种族技能，消耗10个命运硬币，给对方附加以下所有状态（燃烧，流血，目盲，放血），持续时间都是（等级/5，最低3，最高6，每有1层春之歌状态，额外增加2回合）回合，伤害都是每回合等级*5（只有燃烧和流血会造成伤害，每有一层春之歌状态，倍数+1），附加冰冻状态2回合，如果有春之歌状态，每有2层春之歌状态，给怪物添加1回合封印状态。每场战斗只能使用一次该技能，使用后消除春之歌状态'
    }),
    '技能石：春之歌' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('春之歌', true)){
                return false;
            }
            if(getNumByBag('命运硬币') < 5){
                winMsg('命运硬币不足', false, false)
                return false;
            }

            reduceItem('命运硬币', 5)
            addStatus(data, getStatus('春之歌', {num : 1, keep : true}))
            addBattleLog(`命运之歌已经奏响`)
            return true;

        },
        text : '戏命师-黑花种族技能，消耗5个命运硬币，给自己附加1层春之歌状态，该状态可叠加多层，该状态不会自动消失。每有一层春之歌状态，使用命运连线时会增加对应的持续时间和伤害'
    }),

    //机械族系列技能
    '技能石：超载攻击' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('超载攻击', true)){
                return false;
            }
            const needHp = data.level * 5;
            if(data.hp <= needHp){
                winMsg('生命值不足', false, false)
                return false;
            }

            data.hp -= needHp;
            addStatus(data,getStatus('超载', {num : 2}))
            return true;
        },
        myAtk : function(){
            if(!checkRace('超载攻击')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 5)
        },
        text : '机械族种族技能，造成一次5倍攻击，减少等级*5生命值，并给自己附加超载状态，接下来2个回合无法行动。'
    }),
    '技能石：紧急维修' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('紧急维修', true)){
                return false;
            }

            if(getNumByBag('机械碎片') < 1){
                winMsg('机械碎片不足', false, false)
                return false;
            }

            reduceItem('机械碎片')

            if(inBattle()){
                addStatus(data,getStatus('维修中'))
            }

            const text = `使用了紧急维修，恢复${battleAddHp(data, (this.myHp ? this.myHp() : elementCfgs[this.name].myHp()))}HP`;
            msg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return data.level * 20;
        },
        text : '机械族种族技能，消耗背包中一个机械碎片，恢复等级*20的血量，如果在战斗中，则给自己附加维修中状态，下回合无法行动。'
    }),
    '技能石：大维修' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('大维修', true)){
                return false;
            }

            if(getNumByBag('机械碎片') < 20){
                winMsg('机械碎片不足', false, false)
                return false;
            }

            if(getNumByBag('机械核心') < 1){
                winMsg('机械核心', false, false)
                return false;
            }

            reduceItem('机械碎片', 20)
            reduceItem('机械核心', 1)

            if(inBattle()){
                addStatus(data,getStatus('维修中', {num : 3}))
                addStatus(data,getStatus('火花', {returnHarm : data.level * 10}))
            }

            const text = `使用了大维修，恢复${battleAddHp(data, (this.myHp ? this.myHp() : elementCfgs[this.name].myHp()))}HP`;
            msg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return data.maxHp;
        },
        text : '机械族种族技能，消耗背包中20个机械碎片和1个机械核心，恢复所有血量，如果在战斗中，则给自己附加维修中状态，3个回合无法行动，并给自己附加火花状态，受到攻击时对攻击方造成等级*10的伤害，持续3回合。'
    }),
    '技能石：核心制造' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('核心制造', true)){
                return false;
            }

            if(getNumByBag('机械碎片') >= 50){
                reduceItem('机械碎片', 50);
                addItem('机械核心', 1)
                return true;
            }else{
                const text = `无法使用核心制造，机械碎片不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '机械族种族技能，消耗背包中50个机械碎片，制造一个机械核心。'
    }),
    '技能石：核心拆卸' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('核心拆卸', true)){
                return false;
            }

            if(getNumByBag('机械核心') >= 1){
                reduceItem('机械核心', 1);
                addItem('机械碎片', 20)
                return true;
            }else{
                const text = `无法使用核心制造，机械碎片不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '机械族种族技能，拆卸背包中1个机械核心，获得20个机械碎片。'
    }),
    '技能石：纳米装甲' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('纳米装甲', true)){
                return false;
            }
            if(data.battleMonster.nmzj){
                winMsg('你已经加装了纳米装甲', false, false)
                return false;
            }
            data.battleMonster.nmzj = true;

            const need = data.level;
            if(getNumByBag('机械碎片') < need){
                winMsg('机械碎片不足', false, false)
                return false;
            }

            reduceItem('机械碎片', need)

            data.def += need * 2;

            const text = `使用了纳米装甲，增加了${need * 2}防御力。`;
            addBattleLog(text)
            return true;
        },
        text : '机械族-装甲技能，消耗相当你等级的数量的机械碎片，每消耗1个机械碎片，增加2点防御力。该技能一场战斗只能使用一次。'
    }),
    '技能石：装甲涂层' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('装甲涂层', true)){
                return false;
            }
            if(!data.armor){
                winMsg('你没有穿戴护甲', false, false)
                return false;
            }
            if(data.armor.zjtc){
                winMsg('你穿戴的护甲已经附加了装甲涂层', false, false)
                return false;
            }
            const need = data.level;
            if(getNumByBag('机械碎片') < need){
                winMsg('机械碎片不足', false, false)
                return false;
            }

            const item = getBagItemById(data.armor.id);
            equip(item)
            item.zjtc = true;
            item.def += need;
            if(!item.defProp){
                item.defProp = 0;
            }
            item.defProp += parseInt(need / 10) * 0.01;
            item.defProp = parseFloat(item.defProp.toFixed(2));
            equip(item)

            reduceItem('机械碎片', need)

            const text = `你的护甲增加了装甲涂层`;
            winMsg(text)
            return true;
        },
        text : '机械族-装甲技能，消耗相当你等级的数量的机械碎片，给你当前装备的护甲增加防御力，每消耗1个机械碎片，增加1点防御力，每消耗10个机械碎片，增加1%减伤。一件装备只能附加1次装甲涂层。'
    }),
    '技能石：机械神降' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('机械神降', true)){
                return false;
            }
            if(data.battleMonster.jxsj){
                winMsg('你已经使用了机械神降', false, false)
                return false;
            }
            if(getNumByBag('机械核心') < 10){
                winMsg('机械核心不足', false, false)
                return false;
            }
            data.battleMonster.jxsj = true;

            data.atk += 500;
            data.def += 500;
            reduceItem('机械核心', 10)
            addBattleLog(`你使用了机械神降，攻击力和防御力提高500`)

            return true;
        },
        text : '机械族-机械神种族技能，消耗10个机械核心，攻击力和防御力提高500。一场战斗只能使用一次'
    }),
    '技能石：AT立场' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('AT立场', true)){
                return false;
            }
            if(data.shield){
                winMsg('拥有护盾时无法使用该技能', false, false)
                return false;
            }
            if(getNumByBag('机械核心') < 1){
                winMsg('机械核心不足', false, false)
                return false;
            }

            reduceItem('机械核心')
            data.shield += data.level * 30;
            addBattleLog(`你使用了AT立场，获得${data.level * 30}护盾`)

            return true;
        },
        text : '机械族-战斗种族技能，消耗1个机械核心，获得等级*30的护盾，在自己拥有护盾时无法使用该技能。'
    }),
    '技能石：暴走' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('暴走', true)){
                return false;
            }
            if(data.battleMonster.bz){
                winMsg('你正处于暴走状态', false, false)
                return false;
            }
            if(data.hp > data.maxHp * 0.15){
                winMsg('只能在生命之低于15%时使用', false, false)
                return false;
            }
            if(data.battleMonster.hp >= data.battleMonster.maxHp){
                winMsg('怪物满血时无法使用', false, false)
                return false;
            }

            data.battleMonster.bz = true;
            data.atk += data.level * 10;
            data.def += data.level * 10;
            data.shield += data.level * 300;
            addStatus(data, getStatus('暴走', {harm : data.level * 2, num : 1, keep : true}))
            addBattleLog(`你陷入了暴走状态`)

            return true;
        },
        text : '机械族-战斗种族技能，只能在生命值低于15%时使用，一场战斗只能使用一次，怪物满血时无法使用。攻击力和防御力增加等级*10，获得等级*300的护盾，给自己附加暴走状态，每回合受到等级*2的伤害，该状态不会自动消失。'
    }),
    '技能石：歼星' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        noSuck : true,
        quality : 1,
        preFunc : function(){
            if(!checkRace('歼星', true)){
                return false;
            }
            if(getNumByBag('机械核心') < 5){
                winMsg('机械核心不足', false, false)
                return false;
            }
            if(data.level < 2){
                winMsg('至少需要2级才能使用', false, false)
                return false;
            }

            data.level--;
            const reductDef = data.race.attrPoint + (diff === '新人难度' ? 2 : 0)
            data.def -= reductDef;
            data.selfAttrs.def -= reductDef;
            reduceItem('机械核心', 5)
            return true;
        },
        myAtk : function(){
            if(!checkRace('歼星')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 20)
        },
        text : '机械族-补全机种族技能，消耗5个机械核心，等级降低1级，防御力降低当前升1级获得的属性点对应的点数，造成一次20倍攻击，该技能无法触发吸血'
    }),

    //影魔系列技能
    '技能石：恶魔变身' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('恶魔变身', true)){
                return false;
            }
            if(data.battleMonster.embs){
                winMsg('你已经是恶魔形态了', false, false);
                return false;
            }
            if(getDayOrNight() !== '夜'){
                winMsg('当前时间不能使用', false, false)
                return false;
            }
            if(data.exp <= 0){
                winMsg('经验值不足', false, false);
                return false;
            }

            data.exp -= data.race.getLevelUpExp();
            if(!data.useEmbs){
                data.useEmbs = 0;
            }
            data.useEmbs++;
            data.battleMonster.embs = true;
            data.atk *= 3;
            data.def *= 3;
            data.hp *= 3;
            data.maxHp *= 3;

            addBattleLog(`你使用了恶魔变身，变为了恶魔形态，攻击力、防御力、当前血量和血量上限变为3倍`)
            return true;

        },
        text : '影魔种族技能，只能在夜晚使用，只能在经验值大于0时使用，变为恶魔形态，攻击力、防御力、当前血量和血量上限变为原本的3倍，减少当前等级需要的经验量的经验，可以减少为负数。每使用过1次，升级需要的经验倍数提高1（原本是等级的平方*10，使用1次后变为等级的平方*11，再使用一次变为等级的平方*12），跳周目后升级经验恢复正常'
    }),
    '技能石：暗影附加' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('暗影附加', true)){
                return false;
            }
            if(!data.weapon){
                winMsg('你没有装备武器', false, false)
                return false;
            }
            if(data.weapon.ayfj){
                winMsg('你穿戴的装备已经附加了暗影之力', false, false)
                return false;
            }

            const item = getBagItemById(data.weapon.id);
            equip(item)
            item.ayfj = true;
            item.atk += data.level;
            equip(item)

            const text = `使用了暗影附加，你装备的武器增加了${data.level}攻击力。`;
            winMsg(text)
            return true;
        },
        text : '影魔-暗影工匠种族技能，给你当前装备的武器附加暗影之力，增加你当前等级*1的攻击力，一件装备只能附加1次暗影之力。'
    }),
    '技能石：暗影锻造' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('暗影锻造', true)){
                return false;
            }
            if(getNumByBag('神性结晶') >= 1){
                reduceItem('神性结晶', 1);
                addItem('暗影匕首', 1)
                return true;
            }else{
                const text = `神性结晶不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '影魔-暗影工匠种族技能，抽取暗影之力，将神性结晶锻造为暗影匕首'
    }),
    '技能石：暗影神器' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('暗影神器', true)){
                return false;
            }
            if(getNumByBag('神格') >= 1){
                reduceItem('神格', 1);
                addItem('暗影神枪', 1)
                return true;
            }else{
                const text = `神格不足`;
                winMsg(text, false, false);
                return false;
            }
        },
        text : '影魔-暗影神匠种族技能，抽取暗影之力，将神格锻造为暗影神枪'
    }),
    '技能石：暗影融合' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('暗影融合', true)){
                return false;
            }

            if(getDayOrNight() !== '夜'){
                winMsg('当前时间不能使用', false, false)
                return false;
            }
            if(getStatuNum(data, '暗影') >= 13){
                winMsg('你已经和暗影融为一体了', false, false)
                return false;
            }

            if(inBattle()){
                addStatus(data, getStatus('暗影'))
            }
            battleAddHp(data, this.myHp ? this.myHp() : elementCfgs[this.name].myHp());

            const text = `使用了暗影融合，生命值完全恢复`;
            msg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            const hp = parseInt((data.maxHp * (1 - (getStatuNum(data, '暗影') * 0.08))).toFixed(0));
            return hp < 0 ? 0 : hp;
        },
        text : '影魔-暗影生物种族技能，只能在夜晚使用，恢复所有生命值。战斗中使用时为自己附加暗影状态，每有1层暗影状态，治疗量降低8%'
    }),
    '技能石：虚空低语' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('虚空低语', true)){
                return false;
            }
            if(data.battleMonster.xkdy){
                winMsg('对方已经被完全扭曲了', false, false);
                return false;
            }


            if(data.battleMonster.nqyj){
                data.battleMonster.nqyj++;
            }else{
                data.battleMonster.nqyj = 1;
            }

            if(randomNum(1,100) <= 10){
                data.battleMonster.xkdy = true;
                addStatus(data.battleMonster, getStatus('扭曲', {harm : 1000 * data.battleMonster.nqyj, keep : true}))
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}的心灵被完全扭曲了`)
            }else{
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}的心灵被略微扭曲了`)
            }

            return true;

        },
        text : '影魔-虚空大君种族技能，10%概率使用成功，使用无论是否成功，都会给对方附加1层扭曲印记（战斗中不可见，但是实际存在），成功时使怪物陷入扭曲状态，每回合受到扭曲印记*1000的伤害，该状态不会自动消失。当使用成功后，本场战斗不可再次使用该技能。'
    }),

    //扑克人系列技能
    '技能石：方片' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('方片', true)){
                return false;
            }
            if(data.battleMonster.poker === 8){
                winMsg('你的牌已达上限', false, false)
                return false;
            }

            if(data.battleMonster.noFirst && !(data.battleMonster.poker > 0)){
                winMsg('你的牌不足', false, false)
                return false;
            }

            data.battleMonster.poker--;

            //如果不是第一回合
            if(data.battleMonster.noFirst){
                let add = randomNum(1,10);
                add = parseInt(add * (hasStatus(data,'红王') ? 2 : hasStatus(data,'黑王') ? 0.5 : 1));
                data.battleMonster.poker += add;
                if(data.battleMonster.poker > 8){
                    data.battleMonster.poker = 8;
                }
                addBattleLog(`你使用了方片，获得了${add}张牌`)
            }else{
                data.battleMonster.poker = 8;
                data.battleMonster.noFirst = true;
                addBattleLog(`你使用了方片，你的牌补满为8张了`)
            }

            return true;
        },
        text : '扑克人种族技能，消耗一张牌（如果是没使用过方片或者重置时不用消耗牌），随机获取1-10张牌（最多持有8张，仅本次战斗可用，如果是没使用过方片或者重置，不随机，直接补满8张）'
    }),
    '技能石：梅花' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('梅花', true)){
                return false;
            }
            if(!(data.battleMonster.poker > 0)){
                winMsg('你的牌不足', false, false)
                return false;
            }
            if(data.battleMonster.poker === 1 && !confirm('你只剩最后一张牌了，确认使用梅花而不是方片吗？')){
                return false;
            }
            data.battleMonster.poker--;

            return true;
        },
        myAtk : function(){
            if(!checkRace('梅花')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0))) + parseInt(data.level * randomNum(1,10) * (hasStatus(data,'黑王') ? 2 : hasStatus(data,'红王') ? 0.5 : 1));
        },
        text : '扑克人种族技能，消耗一张牌，额外增加等级*（随机1-10）的伤害。'
    }),
    '技能石：黑桃' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('黑桃', true)){
                return false;
            }
            if(!(data.battleMonster.poker > 0)){
                winMsg('你的牌不足', false, false)
                return false;
            }
            if(data.battleMonster.ht){
                winMsg('你已经使用过黑桃了', false, false);
                return false;
            }
            if(data.battleMonster.poker === 1 && !confirm('你只剩最后一张牌了，确认使用黑桃而不是方片吗？')){
                return false;
            }

            data.battleMonster.ht = true;
            data.battleMonster.poker--;
            let add = (parseInt(data.level / 10) + 1) * (randomNum(1, 10));
            add = parseInt(add * (hasStatus(data,'黑王') ? 2 : hasStatus(data,'红王') ? 0.5 : 1))
            data.def += add;

            addBattleLog(`你使用了黑桃，增加了${add}防御`)
            return true;
        },
        text : '扑克人种族技能，消耗一张牌，增加(等级/10 + 1)*(随机1-10)的防御，每场战斗只能使用一次'
    }),
    '技能石：红桃' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('红桃', true)){
                return false;
            }
            if(!(data.battleMonster.poker > 0)){
                winMsg('你的牌不足', false, false)
                return false;
            }
            if(data.battleMonster.poker === 1 && !confirm('你只剩最后一张牌了，确认使用红桃而不是方片吗？')){
                return false;
            }

            data.battleMonster.poker--;
            let add = parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0))) + parseInt(data.level / 2 * randomNum(1,10));
            add = parseInt(add * (hasStatus(data,'红王') ? 2 : hasStatus(data,'黑王') ? 0.5 : 1))

            addBattleLog(`你使用了红桃，恢复了${battleAddHp(data,add)}血量`)
            return true;
        },
        text : '扑克人种族技能，消耗一张牌，治疗基础攻击力+武器攻击力 + 等级/2*(随机1-10)的血量'
    }),
    '技能石：重置' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('重置', true)){
                return false;
            }
            if(data.battleMonster.cz >= 2){
                winMsg('一场战斗只能使用2次', false, false)
                return false;
            }

            if(data.battleMonster.cz){
                data.battleMonster.cz++;
            }else{
                data.battleMonster.cz = 1;
            }
            data.battleMonster.noFirst = true;

            data.battleMonster.poker = 8;
            addBattleLog(`你使用了重置，你的牌补满了8张`)
            return true;
        },
        text : '扑克人一次觉醒通用种族技能，将牌补满8张，一场战斗只能使用2次'
    }),
    '技能石：连击' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('连击', true)){
                return false;
            }
            if(!(data.battleMonster.poker > 0)){
                winMsg('你的牌不足', false, false)
                return false;
            }

            const suits = ['红桃','黑桃','梅花','方片'];
            let point = randomNum(1,10);
            let text = `你抽出了${point}点，`;
            let cardNum = parseInt(10/point);
            if(cardNum > 4){
                cardNum = 4;
            }
            if(cardNum > data.battleMonster.poker){
                cardNum = data.battleMonster.poker;
            }
            point *= cardNum;
            text += `你消耗了${cardNum}张牌，`
            data.battleMonster.poker -= cardNum;

            suits.derangedArray();
            const useSuits = suits.slice(0,cardNum);

            useSuits.forEach(e => {
                if(e === '红桃'){
                    const add = parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0))) + parseInt(data.level / 2 * point);
                    text += `你触发了红桃，恢复了${battleAddHp(data,add)}血量，`;
                }
                if(e === '黑桃'){
                    let add = (parseInt(data.level / 10) + 1) * (randomNum(1, 10));

                    if(data.battleMonster.ht){
                        data.shield += add * 10;
                        text += `你触发了黑桃，获得了${add * 10}护盾，`
                    }else{
                        data.def += add;
                        data.battleMonster.ht = true;
                        text += `你触发了黑桃，增加了${add}防御，`
                    }
                }
                if(e === '梅花'){
                    const atk = parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0))) + (data.level * point)
                    data.battleMonster.hp -= atk;
                    text += `你触发了梅花，对${data.battleMonster.showName || data.battleMonster.name}造成${atk}点伤害，`
                }
                if(e === '方片'){
                    const add = point;
                    data.battleMonster.poker += add;
                    if(data.battleMonster.poker > 8){
                        data.battleMonster.poker = 8;
                    }
                    text += `你触发了方片，获得了${add}张牌，`
                }
            })

            addBattleLog(text + `漂亮的${cardNum}连击`)


            if(data.battleMonster.hp <= 0){
                return 'win';
            }

            return true;
        },
        text : '扑克人-游侠种族技能，随机1-10的一个数字，如果是1或2，点数视为随机出数字的4倍，消耗4张牌，同时触发4个花色的效果（如果已经获得过黑桃增加的防御，那么连击触发的黑桃效果变为获得本应增加的防御力*10的护盾）。如果是3，则视为9点，消耗3张牌，随机触发3个花色的效果，如果是4或5，则视为双倍点数，随机触发2个花色的效果，6-10则随机触发一个花色的效果，随机出的数字则为点数。当出现持有的牌数不足支付需要消耗的数量时，则消耗所有的牌，点数视为消耗的牌的倍数，随机触发消耗的牌同等数量的花色效果。该技能触发的梅花效果不进行波动，无视防御，无法触发吸血。'
    }),
    '技能石：开天' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        noSuck : true,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('开天', true)){
                return false;
            }
            if(!data.battleMonster.poker){
                data.battleMonster.poker = 0;
            }
            if(data.battleMonster.poker < 2){
                winMsg('你的牌不足', false, false)
                return false;
            }
            data.battleMonster.poker -= 2;

            return true;
        },
        myAtk : function(){
            if(!checkRace('开天')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0))) + parseInt(data.level * randomNum(1,10) * randomNum(1,10) * (hasStatus(data,'黑王') ? 2 : hasStatus(data,'红王') ? 0.5 : 1));
        },
        text : '扑克人-剑神种族技能，消耗2张牌，将牌飞出，用后一张牌击中前一张牌，获得二次爆发，额外增加等级*（随机1-10）*（随机1-10）的伤害。该技能无法触发吸血'
    }),
    '技能石：红王' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('红王', true)){
                return false;
            }
            if(getStatuNum(data, '红王') > 0){
                winMsg('你已经是红王状态了', false, false)
                return false;
            }

            if(data.battleMonster.hp === data.battleMonster.maxHp){
                data.battleMonster.poker = 8;
                addBattleLog(`你的牌补满了8张`)
            }
            removeStatus(data,'黑王')
            addStatus(data,getStatus('红王', {keep : true}))

            return true;
        },
        text : '扑克人-反王种族技能，给自己附加红王状态，红桃和方片效果翻倍，黑桃和梅花效果减半，该状态不会自动消失，如果有黑王状态则会解除黑王状态，如果怪物是满血，则补满8张牌'
    }),
    '技能石：黑王' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('黑王', true)){
                return false;
            }
            if(getStatuNum(data, '黑王') > 0){
                winMsg('你已经是黑王状态了', false, false)
                return false;
            }

            if(data.battleMonster.hp === data.battleMonster.maxHp){
                data.battleMonster.poker = 8;
                addBattleLog(`你的牌补满了8张`)
            }
            removeStatus(data,'红王')
            addStatus(data,getStatus('黑王', {keep : true}))

            return true;
        },
        text : '扑克人-反王种族技能，给自己附加黑王状态，黑桃和梅花效果翻倍，红桃和方片效果减半，该状态不会自动消失，如果有红王状态则会解除红王状态，如果怪物是满血，则补满8张牌'
    }),
    '技能石：全王' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('全王', true)){
                return false;
            }
            if(getStatuNum(data, '红王') > 0 && getStatuNum(data, '黑王') > 0){
                winMsg('你已经是全王状态了', false, false)
                return false;
            }

            if(data.battleMonster.hp === data.battleMonster.maxHp){
                data.battleMonster.poker = 8;
                addBattleLog(`你的牌补满了8张`)
            }
            addStatus(data,getStatus('红王', {keep : true}))
            addStatus(data,getStatus('黑王', {keep : true}))

            return true;
        },
        text : '扑克人-全王种族技能，给自己同时附加红王和黑王状态，所有花色效果翻倍，该状态不会自动消失，如果怪物是满血，则补满8张牌'
    }),
    '技能石：先祖附魔' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('先祖附魔', true)){
                return false;
            }
            $('.patriarch-enchant').show();
            renderPatriarchEnchant();
            return true;
        },
        text : '蜥蜴人种族技能，可进行先祖附魔。'
    }),
    '技能石：先祖狂暴' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('先祖狂暴', true)){
                return false;
            }
            if(data.battleMonster.xzkb){
                winMsg('你已经处于先祖狂暴状态', false, false)
                return false;
            }
            data.battleMonster.xzkb = true;

            const atk = parseInt(((data.patriarchEnchantWeapon ? data.patriarchEnchantWeapon.atk || 0 : 0) + (data.patriarchEnchantArmor ? data.patriarchEnchantArmor.atk || 0 : 0)) * 0.5);
            const def = parseInt(((data.patriarchEnchantWeapon ? data.patriarchEnchantWeapon.def || 0 : 0) + (data.patriarchEnchantArmor ? data.patriarchEnchantArmor.def || 0 : 0)) * 0.5);

            data.atk += atk;
            data.def += def;

            addBattleLog(`你使用了先祖狂暴，攻击增加${atk}，防御增加${def}`)

            return true;
        },
        text : '蜥蜴人-先祖战士种族技能，利爪附魔和鳞片附魔提供的攻击和防御提高50%，每场战斗只能使用1次'
    }),
    '技能石：制造传承药剂' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('制造传承药剂', true)){
                return false;
            }

            if(getNumByBag('魔蛟心脉精华') < 5){
                winMsg('魔蛟心脉精华不足', false, false)
                return false;
            }

            if(getNumByBag('神性结晶') < 1){
                winMsg('神性结晶不足', false, false)
                return false;
            }

            reduceItem('魔蛟心脉精华', 5);
            reduceItem('神性结晶', 1);
            addItem('传承药剂', 1)

            return true;
        },
        text : '蜥蜴人-巫医种族技能，使用5个魔蛟心脉精华和1个神性结晶，制造1个传承药剂。'
    }),
    '技能石：幽灵虫' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('幽灵虫', true)){
                return false;
            }

            if(!data.battleMonster.ylc){
                data.battleMonster.ylc = 0;
            }
            data.battleMonster.ylc++;

            addStatus(data.battleMonster, getStatus('幽灵虫', {harm : data.battleMonster.ylc * 200,num : 10}));
            addBattleLog(`你召唤了1只幽灵虫`)

            return true;
        },
        text : '蜥蜴人-巫祖种族技能，召唤1只幽灵虫啃食对方的灵魂，幽灵虫每回合造成200伤害，每召唤1只幽灵虫，伤害增加200，持续10回合，每召唤1只幽灵虫，持续回合数增加10回合。'
    }),
    '技能石：抽取血液' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('抽取血液', true)){
                return false;
            }
            if(data.battleMonster.noOneKill){
                winMsg('不能对神和世界BOSS使用', false, false);
                return false;
            }
            if(data.inDungeon){
                winMsg('不能在副本中使用', false, false);
                return false;
            }
            if(data.battleMonster.hp < data.battleMonster.maxHp * 0.05){
                const name = '血液库存';
                const item = elementCfgs[name].new({name, quantity : 1});
                item.monster = data.battleMonster;
                item.showName = `血液：${item.monster.name}`;
                data.bag.push(item)
                msg(`抽取血液成功`);
                battleWin();
            }else{
                winMsg('怪物血量低于5%时才能使用')
            }

            return true;
        },
        text : '吸血鬼-刀锋战士种族技能，只能在怪物血量低于5%时使用，将怪物血液吸干，并储存起来。不能对神（是神，不是神话，具体看图鉴-说明-神）和世界BOSS使用，不能在副本中使用'
    }),
    '技能石：经验提取器' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('经验提取器', true)){
                return false;
            }
            $('.exp-extract').show();
            renderExpExtract();
            return true;
        },
        text : '已废弃'
    }),
    '技能石：超度' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('超度', true)){
                return false;
            }
            data.battleMonster.maxHp -= data.atk + data.def;
            addObjHp(data.battleMonster, 0)
            addBattleLog(`恭请南无大慈大悲地藏王菩萨慈悲护持`)
            if(data.battleMonster.maxHp <= 0){
                if(data.level - data.battleMonster.level < 10){
                    data.merit += data.level > data.battleMonster.level ? 1 : 3;
                    msg(`你超度了${data.battleMonster.showName || data.battleMonster.name}`);
                }
                battleWin();
            }

            return true;
        },
        text : '地球人-佛门种族技能，降低怪物相当于你自身攻击力+防御力的血量上限，当怪物血量上限小于等于0时，则完成超度。超度和比你等级小10级以内的怪物会获得1功德，超度等级大于等于你的怪物会获得3功德。'
    }),
    '技能石：无量法相' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('无量法相', true)){
                return false;
            }
            if(data.battleMonster.wlfx){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }

            data.battleMonster.wlfx = true;
            let addNum = data.merit > 0 ? parseInt(data.merit / 100) + (data.karma || 0) : 0;
            addNum = addNum > 20 ? 20 : addNum;
            data.reduceHart += 0.01 * addNum;
            const text = `使用了无量法相，增加${addNum}%减伤`;
            addBattleLog(text)
            return true;
        },
        text : '地球人-佛门种族技能，每有100功德或1善业，增加1%减伤，最多增加20%，每场战斗只能使用一次'
    }),
    '技能石：轮回' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('轮回', true)){
                return false;
            }
            if(data.level < 20){
                winMsg('等级不足',false,false)
                return false;
            }

            const num = data.level - 1;
            data.level = 1;
            data.merit += num;
            initAttr();
            if(data.weapon && data.weapon.level > data.level){
                equip(data.weapon)
            }
            if(data.armor && data.armor.level > data.level){
                equip(data.armor)
            }
            return true;
        },
        text : '地球人-佛门种族技能，20级以上才能使用，将等级变为1级，自动进行一次洗点。该技能每导致你降低了1级，获得1点功德。'
    }),
    '技能石：功德无量' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('功德无量', true)){
                return false;
            }
            if(data.merit < 100){
                winMsg('功德不足',false,false)
                return false;
            }

            data.merit -= 100;
            data.karma++;
            addObjHp(data, data.maxHp);
            addObjHunger(data, data.maxHunger);
            addObjWater(data, data.maxWater);
            addObjSan(data, data.maxSan);
            data.def++;
            return true;
        },
        text : '地球人-佛门种族技能，消耗100功德，将生命、饥饿、水分、理智全部回满，并增加1点防御力，该技能获得的防御力洗点后消失，使用该技能会获得1点善业。'
    }),
    '技能石：功德圆满' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('功德圆满', true)){
                return false;
            }
            if(diff === '硬核难度' || diff === '扩展难度'){
                winMsg('硬核难度无法使用该技能！', false, false);
                return false;
            }
            if(data.level < 90){
                winMsg('至少90级才可以使用！', false, false);
                return false;
            }
            if(data.karma < 200){
                winMsg('善业不足',false,false)
                return false;
            }
            if(getNumByBag('神格') < 1){
                winMsg('你需要神格来感悟',false,false)
                return false;
            }

            talentAwakening('地球人-活佛', 90);
            winMsg('恭喜你完成了二次觉醒！');
            return true;
        },
        text : '地球人-佛门种族技能，至少90级，且拥有200善业时才能使用，使用时需要背包中至少有1个神格，但是使用该技能不会消耗这个神格，仅用于感悟。使用后种族变为：地球人-活佛，等级变为90级，并自动进行一次洗点。硬核难度无法使用该技能'
    }),
    '技能石：天剑' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        noSuck : true,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('天剑', true)){
                return false;
            }
            const filter = data.bag.filter(e => e.name === '天剑' && e.endurance > 0);
            if(filter.length === 0){
                winMsg('你的身上没有携带耐久度足够的天剑', false, false)
                return false;
            }
            reduceItemEndurance(filter[0], 1);
            addStatus(data.battleMonster, getStatus('天剑'));
            if(hasStatus(data, '神游')){
                addStatus(data.battleMonster, getStatus('雷剑'));
            }

            return true;
        },
        myAtk : function(){
            if(!checkRace('天剑')){
                return 0;
            }
            return parseInt(data.atk * 3) * (hasStatus(data, '蔷薇') ? 2 : 1);
        },
        text : '地球人-蜀山种族技能，必须背包中有天剑才能使用。消耗天剑1点耐久度，发起一次相当于本人攻击力（不包含武器攻击力，但算入护甲攻击力）*3的攻击，并给怪物附加天剑状态，持续10回合。该技能无法触发吸血'
    }),
    '技能石：雷剑' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        noSuck : true,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('雷剑', true)){
                return false;
            }
            const filter = data.bag.filter(e => e.name === '雷剑' && e.endurance > 0);
            if(filter.length === 0){
                winMsg('你的身上没有携带耐久度足够的雷剑', false, false)
                return false;
            }
            reduceItemEndurance(filter[0], 1);
            addStatus(data.battleMonster, getStatus('雷剑'));
            if(hasStatus(data, '神游')){
                addStatus(data.battleMonster, getStatus('天剑'));
            }

            return true;
        },
        myAtk : function(){
            if(!checkRace('雷剑')){
                return 0;
            }
            return parseInt(data.atk * 3) * (hasStatus(data, '蔷薇') ? 2 : 1);
        },
        text : '地球人-蜀山种族技能，必须背包中有雷剑才能使用。消耗雷剑1点耐久度，发起一次相当于本人攻击力（不包含武器攻击力，但算入护甲攻击力）*3的攻击，并给怪物附加雷剑状态，持续10回合。该技能无法触发吸血'
    }),
    '技能石：天雷合并' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        noSuck : true,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        preFunc : function(){
            if(!checkRace('天雷合并', true)){
                return false;
            }
            const lei = data.bag.filter(e => e.name === '雷剑' && e.endurance >= 10);
            if(lei.length === 0){
                winMsg('你的身上没有携带耐久度足够的雷剑', false, false)
                return false;
            }
            const tian = data.bag.filter(e => e.name === '天剑' && e.endurance >= 10);
            if(tian.length === 0){
                winMsg('你的身上没有携带耐久度足够的天剑', false, false)
                return false;
            }
            if(!hasStatus(data.battleMonster, '天剑') || !hasStatus(data.battleMonster, '雷剑')){
                winMsg('怪物身上必须同时有天剑和雷剑状态', false, false)
                return false;
            }
            reduceItemEndurance(lei[0], 10);
            reduceItemEndurance(tian[0], 10);
            removeStatus(data.battleMonster, '雷剑');
            removeStatus(data.battleMonster, '天剑');

            return true;
        },
        myAtk : function(){
            if(!checkRace('天雷合并')){
                return 0;
            }
            return parseInt(data.atk * 10) * (hasStatus(data, '蔷薇') ? 2 : 1);
        },
        text : '地球人-蜀山种族技能，必须背包中同时有至少10点耐久的天剑和雷剑，且怪物身上有天剑和雷剑状态时才能使用。消耗天剑和雷剑10点耐久度，发起一次相当于本人攻击力（不包含武器攻击力，但算入护甲攻击力）*10的攻击，并消除怪物身上的天剑和雷剑状态。该技能无法触发吸血'
    }),
    '技能石：昊天镜' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('昊天镜', true)){
                return false;
            }
            const filter = data.bag.filter(e => e.name === '昊天镜' && e.endurance > 0);
            if(filter.length === 0){
                winMsg('你的身上没有携带耐久度足够的昊天镜', false, false)
                return false;
            }
            reduceItemEndurance(filter[0], 1);
            addStatus(data.battleMonster, getStatus('昊天镜', {harm : parseInt(data.atk * 2) * (hasStatus(data, '临江') ? 2 : 1), keep : true}));
            addBattleLog(`昊!天!镜!`)

            return true;
        },
        text : '地球人-蜀山种族技能，必须背包中有昊天镜才能使用。减少1点昊天镜的耐久，给怪物附加昊天镜状态，每回合减少相当于本人攻击力（不包含武器攻击力，但算入护甲攻击力）*2的血量，该状态不会自动消失。'
    }),
    '技能石：日金轮' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        func : function(){
            if(!checkRace('日金轮', true)){
                return false;
            }
            if(data.battleMonster.rjl){
                winMsg('每场战斗只能使用一次',false,false)
                return false;
            }
            const filter = data.bag.filter(e => e.name === '日金轮' && e.endurance > 0);
            if(filter.length === 0){
                winMsg('你的身上没有携带耐久度足够的日金轮', false, false)
                return false;
            }
            data.battleMonster.rjl = true;
            reduceItemEndurance(filter[0], 1);

            data.reduceHart += 0.2 +  (hasStatus(data, '临江') ? 0.1 : 0);
            const text = `使用了日金轮，增加20%减伤`;
            addBattleLog(text)

            return true;
        },
        text : '地球人-蜀山种族技能，必须背包中有日金轮才能使用。减少1点日金轮的耐久，增加20%的减伤。该技能每场战斗只能使用1次。'
    }),
    '技能石：月金轮' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        func : function(){
            if(!checkRace('月金轮', true)){
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }
            const filter = data.bag.filter(e => e.name === '月金轮');
            if(filter.length === 0){
                winMsg('你的身上没有携带月金轮', false, false)
                return false;
            }

            let monsterList = [
                ...data.world.mapElements[data.location.join()].monsterList,
            ];
            if(!data.inDungeon){
                const mapName = data.map[data.location[1]][data.location[0]];//地图名
                const point = data.location.join();//坐标
                monsterList = [
                    ...monsterList,
                    ...data.world.mythMonster.filter(e => e.location.join() === point && !e.deathTime).map(e => e.name),
                ];
                if(mapCfgs[data.worldIndex].endTerrain === mapName){
                    const name = mapCfgs[data.worldIndex].endBoss;
                    monsterList.push(name);
                }
                if(data.nextPoint && point === data.nextPoint.join()){
                    if(!data.world.pass){
                        monsterList.push(data.world.worldBoss);
                    }
                }
            }

            monsterList = monsterList.filter(e => data.zhc ? true : !monsterCfgs[e].noOneKill);
            data.zhc = false;
            if(monsterList.length > 0){
                let countHp = 0;
                monsterList.forEach(e => {
                    data.battleMonster = createBattleMonster(e);
                    countHp += data.battleMonster.hp * (monsterCfgs[e].noOneKill ? 10 : 1);
                    battleWin(true, 0, false);
                });

                let needEndurance = parseInt(countHp / 100) + (countHp % 100 === 0 ? 0 : 1);
                filter.forEach(e => {
                    if(needEndurance > 0){
                        let reduce = needEndurance;
                        if(e.endurance < reduce){
                            reduce = e.endurance;
                        }
                        reduceItemEndurance(e, reduce);
                        needEndurance -= reduce;
                    }
                })
                if(needEndurance > 0){
                    data.hp -= needEndurance * 100;
                }
                if(data.hp <= 0){
                    winMsg('你强行驱动月金轮，最终耗尽了生命')
                    $('.item-use-win-modal').hide();
                    $('.item-use-win').hide();
                    $('.bag').hide();
                    $('.home').hide();
                    addDieLog('你强行驱动月金轮，最终耗尽了生命');
                    die();
                }else{
                    timeLapses(5)
                }
            }else{
                if(monsterList.length > 0){
                    winMsg('月金轮无法对当前怪物造成伤害');
                }else{
                    winMsg('你找不到任何怪物');
                }
            }
            return true;
        },
        text : '地球人-蜀山种族技能，必须背包中有月金轮才能使用，在副本中不可使用。耗时5分钟，攻击并杀死当前看见的所有怪物（免疫即死攻击的怪物除外），怪物每有100血，便减少月金轮1点耐久。如果月金轮耐久度耗尽后，地图剩余的怪物还没全部杀死，那么则需要消耗玩家自身的血量来支付剩余需要消耗的耐久度，每100点血支付1点耐久度，这种情况可能导致血量扣负并死亡。如果你的背包有多个月金轮，那么第一个消耗完所有耐久后，会开始消耗下一个月金轮的耐久，直到所有月金轮的耐久全都消耗完才会开始消耗你的血量'
    }),

    //食人魔技能
    '技能石：掠食' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 5,
        endurance : 1000,
        voidDust : 0,
        quality : 1,
        gold : 0,
        myAtk : function(){
            if(!checkRace('掠食')){
                return 0;
            }
            const rate = (data.race.name === '食人魔-暴食' || data.race.name === '食人魔-暴君') && data.battleMonster && data.battleMonster.items.filter(e => elementCfgs[e.name].isMeat).length > 0 ? 2 : 1;
            return rate * (parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1) + parseInt((data.maxHunger - data.hunger) / 5))
        },
        text : '对敌人额外造成(饥饿值上限-当前饥饿值)/5的伤害'
    }),
    '技能石：狂暴' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('狂暴', true)){
                return false;
            }
            if(data.battleMonster.kb){
                winMsg('你已经处于狂暴中了', false, false);
                return false;
            }

            data.battleMonster.kb = true;
            data.atk += parseInt(data.maxHunger / 5);
            data.def -= parseInt(data.maxHunger / 10);
            addBattleLog(`你使用了狂暴，攻击力增加${parseInt(data.maxHunger / 5)}，防御力减少${parseInt(data.maxHunger / 10)}`)
            return true;
        },
        text : '攻击力提高饥饿上限/5，防御力降低饥饿上限/10，每场战斗只能使用一次'
    }),
    '技能石：自食' : new Element({
        battleUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('自食')){
                return false;
            }
            if(!inBattle()){
                winMsg('只能在战斗中使用，请丢弃该技能石重新制造', false, false)
                return false;
            }
            if(data.battleMonster.zs){
                winMsg('你已经吃过自己了', false, false)
                return false;
            }

            data.battleMonster.zs = true;
            const num = parseInt(data.maxHp * 0.2);
            if(data.hp < num){
                winMsg('生命值不足', false, false);
                return false;
            }

            data.hp -= num;
            const number = parseInt(num / 3);
            data.maxHunger += number * 2;
            addObjHunger(data, number);

            addBattleLog('你吃了自己的肉！');
            return true;
        },
        text : '食人魔实在太饿了，于是选择吃自己的肉。消耗20%生命值，每消耗3生命值，恢复1点饥饿值，增加2点饥饿值上限,每场战斗只能使用一次'
    }),
    '技能石：无尽暴食' : new Element({
        canUse :true,
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('无尽暴食')){
                return false;
            }

            if(data.hunger <= 0){
                winMsg('饥饿值不足', false, false);
                return false;
            }

            if(inBattle()){
                data.maxHunger += data.hunger;
            }
            battleAddHp(data, data.hunger * 2);
            data.hunger = 0;

            return true;
        },
        myHp(){
            if(!checkRace('无尽暴食')){
                return 0;
            }
            return data.hunger * 2;
        },
        text : '食人魔-暴食种族技能，为什么越吃越饿了呢。消耗所有饥饿值，每消耗1饥饿值，恢复2点生命值。如果在战斗中使用，则饥饿上限增加消耗的饥饿数'
    }),
    '技能石：铁血' : new Element({
        battleUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('铁血')){
                return false;
            }
            if(data.battleMonster.tx){
                winMsg('你已经是铁血状态了', false, false)
                return false;
            }

            data.battleMonster.tx = true;
            if(!data.suck){
                data.suck = 0;
            }
            data.suck += (data.weapon && data.weapon.suck ? data.weapon.suck : 0) + (data.armor && data.armor.suck ? data.armor.suck : 0) + (data.suck || 0);

            addBattleLog('你进入了铁血状态');
            return true;
        },
        text : '食人魔-暴君种族技能，进入了铁血状态，吸血翻倍，每场战斗只能使用一次'
    }),
    '技能石：双重施法' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('双重施法', true)){
                return false;
            }
            if(hasStatus(data, '念咒')){
                winMsg('你正在念咒', false, false);
                return false;
            }

            addStatus(data, getStatus('念咒', {num : (data.battleMonster.sxs ? 3 : 2) + getStatuNum(data, '狂热')}))
            addBattleLog('你的两个脑袋同时开始念咒')
            return true;
        },
        text : '食人魔-双头法师种族技能，没有念咒状态时才能使用，给自己赋加2层念咒状态。当念咒状态都被消耗掉的时候，会给自己附加一层狂热(最多2层)，每当有一层狂热，在使用双重施法时额外增加一层念咒效果'
    }),
    '技能石：爆轰术' : new Element({
        onlyOne :true,
        isWeapon : true,
        endurance : 1000,
        weight : 5,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(weapon){
            if(!checkRace('爆轰术', true)){
                return false;
            }

            if(hasStatus(data, '念咒')){
                const need = parseInt(data.level / 5);
                if(data.hunger < need){
                    winMsg('你的饥饿值不足', false, false)
                    return;
                }
                data.hunger -= need;

                const num = getStatuNum(data, '念咒');
                reduceStatusNum(data, '念咒', true)

                //获取伤害
                let harm = this.myAtk();

                if(data.race.name === '食人魔-血法师'){
                    data.battleMonster.maxHp -= parseInt(harm * 0.2);
                    addObjHp(data.battleMonster, 0)
                }

                if(num > 1){
                    reduceWeaponEndurance(weapon.id);
                    if(data.weapon && data.weapon.id != weapon.id){
                        reduceWeaponEndurance(data.weapon.id);
                    }

                    const dlcAddFloat = checkMonthName('命运波动之月') ? 0.1 : checkMonthName('命运平稳之月') ? -0.1 : 0;
                    harm = randomNum(parseInt(harm * (1 - atkFloat - dlcAddFloat)),parseInt(harm * (1 + atkFloat + dlcAddFloat))) - data.battleMonster.def

                    if(harm > 0){
                        addBattleLog(`你使用[技能石：爆轰术]进行攻击，对${data.battleMonster.showName || data.battleMonster.name}造成${harm}点伤害`);
                        data.battleMonster.hp -= reduceShield(data.battleMonster,harm);
                    }else{
                        addBattleLog(`你使用[技能石：爆轰术]进行攻击，无法击破${data.battleMonster.showName || data.battleMonster.name}的防御。`);
                    }
                    if(data.battleMonster.hp > data.battleMonster.maxHp){
                        data.battleMonster.hp = data.battleMonster.maxHp;
                    }
                    renderBattlePage();

                    //怪物死亡，获得战利品
                    if(data.battleMonster.hp <= 0){
                        battleWin();
                    }
                    return false
                }else{
                    if(getStatuNum(data, '狂热') < 2){
                        addStatus(data, getStatus('狂热'))
                    }
                    return true;
                }
            }else{
                winMsg('你还没有念咒', false, false)
                return false;
            }
        },
        myAtk : function(){
            if(!checkRace('爆轰术')){
                return 0;
            }
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) + (data.level * 10))
        },
        text : '食人魔-双头法师种族技能，只能在有念咒状态时使用，消耗相当于你等级/5的饥饿，额外造成消耗的等级*10的额外的伤害，念咒层数-1。如果你的念咒层数超过1层，则使用该技能后依旧是你的回合。本技能无法触发吸血。'
    }),
    '技能石：嗜血术' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('嗜血术', true)){
                return false;
            }
            if(!hasStatus(data, '念咒')){
                winMsg('你还没有念咒', false, false);
                return false;
            }
            if(data.battleMonster.sxs){
                winMsg('你已经给自己施加了嗜血术', false, false);
                return false;
            }

            if(getStatuNum(data, '念咒') === 1){
                addStatus(data, getStatus('狂热'))
            }

            data.hunger -= 50;
            data.battleMonster.sxs = true;
            reduceStatusNum(data, '念咒', true)
            data.suck += 50;
            addBattleLog('你使用了嗜血术，增加了50%吸血')
            return true;
        },
        //text : '食人魔-双头法师种族技能，拥有念咒状态时才能使用，消耗50饥饿，减少1层念咒状态，增加50%吸血，加快施法速度，使用了嗜血术后，使用双重施法时将获得3层念咒。该技能每场战斗只能使用一次'
        text : '该技能已废弃'
    }),

    //操脑蛛技能
    '技能石：解除操纵' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('解除操纵')){
                return false;
            }
            if(!data.control){
                winMsg('你没有控制怪物', false, false)
                return false;
            }
            winMsg(`你解除了${data.control.showName || data.control.name}的控制`);
            data.control = null;
            const hp = data.hp;
            initAttr();
            data.suck = 0;
            if(data.hp > hp){
                data.hp = hp;
            }
            return true;
        },
        text : '操脑蛛种族技能，解除当前控制的怪物，并自动进行一次洗点。如果解除操纵前的血量低于洗点后的血量，则血量保持为解除操纵前的血量'
    }),
    '技能石：精神狂暴' : new Element({
        battleUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('精神狂暴')){
                return false;
            }
            if(data.battleMonster.jskb){
                winMsg(`你操控的${data.control.showName || data.control.name}已经处于精神狂暴当中`, false, false);
                return false;
            }
            data.battleMonster.jskb = true;

            data.atk += data.control.atk * 3;
            const old = data.control.hp;
            data.control.maxHp = data.control.hp = parseInt(data.control.hp * 0.7)
            const num = old - data.control.hp;
            data.maxHp -= num;
            data.selfAttrs.maxHp -= num;
            if(data.hp > data.maxHp){
                data.hp = data.maxHp;
            }

            addBattleLog(`你强制让你操控的${data.control.showName || data.control.name}陷入了狂暴中`);
            return true;
        },
        text : '操脑蛛种族技能，永久降低被控制怪物30%的生命上限，并将减少的具体数值立刻体现到人物当前的生命值上限，提高控制怪物本身攻击力*3的攻击力。该技能每场战斗只能使用一次'
    }),
    '技能石：怪物强化' : new Element({
        canUse :true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('怪物强化')){
                return false;
            }
            if(!data.control.upNum){
                data.control.upNum = 0;
            }
            const need = 5 * Math.pow(2, data.control.upNum)
            const items = monsterCfgs[data.control.name].items.filter(e => elementCfgs[e.name].fromMonster).map(e => e.name);

            if(items.length === 0){
                winMsg('该怪物没有可强化的材料，无法强化', false, false)
                return;
            }

            if(items.filter(e => getNumByBag(e, data.location.join() === data.world.home.location.join()) >= need).length === items.length){
                items.forEach(e => {
                    //如果是在家，允许使用仓库中的物品
                    if(data.location.join() === data.world.home.location.join()){
                        //获取背包中的数量
                        const bagNum = getNumByBag(e);
                        //优先使用背包中的物品
                        if(bagNum >= need){
                            reduceItem(e, need);
                        }else{
                            if(bagNum > 0){
                                reduceItem(e, bagNum);
                            }
                            reduceItemByStore(e, need - bagNum);
                        }
                    }else{
                        reduceItem(e, need);
                    }
                })
                data.control.upNum++;

                data.control.hp = Math.ceil(data.control.hp * 1.1)
                data.control.atk = Math.ceil(data.control.atk * 1.1)
                data.control.def = Math.ceil(data.control.def * 1.1)

                const hp = data.hp;
                initAttr();
                if(data.hp > hp){
                    data.hp = hp;
                }
                winMsg(`强化成功，消耗[${items.join('，')}]*${need}`)
                return true;
            }else{
                winMsg(`材料不足，此次强化需要[${items.join('，')}]*${need}`)
                return false;
            }
        },
        text : '强化你操纵的怪物的属性，可以无限次数强化，每次强化都会在当前属性上提高10%的血量、攻击和防御(全部向上取整)，并自动进行一次洗点，但是当前血量保持强化前的状态。强化需要消耗操纵的怪物掉落的材料（放在仓库里也可以，不用带在身上），初次强化需要消耗掉落的材料各5个，之后每强化过一次，材料翻倍。即第二次10个，第三次20个，第四次40个。取消操纵时强化获得的属性一并丢失'
    }),

    //污染者技能
    '技能石：自我扭曲' : new Element({
        battleUse : true,
        weight : 0,
        voidDust : 0,
        quality : 1,
        gold : 0,
        func : function(){
            if(!checkRace('自我扭曲', true)){
                return false;
            }
            const num = ndx(5, 4) * (getStatuNum(data, '扭曲形态') + 1)

            if(data.san < num){
                addBattleLog('你试图让自己更加扭曲，但是你的理智不足以控制你的身体');
                return true;
            }

            reduceObjSan(data, num);
            addStatus(data, getStatus('扭曲形态'))

            let attrNum = getStatuNum(data, '扭曲形态') * getCthulhuScholarship();
            const attrs = ['atk','atk','atk','atk','def','def','def','hp','hp','suck'];
            //以下为一次增加获得的点数
            const addNum = {
                atk : 1,
                def : 1,
                hp : parseInt(data.maxHp * 0.01),
                suck : 1,
            }
            if(addNum.hp < 1){addNum.hp = 1}

            for(let i = 0 ; i < attrNum ; i++){
                const attr = attrs.getRandom();
                if(attr === 'suck' && !data.suck){
                    data.suck = 0;
                }
                data[attr] += addNum[attr];
                if(attr === 'hp'){
                    data.maxHp += addNum[attr];
                }
            }

            addBattleLog(`你消耗了${num}理智，并且变得更加扭曲了`)
            return true;
        },
        text : '污染者种族技能，消耗“5d4*(扭曲形态层数+1)”的理智值(当理智不足时会使用失败，并浪费这一回合的行动机会。如果理智正好和需要消耗的理智相同，消耗后会保留1点，而不是变为0)，给自己附加一层扭曲形态，并获得当前扭曲形态层数*克苏鲁学识的随机属性点，这些属性点将自动随机分配，可能分配到以下属性中：攻击（40%概率，1属性点=1攻击）/防御（30%概率，1属性点=1防御）/血量（20%概率，1属性点=1%血量，最少1）/吸血（10%概率，1属性点=1%吸血）'
    }),

    //星灵系技能
    '技能石：时间穿梭' : new Element({
        canUse :true,
        voidDust : 0,
        quality : 1,
        weight : 0,
        gold : 0,
        func : function(){
            if(!checkRace('时间穿梭', true)){
                return false;
            }
            $('.item-use-win-modal').hide();
            $('.item-use-win').hide();
            $('.win').hide();
            $('.time-shuttle').show();
            return true;
        }, text : '星灵种族技能，可以穿梭到未来，具体穿梭到多久后的未来可以自行选择'
    }),
};
