//赞助商列表
let sponsors = {};
let sponsorList = [];
//const wsIp = 'localhost';
const wsIp = '116.204.123.41';
let ws = null;

//获取用户CODE，全难度唯一
function getCode(){
    let code = localStorage.getItem('idCode');
    if(!code){
        if(conf.code){
            if(conf.code.length === 8){
                code = conf.code;
            }else{
                code = S4() + S4();
                alert('检测到您的ID异常，可能是1.87版本的BUG导致的，已重新生成ID');
            }
        }else{
            code = S4() + S4();
        }
        localStorage.setItem('idCode', code);
    }

    if(conf.code !== code){
        conf.code = code;
        save(confSavedName, conf);
    }
    return code;
}

//获取用户名称，全难度唯一
function getName(){
    let name = localStorage.getItem('idName');
    if(!name){
        if(conf.name){
            name = conf.name;
        }else{
            name = getCode();
        }
        localStorage.setItem('idName', name);
    }

    if(conf.name !== name){
        conf.name = name;
        save(confSavedName, conf);
    }
    return name;
}

//链接WebSocket
function linkWs(){
    try{
        if(!$('.chat-room').is(':hidden')){
            $('#chatroom').removeClass('has-new');
        }
        if(!ws){
            ws = new WebSocket(`ws:${wsIp}:9013/chatroom/websocket`);

            $('#chat-room-name').val(getName());

            //连接成功时调用
            ws.onopen = function(evt){
                setTimeout(() => {
                    systemMsg("成功连接到聊天室，官方Q群1群：199488988，2群：584578235，3群：249417059，4群：216971908，5群：697251775（建议加5群，其他群不太活跃）");
                    systemMsg("不想看聊天室的可以在系统中关闭。本游戏完全用爱发电，也不可能有精力去弄太多限制过滤之类的，请大家在聊天室保持文明守序，不要刷屏和发敏感信息，否则只能关闭聊天室了");
                    systemMsg("如果遇到卡关的情况，请看tap论坛攻略区加精的的寒影全图通关攻略，寒影都能通关的打法，其他任何种族都可以参照着通关");
                }, 500)
            };

            //接收到服务器的消息时调用
            ws.onmessage = function(evt){
                try{
                    const data = JSON.parse(evt.data);
                    if(data.isOldList){
                        JSON.parse(data.list).forEach(e => {
                            appendChatRoomMsg(e.msg, e.name, e.code, e.time, e.info);
                        })
                    }else{
                        appendChatRoomMsg(data.msg, data.name, data.code, data.time, data.info);
                    }
                    $('.online-num').html('(在线人数：' + data.count + ')');
                    if($('.chat-room').is(':hidden')){
                        $('#chatroom').addClass('has-new');
                    }
                }catch(e){}
            };

            //连接关闭时调用
            ws.onclose = function(evt){
                ws = null;
                systemMsg("聊天室连接已断开");
            };

            window.sendMsg = function(msg){
                appendChatRoomMsg(msg, getName(), getCode(), new Date().format('yyyy-MM-dd hh:mm:ss'), getRoleInfo());
                ws.send(JSON.stringify({name : getName(), code :getCode(), msg, info : getRoleInfo()}));
            }
        }

    }catch (e) {
        systemMsg('聊天室链接错误')
    }
}

//获取当前角色信息
function getRoleInfo(){
    const dlcs = [];
    if(data.dlcMonsterEquip){dlcs.push('怪物武装')}
    if(data.dlcMonsterItem){dlcs.push('怪物物品')}
    if(data.dlcFateMonth){dlcs.push('命运之月')}
    if(data.dlcWorldEnd){dlcs.push('世界末日')}
    if(data.dlcLastMagic){dlcs.push('末法时代')}
    if(data.dlcOriginal){dlcs.push('原初体验')}
    return `${diff}&nbsp;&nbsp;${data.order || 1}周目${data.level}级${data.race.name}${dlcs.length > 0 ? `&nbsp;&nbsp;DLC：${dlcs.join('+')}` : ''}`;
}

function sendMsg(msg){}

//打开聊天室
$('#chatroom').click(function(){
    $('.chat-room').show();
    linkWs();
});

//改名
function changeChatRoomName(){
    const val = $('#chat-room-name').val();
    if(val != null && val !== ''){
        if(val.length > 8){
            alert('名字不能超过8个字符')
            return;
        }
        localStorage.setItem('idName', val);
        alert('改名成功')
    }else{
        alert('名字不合规则')
        $('#chat-room-name').val(getName());
    }
}

//系统消息
function systemMsg(text){
    appendChatRoomMsg(text, '系统消息', '00000000');
}

//追加聊天室消息
function appendChatRoomMsg(text, name = getName(), code = getCode(), time = new Date().format('yyyy-MM-dd hh:mm:ss'), info){
    if(sponsorList.includes(code)){
        name = `${name}<span class="sponsor-name">[赞助商]</span>`
    }
    $('.chat-room-body').prepend(`<div class="chat-room-msg"><div class="chat-room-msg-title"><span class="chat-room-msg-name">${name}[${code}]</span><span class="chat-room-msg-time">${time}</span></div>${info ? `<div class="chat-room-msg-info">${$(`<span>${info}</span>`).text()}</div>` : ''}<div class="chat-room-msg-context ${sponsorList.includes(code) ? 'sponsor-text' : ''}">${$(`<span>${text}</span>`).text()}</div></div>`);
}

//监听回车
$('#chat-room-text').bind('keydown',function(event){
    if(event.keyCode == "13") {
        sendChatRoomMsg();
    }
});

//发消息
function sendChatRoomMsg(){
    const val = $('#chat-room-text').val();
    if(val != null && val !== ''){
        if(val.length > 200){
            alert('一次不能发送超过200个字符')
            return;
        }
        $('#chat-room-text').val('');
        sendMsg(val);
        while ($('.chat-room-body .chat-room-msg').length > 100){
            $('.chat-room-body .chat-room-msg').last().remove();
        }
    }
}

let sponsorWs = null;
function initSponsor(){
    if(sponsorWs == null){
        sponsorWs = new WebSocket(`ws:${wsIp}:9014/sponsor/sponsor`);
        sponsorWs.onopen = function(evt){
            sponsorWs.send(JSON.stringify({type : 'query', keep : '0', code : getCode()}));
        };
        sponsorWs.onmessage = function(evt){
            try{
                const data = JSON.parse(evt.data || '{}');
                if(Object.keys(data).length > 0){
                    sponsorList = [];
                    sponsors = {};
                    $('.sponsor-list').html('');

                    let keys = Object.keys(data).sort((a, b) => parseFloat(data[b].money) - parseFloat(data[a].money));

                    keys.forEach(e => {
                        if(data[e].code){
                            //读取公共
                            if(e === '更新预告'){
                                if(data[e].code !== conf.updateCode){
                                    conf.updateCode = data[e].code;
                                    save(confSavedName, conf);
                                    $('.common-win').show().find('.win-body').html(`<h1 style="text-align: center">更新预告</h1><p style="text-indent:2em;padding: 0 10px">${data[e].money}</p>`)
                                    return;
                                }
                            }

                            let arr = data[e].code.split(',');
                            arr.forEach(a => {
                                sponsors[a] = parseInt(parseFloat(data[e].money) * 10);
                            })
                            sponsorList = [...sponsorList, ...arr]
                            $('.sponsor-list').append(`${e}：${data[e].money}元<br>`)
                        }
                    })
                }
            }catch(e){}
            renderSponsorShop()
        };
        sponsorWs.onclose = function(evt){
            sponsorWs = null;
        };
    }
}

//复制ID
function copyContent(value, type = 'input') {
    const input = document.createElement(type);
    input.setAttribute('readonly', 'readonly'); // 设置为只读, 防止在 ios 下拉起键盘
    // input.setAttribute('value', value); // textarea 不能用此方式赋值, 否则无法复制内容
    input.value = value;
    document.body.appendChild(input);
    input.setSelectionRange(0, 9999); // 防止 ios 下没有全选内容而无法复制
    input.select();
    document.execCommand('copy');
    document.body.removeChild(input);
    winMsg('ID复制成功', false, false)
}
