//点击切换类型
$('.cybernet').on('click','.cybernet-type', function(){
    $('.cybernet-types .cybernet-active').removeClass('cybernet-active')
    $(this).addClass('cybernet-active');
    renderCybernetItems();
});

//点击切换物品
$('.cybernet').on('click','.cybernet-item', function(){
    $('.cybernet-items .cybernet-active').removeClass('cybernet-active')
    $(this).addClass('cybernet-active');
    renderCybernetBody();
});

//dlc说明文本
const dlcTexts = {
    '怪物武装' : `开启后怪物有可能穿戴装备（武器和护甲都是10%概率，也可能两个一起穿戴），并获得装备属性，怪物穿戴的装备会从低于自己10级以内的装备列表里随机一件，并触发锻造，获得相当于你执行一次锻造造出来的装备，获得各个品质的概率和你在锻造台锻造的概率一致，也就是说你的锻造熟练度越高，怪物也可能更可能获得高品质的装备。但是怪物的装备不会镶嵌、附魔、锤炼等。怪物的装备只会加成怪物的攻击、防御、血量和吸血属性，且不会穿戴盾牌`,
    '怪物物品' : `开启后怪物有10%的可能携带药剂和投掷品（世界BOSS除外），在随机到会携带的情况下（即触发了那10%的携带概率），每种物品最多携带1个，最少携带1种物品，最多携带怪物等级/10+1种物品。携带的物品一定是怪物所在地图可以制造出来的物品，不会出现孤岛的怪携带强效治疗药剂之类的事情。怪物携带的物品，如果直到死亡都还没有使用，则会加入掉落列表中，被玩家获取，但是副本中的怪物虽然也会可能携带物品，但是一定不会掉落，扫荡时怪物不会渲染物品，所以扫荡类技能（冰封千里，亡灵天灾等）也无法获取到怪物的物品。的物品列表如下：物品名（携带需要的怪物等级）<br>${Object.keys(monsterItemDlcSkills).map(s => `${s}(${monsterItemDlcSkills[s].level})`).join('，')}`,
    '命运之夜' : `开启后每个游戏月都会有自己的主题，不同的主题有不同的效果，具体如下：<br>${dlcFateMonths.map(e => `<b>${e.name}</b>：${e.text}`).join('<br>')}`,
    '世界末日' : `开启的当天开始计算时间，开启后次元交易所将不可用，同时每个游戏日当前地图都会有1个资源地形（即非神殿、地图出入口这种地形）变为末地，直到该地图所有资源地形都变成末地。在副本中时，副本地形不会变为末地，但是离开副本后，在副本经过了多少天， 就会有多少个地形变为末地`,
    '末法时代' : `开启后无法进行觉醒，如果开启时已经觉醒过了，则会变成觉醒前的种族，并自动进行一次洗点，如果蜥蜴人-卡格拉玛给鳞片附魔的是武器，则会失去鳞片附魔。`,
    '原初体验' : `后面为了丰富玩法，增加了很多东西，难度也因此降低了很多，所以增加了这个怀旧的DLC，有兴趣的玩家可以体验一下原版的开拓者是什么难度。开启后无法使用镶嵌物仓库、镶嵌台、符文法阵、附魔台、纳米机器、元素实验室、次元金融所、赞助商店、装备打孔器、溶解室、洗涤室，不会遇到流浪商人。我知道这么BT的DLC你们应该没啥兴趣，不过我想玩，所以我就做了。`,
};

//说明列表
const explains = {
    'DLC' : `<p>在扩展难度下，可以在系统中开启或关闭指定DLC。DLC随时可以开启，但是时间流逝后将无法再关闭。并不是说玩拓展难度就要打开所有DLC的，根据自己的兴趣开就好了，所有DLC一起开启可能会导致难度过高。</p><h2>DLC有：</h2>${Object.keys(dlcTexts).map(name => `<h3>${name}</h3><p>${dlcTexts[name]}</p>`).join('')}`,
    '家' : `<p>安家是整个游戏的基础，绝大多数功能都在家中解锁。<br>安家没有成本，但每个地图中只能安一次家，且安家后无法随意搬家。<br>在家中的任何操作（包括回家，出门）不会消耗时间。<br>家可以升级，越高等级的家解锁越多的功能。每个地图的家的等级不会互通，安家时为0级。<br>升级家需要的材料如下：<br><br>1级家：纤维*5，木头*10，石头*5<br><br>2级家：铁锭*20，铜锭*20，红水晶*20，魔晶石*20，哥布林之心*3<br><br>3级家：紫晶*20，灵魂晶粉*20，紫晶之核*3，时空碎片*1<br><br>4级家：神性结晶*10，赐福神力*3<br><br>5级家：弑神之证*1</p>`,
    '床' : `<p>0级家解锁。在床上睡觉时，不会被怪物攻击，且每小时恢复${60 / statusMin * sleepAddHp}生命值。<br>睡觉为每15分钟判定一次，每次判定会扣除${statusNum}饥饿和水分，并恢复${sleepAddHp}生命值。饥饿和水分足够扣除，才会恢复生命值，如果饥饿和水分任意一项不够扣除，会用血量代替扣除，且本轮判定不会恢复生命值。</p>`,
    '仓库' : `<p>0级家解锁。存储物资，没有存储上限。</p>`,
    '镶嵌物仓库与存档' : `<p>0级家解锁。镶嵌物中只能存储镶嵌物，但是全存档互通，也就是说你可以在高等级的存档中获取镶嵌物存入镶嵌物仓库，在低等级的存档取出镶嵌物使用。</p>`,
    '工作台' : `<p>1级家解锁。工作台中可以制作多种物品，包括种族专属技能石，低级材料，工具，药膏，背包等。草药膏是前期很重要的补给物品。</p>`,
    '熔炉' : `<p>1级家解锁。用来烧炼矿物。</p>`,
    '厨房' : `<p>1级家解锁。用来加工食物，获得更多的饥饿和水分值。</p>`,
    '锻造台' : `<p>1级家解锁。用来打造装备。可以将武器装备在手上，装备武器后不允许空手攻击，也不允许使用其他未装备的武器，但是可以享受到武器上的防御加成。</p>`,
    '炼金室' : `<p>1级家解锁。用来制造投掷品和药剂。投掷品和药剂都是一次性物品，但是投掷品可以造成较高伤害和伤害buff，药剂可以提供强力回复和持续恢复。投掷品和药剂都是强大的战斗助力。</p>`,
    '附魔台' : `<p>1级家解锁。用来为装备附魔，提供额外属性。使用变异核心对装备进行附魔，附魔得到的词缀为怪物变异词缀（所以要看附魔词缀请去“图鉴-说明-怪物变异”），附魔等级越高，获得的词缀等级越高，获得的词缀等级最低不低于附魔等级-5，最高不高于附魔等级，变异怪物死亡时掉落几个变异核心，其所带的词缀就是几级词缀。每件装备只能拥有一个附魔词缀，但是可以多次附魔，每次附魔都会覆盖掉之前已有的附魔属性。</p>`,
    '镶嵌台' : `<p>1级家解锁。用来为有孔的装备镶嵌，提供额外属性。更多相关内容请看下方的：镶嵌物、符文、符文之语</p>`,
    '符文法阵' : `<p>1级家解锁。用来转移符文之语。被转移装备和目标装备的孔数必须相同，转移符文之语会销毁被转移装备。装备如果镶嵌了符文之语后又打了孔，则不能再被转移。</p>`,
    '装备打孔器' : `<p>1级家解锁。用来为装备打孔。</p>`,
    '溶解室' : `<p>1级家解锁。用来将装备溶解，回收镶嵌物。</p>`,
    '洗涤室' : `<p>1级家解锁。用来将装备洗涤为1级。</p>`,
    '虚空分解机' : `<p>2级家解锁。可以将不需要的材料分解为虚空粉尘，虚空粉尘可以修理装备。</p>`,
    '虚空修复器' : `<p>2级家解锁。用来修复装备。使用虚空粉尘可以修复装备耐久度，每件装备修复1点耐久度需要1粉尘，高级装备每次需要2粉尘。每次修理后，需要的粉尘数量翻倍。例如木斧，修复9耐久度需要9粉尘，下次再修复9耐久就需要18粉尘，再下次就需要36粉尘。</p>`,
    '次元研究室' : `<p>2级家解锁。用来制造特殊道具。灵魂追猎可以追踪神话怪的位置，次元钥匙可以在任何位置打开本地图的家的仓库，次元信标可以用来搬家。</p>`,
    '次元交易所' : `<p>2级家解锁。可以将不需要的材料卖出获得金币，使用金币购买需要的材料。次元交易所出售的物品每天晚上0点刷新。</p><h4>各地图出售物品列表如下</h4>${Object.keys(goods).map(e => `<h5>${mapCfgs[e].name}</h5><p>${Object.keys(goods[e]).map(t => `<b>${t}：</b>${goods[e][t].map(good => `${good}(${elementCfgs[good].gold}G)`).join('，')}`).join('<br>')}`).join('<br><br>')}</p>`,
    '亵渎室' : `<p>2级家解锁。用来制造强大的投掷品、药剂和道具。</p>`,
    '纳米机器' : `<p>2级家解锁。用来制造盾牌（装备在武器栏）</p>`,
    '元素实验室' : `<p>2级家解锁。用于进行元素调和，只能使用背包中的物品进行调和。目前可调获得的物品有：${Object.keys(elementalRecipes).join('，')}。调和成功的配方会加入配方列表，一个难度下配方列表是通用的。可以选择一个物品进行配方研究，研究也会消耗材料，并根据元素情况给予反馈，当配方达到要求时，将获得该物品，并记录改配方。</p>`,
    '次元金融所' : `<p>2级家解锁。这就是个纯娱乐设施，不是为了赚金币的，只是给游戏增加点娱乐玩法。跳周目时会重置金融所内所有点券，金币购买的点券会全部消失，赞助点数购买的点券会全部按照当前价位出售。涨跌完全随机，绝对随机，和之前一段时间的涨跌毫无关系，不要把炒股的思维带进来玩，这就是单纯的运气游戏。可以在跨位面商人联合建立的交易所购买和出售点券，无论购买还是出售，次元金融所都会收取本次交易额百分之一的手续费，该手续费将体现在价格上，例如“海产商会”的点券当前价格是520.14，那么你要购买，就需要按照520.14*1.01=525.34的价格购买，如果是出售只能按照520.14*0.99=514.94的价格出售。次元金融所的价格每个游戏日（0点）浮动一次，最高涨跌幅度最高都是10%，每次涨跌都是给予前一日的价格，所以如果连续两天涨10%，相对于2天前来说，不是涨了20%，而是涨了(1.1*1.1-1)*100%=21%。当点券价值低于指定阈值时，将会进行破产清算，将强制卖出玩家所有该点券，并重置该点券为初始状态，金币得清算阈值为${stockCfg.金币.close}，赞助点数得清算阈值为${stockCfg.赞助点数.close}。</p>`,
    '传送门' : `<p>3级家解锁。使用时空粉尘可以快捷传送到任何地图的家，无论这个家是否达到3级（不过目标家没到3级的话你可能要用腿跑回去）。传送门还可以传送去副本，具体见下方的副本说明。</p>`,
    '时空法阵' : `<p>3级家解锁。用来制作回城卷轴和短程传送卷轴。短程传送卷轴是很重要的保命物品。</p>`,
    '生命祭坛' : `<p>3级家解锁。用来解锁几个特定种族。</p>`,
    '锤炼台' : `<p>4级家解锁。用来锤炼装备。</p>`,
    '神力窃取室' : `<p>4级家解锁。用来制作各种高级道具。</p>`,
    '天赋祭坛' : `<p>4级家解锁。用来进行转职。</p>`,
    '最终退路' : `<p>5级家解锁。用来制造进入下一周目的物品。</p>`,
    '季节和日夜' : `<p>3-5月为春季，6-8月为夏季，9-11月为秋季，12-2月为冬季。春秋的6点-18点为白天（即19点开始变为夜晚，而不是18点就变为夜晚），夏季5点-19点为白天，冬季7点-17点为白天。怪物只会在自己的活动时间（日或夜或全天）偷袭玩家，其他时间也能找到怪物，但是怪物不会主动攻击玩家。不同的怪物活动时间不一样，具体见图鉴。在春季，所有可再生资源的生成速度翻倍，在冬季，所有资源不再生成，在夏天，水分消耗速度翻倍。</p>`,
    '神' : `<p>在部分技能或物品中，会显示该技能对神无效，这里需要注意，神仅仅是指：草木之神/森林之神/山脉之神/大地之神/生命之神/五首龙神这几个怪，其他的即使是神话怪，也不是神。神是不吃任何秒杀技能的，除非秒杀技能写了可以对神有效，而一般说明中写了对免疫即死攻击的怪物无效，那么这里所谓的免疫即死攻击的怪物，就是指的神和世界BOSS。</p>`,
    '怪物偷袭' : `<p>怪物在自己的活动时间有几率主动攻击玩家，具体攻击时间和几率见图鉴-怪物。怪物偷袭时必然是怪物先手攻击。怪物只会偷袭比自己高最多5级的玩家。</p>`,
    '吸血' : '<p>战斗中每吸取20点HP，则扣除1点生命上限，不足20点HP时按20点算。例如：吸血15HP，则扣除1点HP上限，吸血28HP时，扣除2点HP上限。扣除的HP上限战斗结束后返还。扣生命上限的吸血量是按照实际吸血量算的，例如你攻击力1000，吸血100%，血量980/1000，此时你攻击打出1000伤害，你的吸实际血量为20，而不是1000，所以只扣除1HP上限。如果你一直保持满血，吸血量就是0，就不会扣生命上限。</p>',
    '无视防御' : `<p>游戏内所谓的无视防御，其实本质上就是伤害加上了对面的防御力（对方防御力小于0时不会增加也不会减少伤害），所以当我们用灵魂鞭挞的时候，灵魂鞭挞有100攻击，对面怪物100防御，可能会发现战斗页面显示灵魂鞭挞200伤害，最终只打出了60伤害这种事，因为这个200伤害已经是增加了对面的防御力了，灵魂威慑本次实际的真实伤害时100，这一点在战斗外也可以看到，灵魂威慑战斗外显示100伤害，进战斗显示200。所以，无视防御其实也增大了波动幅度。如果是真正的无视防御，那么100伤害应该打出80-120的真伤，但是本游戏的机制，实际上就是打出160-240伤害，然后减去怪物100防御，最终变成60-140的真伤。</p>`,
    '消耗品' : `<p>消耗品主要分为投掷品和药剂两种，每个消耗品使用一次即销毁，部分强力消耗品一整场战斗中只能使用一次。投掷品可以造成高额伤害并附加控制或伤害buff，药剂可以提供强力回复和持续恢复效果。在攻击强大的怪物时，携带一些消耗品可以显著降低难度。</p>`,
    '技能石' : `<p>每个种族都有其独有的技能石，击败神话怪物可以获得公有技能石，使用技能石释放技能。身上有封印状态时，无法使用技能石。</p>`,
    '时间流逝' : `<p>当进行任何会消耗时间的行为时，会进行一次时间流逝判断。<br>时间流逝会刷新地图上的怪物，并且根据刷新出来的怪物，进行一次攻击判定，当前时间在怪物的主动攻击时间范围内时，并且概率判定达成，则会被怪物主动攻击，进入战斗。</p>`,
    '扫荡' : `<p>在自己的等级高于地图最高等级至少6级时，可以对地图区块进行扫荡。扫荡可以一次性采集地图区块上指定的所有某种资源。并非所有资源都可以扫荡。扫荡时请注意用时，小心把自己扫死了。</p>`,
    '攻击波动' : `<p>无论是怪物还是玩家，在进行攻击时，攻击力都会先进行波动，然后再去减对方的防御力。</p>`,
    '经验波动' : `<p>打低于自己20级的怪没有经验。怪每比自己高1级，多10%经验，每比自己低1级，少5%经验。</p>`,
    '锻造和装备' : `<p>锻造时，除了固定品质的装备，其他装备打造时都有概率获得[优秀(${qualityRate[1]}‰，上限${qualityRateMax[1]}‰)、精良(${qualityRate[2]}‰，上限${qualityRateMax[2]}‰)、传说(${qualityRate[3]}‰，上限${qualityRateMax[3]}‰)、神话(${qualityRate[4]}‰，上限${qualityRateMax[4]}‰)]品质的加成,每个品质有独特的前缀，不同前缀有不同的属性加成。打造出不同品质的装备有不同的熟练度加成，熟练度每提高${forgeQualityExp}点则提高1‰的各个品质出现率。</p><h4>装备前缀如下</h4><p>${Object.keys(prefixs).map(e => {
        return `${e}(LV${prefixs[e].level}，${qualityAttr[prefixs[e].quality].name})：atk+${prefixs[e].attrs.atk || 0}，def+${prefixs[e].attrs.def || 0}，耐久+${prefixs[e].attrs.endurance || 0}`;
    }).join('<br>')}</p>`,
    '神话怪物' : `<p>神话怪物不会固定在某个地形刷新，而是随机生成在地图任意位置，然后每天移动一次，朝4周随机地形移动。神话怪物被打死后，将在${mythMonsterRebirthDay}天后于地图任意位置重生。神话怪物不会主动攻击玩家。</p>`,
    '不破防' : `<p>当怪物本次打出的攻击力，不超过护甲本身的防御力的一半时，不会扣除护甲的耐久度。</p>`,
    '怪物变异' : `<p>在进入战斗时，怪物有${variationRate}%的可能变异，拥有变异词条。怪物变异无法在地图上看到，只能进入战斗时看到。怪物变异后，根据词条不同，会掉落不同数量的变异之核，变异之核是附魔的必要材料。</p><h4>怪物变异词条如下</h4><p>${Object.keys(variations).map(e => {
        return `${e}(LV${variations[e].num})：atk+${variations[e].atk}，def+${variations[e].def}，hp+${variations[e].hp}`;
    }).join('<br>')}</p>`,
    '神殿' : `<p>每个神灵在每个地图上都一定会有一个神殿。神殿拥有神性值，完成1个神殿任务，该神殿的神性+1。神殿商店会出售神殿独有的物品，每个神出售的物品会有所不同。完成神殿任务获得神眷和信仰，商店部分商品购买时会有神眷要求，信仰是神殿商店的购买货币。摧毁神殿时，会获得（神性/10）的神性结晶，同时会清空所有该神殿所属神灵的神眷和信仰，然后再减少（神性*100）的神眷和信仰。神殿任务可以拒绝，拒绝后刷新任务。当神神眷到${minGodFavor}时，会产生神罚，并且该神灵将永远拒绝你进入其神殿，当你试图进入神殿时，会造成(神眷/100)的伤害。</p>`,
    '神罚' : `<p>神眷达到${minGodFavorMonster}时，神罚将导致怪物变异，以后所有怪物都将带有神罚字样，掉落物品不变，但是属性提高，神眷越低，属性增加越多。-1000神眷时，怪物属性增加HP+${godMonsterAddAttr.hp},atk+${godMonsterAddAttr.atk},def+${godMonsterAddAttr.def}。之后每-100神眷，属性再增加HP+${godMonsterAddAttr.hp},atk+${godMonsterAddAttr.atk},def+${godMonsterAddAttr.def}。</p>`,
    '神战' : `<p>神眷达到${godBattle}时，和任意怪物触发战斗时，都会变为神战，神灵将亲自降临，无法逃跑。击败神灵后，该神灵对你的神眷和信仰清空，并且忘记你对其做过的事情，你可以重新进入其神殿。</p>`,
    '种族' : function(){return `<p>首先，各大生物类的种族基本都是拥有特定血脉的亚种，所以都是类人型。属性点加在血量上时，会增加种族对应的“升级提升生命值”的数值，每加20点生命值，下一次增加的数值再基础数值上加1倍，最多只能增幅为基础数值的5倍。例如：加的前10点生命值一次加10血，21点-40点加20血，41-60点加30血，但是哪怕加到第200点，也就一次加50血。而升级自动加的属性点，每10级增加一倍，最高也是基础血量成长的5倍。</p><p><h4 style="text-align: center">点击查看各种族详情及觉醒情况</h4>${Object.keys(races).filter(e => !e.includes('-')).map(e => `<p><a href="javascript:seeRace('${e}')">${e}${conf.races.includes(e) || initRaces.includes(e) ? `(已解锁)` : ''}</a></p>`).join('')}</p>`},
    '副本' : `<p>怪物有几率掉落位面坐标，使用位面坐标可解锁副本，在3级家的传送门可以传送至副本。副本不可安家，不能回家，不能打开远程仓库。传送去副本时不能超重。副本分为普通副本、无限副本和无限刷怪副本：<br><br>普通副本怪物死亡后不会刷新，下次进入副本自动刷新所有副本怪物，死亡则GAME OVER。<br><br>无限刷怪副本和普通副本类似，但是里面的怪可以无限刷新，而非打死后就不刷新了。<br><br>无限副本内击杀怪物不会掉落任何物品，初始进入时刷新副本内所有怪物，全怪物等级为LV1，LV1的怪物属性和野外属性保持一致。当初次打死一只怪物后，该副本只刷新这只怪物，并且怪物等级+1。每打死一次怪物，则怪物等级+1。怪物等级每提高1级，属性提高50%，例如，怪物LV1时生命值为100，LV2时为150，LV3时为200。如果人物等级比怪物等级高10级以上，则每高10级，额外提升50%怪物属性。例如，70级打10级的神性史莱姆，初始血量1000，LV2则是4500，LV3则是8000。会随着等级提高的属性有：生命值/攻击力/防御力/吸血。无限副本中死亡不会GAME OVER，而是自动补满血量并离开副本。离开无限副本时，会进行奖励结算，按照你所攻击的怪物的正常掉落为基础，从LV1之后，你击败的该怪物每提升1级，所有掉落物品的最大掉落数量+2。举例说明：神性史莱姆初始掉落为1-1个神性结晶，如果你击杀了L4的神性史莱姆，那么离开副本时，神性史莱姆的神性结晶变为1-6，其他掉落物的最大掉落数量也全部+6，然后根据当前的掉落率进行一次奖励结算，结算方式和怪物击杀掉落方式一样，根据最小和最大掉落数量随机。<br><br>传送去副本需要消耗一个时空碎片。<br>普通副本有：${Object.keys(dungeons).filter(e => dungeons[e].type === 1).join('，')}<br>无限副本有：${Object.keys(dungeons).filter(e => dungeons[e].type === 2).join('，')}<br>无限刷怪副本有：${Object.keys(dungeons).filter(e => dungeons[e].type === 3).join('，')}</p>`,
    '镶嵌物' : `<p>镶嵌物可以在镶嵌台镶嵌到有孔的装备中。镶嵌物的等级若高于装备等级，镶嵌后装备等级会提升到镶嵌物的等级，请特别注意这一点。所有怪物都会掉落镶嵌物，但是在怪物图鉴中看不到。每个怪物不会掉落等级高于自身等级的镶嵌物。镶嵌物的属性和掉落情况如下（以下不包括符文）：${inlays.filter(e => e.monsterItem).map(e => `</p><h5>${e.name}</h5><p>${getInlayText(e.name, true)}<br>爆率：${Object.keys(e.monsterItem).map(m => `${m}(${e.monsterItem[m].join('~')})`).join('，')}<br>`).join('<br>')}</p>`,
    '符文' : `<p>符文和一般镶嵌物有所不同，符文按照正确的顺序镶嵌，可以组成符文之语。所有怪物都会掉落符文，但是在怪物图鉴中看不到。每个怪物不会掉落等级高于自身等级的符文。符文的属性和掉落情况如下：${runes.map(e => `</p><h5>${e.name}(${e.text})</h5><p>${getInlayText(e.name, true)}<br>爆率：${Object.keys(e.monsterItem).map(m => `${m}(${e.monsterItem[m].join('~')})`).join('，')}<br>`).join('<br>')}</p>`,
    '符文之语' : `<p>首先：在镶嵌台中，如果你选中了一件装备，且该装备有对应孔数的符文之语，且该装备的所有孔都是空的，则可以直接在镶嵌台的查询符文之语按钮中，直接选中你想要的符文之语，不需要对照着顺序一个个镶嵌。当装备的孔数正好和某条符文之语的符文数量相同，则按照正确的顺序镶嵌符文后，可以组成符文之语。如果镶嵌顺序错误，或者装备孔数大于符文之语需要的符文数量，则无法组成符文之语。例如，一个符文之语需要3#符文+5#符文，你在一个3孔的装备上先前3#+5#，是不会组成符文之语的。并且，只有普通品质的装备才能组成符文之语，优秀及以上品质的装备即使按照正确的顺序镶嵌符文也无法制成符文之语。注意，符文之语的属性和镶嵌符文的属性不会叠加，但是符文之语的属性必定包含甚至高过符文本身的属性。符文之语列表如下：${Object.keys(runeWord).map(e => {
        return `</p><h5>${runeWord[e].name}(${runeWord[e].runes.length}孔)</h5><p>${runeWord[e].runes.map(r => `${r}(${runes.filter(ru => ru.name === r)[0].no}#)`).join('+')}${getRuneWordText(e)}<br>`;
    }).join('<br>')}</p>`,
    '战斗状态' : `<p>部分技能会使你或者怪物附加特殊状态，特殊状态有不同效果，例如每回合受到伤害，无法行动等。状态造成的伤害为绝对真实伤害，没有任何办法可以抵消。目前已有的状态如下：</p>${Object.keys(status).map(e => `<p>${e}${status[e].canAddNum ? '(持续回合数可叠加)' : ''}：${status[e].text}</p>`).join('')}`,
    '护盾' : `<p>护盾可以抵挡攻击和技能的伤害，但是无法抵挡状态造成的伤害。</p>`,
    '元素属性' : `<p>大多数素材都有元素属性，可以在图鉴中查看所有物品的元素属性。元素属性共有金木水火土极6中，代表的战斗属性分别为：金（攻击），木（吸血），水（耐久），火（生命），土（防御），极（减伤）。很明显可以看到，这会用于装备上或者战斗药剂之类的地方，但是这个版本还没有实际应用，因为工作量有点大，但是后续会有的，目前已有的想法有：元素实验室（已做，后续会继续增加配方），元素附魔（可能以DLC形式出现），矮人种族（大概率会做），以及更多连想法都还没有的相关功能</p>`,
    '世界BOSS' : `<p>世界BOSS不吃秒杀技能。打所有怪都有几率掉落牵引卷轴，使用牵引卷轴将触发和本地图的世界BOSS战。如果没打死世界BOSS便逃跑，下次进入世界BOSS战时，BOSS血量将保留为上一次的剩余血量，其他的属性和重新开始战斗没有任何区别。</p>`,
    '世界之力' : `<p>击杀世界BOSS会掉落世界之力物品，使用后获得对应的世界之力点数。世界之力点数可用于在流浪商人处购买物品。</p>`,
    '流浪商人' : `<p>流浪商人每月10号会在你家门口推销商品，可以用世界之力在流浪商人处购买商品，流浪商人会出售一些独有的商品。</p>`,
    '通关' : `<p>击败生命之神后视为通关，所有怪物将会变为神罚状态，怪物增加的属性相当于-100000神眷带来的神罚强度。</p>`,
    '周目' : `<p>游戏初始为1周目，1周目不会显示，二周目开始会在时间栏显示周目数。5级家的最终退路可以制造贤者之石，使用贤者之石可以进入下一周目，并获得（周目-1）*5个周目礼包，并且根据你曾经进入过的最高周目，创建新角色（挑战种族除外）时将获得（周目-1）*3个周目礼包。从2周目开始，怪物会获得等级*(周目-1)*3的自由属性点(以1级怪为例，2周目3点，3周目6点，4周目9点)，将随机加到以下4个属性上，括号里显示的是每点属性点对这个属性的增幅幅度：攻击（40%概率，1属性点=1攻击）/防御（30%概率，1属性点=1防御）/血量（20%概率，1属性点=1%血量，最少1）/吸血（10%概率，1属性点=0.5%吸血，但是向下取整，所以0.5%吸血=0吸血，2.5%吸血=2吸血）。进入下一周目时不可切换种族，种族自动变为当前种族的未觉醒初始种族，等级回到1级，地图全部重置，仓库物品全部消失（镶嵌物仓库保留），金币清空，你的护身符如果放在背包中，则可以被带入下一周目，除了护身符之外无法携带任何物品去下一周目。从2周目开始，每过1周目，所有种族每级获得的属性点额外+2，挑战种族也是如此
。即在2周目，正常种族升1级给3属性点，正常一转升1级给4属性点。通过例如神话之力、锻造出神话装备、戏命师转盘、世界庇佑死亡扣除的属性点等所有方式获得的额外属性点（无论正负）都会被带入下一周目。</p>`,
    '种族周目点数' : '<p>如果你有种族周目点数，在家里会出现一个种族周目商店，可以用种族周目点数购买物品。创建新角色时和跳周目都会获得该点数，获得点数数量的算法为：根据你各个种族的最大周目数，获取奖励，每有1个种族最大周目数+1，则奖励点数+1。例如：你的史莱姆最大周目3，人类最大周目5，总计就会获取(3-1)+(5-1)=6，这里的6称之为奖励点数。每次跳周目都会清空没有用的点数，然后重新发点数，所以不要保留，用掉吧</p>',
    '成就' : '<p>可以在系统中查看成就进度。每个角色的成就进度是独立的，但是成就一旦完成，则所有角色的该成就都会显示为完成状态。完成成就的角色会立刻获得成就奖励，在新创建角色时，会获得已完成的所有成就的奖励。</p>',
    '节日活动' : `<p>在现实当中的有些节日，游戏内会举行节日活动，活动时可能会在一些地形产生特殊的资源，出现特定的配方，如果该活动有节日怪物，则在任何地图的任何地形都可能出现节日怪物，节日怪物在任何地形都有1%概率刷新，节日怪物的属性固定为当前等级对应地图的世界BOSS的初始攻防，血量和经验为世界BOSS的十分之一，固定为精英怪物。节日结束后对应的怪物会直接从页面消失，如果和节日怪物战斗中退出游戏，下次进入游戏时如果节日活动已经结束，则会直接退出战斗，而不是继续战斗。有些活动还会有特定的节日商品，可以通过使用节日活动中获取的道具兑换商品，当一个节日有节日商品出售时，在家里会出现一个节日商店。在节日当天，还会有额外赠送的礼物，只要进入游戏即赠送。各个节日的活动情况如下：${festivals.map(e => `</p><h3>${e.name}</h3><p><h4>活动时间：</h4>${e.dateText}<br>${Object.keys(e.recipes).length > 0 ? `<h4>活动配方：</h4>${Object.keys(e.recipes).map(r => `${r}*${e.recipes[r].getNum}(${e.recipes[r].need ? e.recipes[r].need : facility4level[e.recipes[r].level].join('/')})=${Object.keys(e.recipes[r].items).map(it => `${it}*${e.recipes[r].items[it]}`).join(`+`)}`).join('<br>')}<br>` : ''}${Object.keys(e.monsters).length > 0 ? `<h4>活动怪物：</h4>${Object.keys(e.monsters).join(`，`)}<br>` : ''}${Object.keys(e.shop).length > 0 ? `<h4>节日商品：</h4>${Object.keys(e.shop).join(`，`)}<br>` : ''}${Object.keys(e.terrainElements).length > 0 ? `<h4>节日资源：</h4>${formatFestivalTerrainElements(e.terrainElements)}` : ''}<h4>节日赠礼：</h4>${e.giftDate.map(g => `${g.dateText}：${Object.keys(g.gifts).map(gi => `${gi}*${g.gifts[gi]}`).join('+')}`).join('<br>')}<br>`)}</p>`,
    '养成' : `<p>完成隐藏成就《灵魂吸引》后解锁养成玩法。使用神秘印记后，无论你在哪个地图的家门口，都能看到一个随机名字的小女孩，你可以给他食物，礼物，也可以跟她说话，或者赶走她。她是需要吃喝的，而且只能你给她喂，固定${eduCfgs.maxHunger}食物上限和${eduCfgs.maxWater}水分上限，每${eduCfgs.reduceMin}分钟减少一次饥饿和水分，每次固定减少${eduCfgs.reduceOnce}点，但是夏天水分消耗翻倍。只有饥饿和水分在80以下时才能喂食，如果饿了或者渴了（对应状态小于${eduCfgs.needNum}点），她会主动告诉你，但是在一次饥饿或口渴状态中只会跟你说一次。喂食的话，无论喂食的东西加多少饥饿或水分，只要能加饥饿，就会将饥饿补满，水分也是如此。好感度越高说的话越亲密。她有喜欢的食物和讨厌的食物，且都不止一个，每个养成角色都是随机的，送喜欢的食物+5好感度，送讨厌的食物-10好感度，送其他食物+1好感度，每有1天没跟她说话-1好感度，喂食是唯一增加好感度的方法。当她饥饿或水分降低到0，则死亡。当她好感度降低到0，则会离开。当你跳周目时，她会跟你一起进入下一个周目。当她还存在时，你无法使用神秘印记。当她死亡或者离开了，你可以再次使用神秘印记，但是下次来的就是另一个人了。更多设定请自行摸索。提示：赠送物品不会增加好感度，无论送什么，送多少。当满足要求后，养成人物就会送你护身符，护身符只有在送你的养成人物还活着且没离开时才会生效，如果死亡了或者离开了，那么计算你重新用神秘印记召唤另一个养成人物，就算名字一样，以前的护身符也会失效了，但是新养成人物会重新送你护身符。可获得的护身符如下：</p>${eduMakeItems.map(e => `<p><b>${e.name}</b><br>需要好感度：${e.friendliness}<br>需要物品：${e.items.join('+')}</p>`).join('')}`,
    '养成剧情' : `<p>养成人物满足一定条件后，将触发相关剧情，剧情HappyEnd后，跟随你时将不会再额外吸引怪物攻击你，同时将解锁自动吃喝功能，即当你让养成角色跟随你时，当你的饥饿值或水分值低语某个值时，在时间流逝后将自动吃喝，自动吃喝规则如下：如果你的快捷栏第一格是可食用的食物，且会增加饥饿值，则当你损失的饥饿值高于该物品增加的饥饿值时，她会喂你吃1个快捷栏1的物品。如果是一次性消耗了大量饥饿，例如睡觉后触发自动给吃东西，则会直接吃到消耗的饥饿低于该食物可以补充的饥饿为止。当你的快捷栏2放的是加水份的食物，则水分低于该物品加的水分时，她会喂你吃快捷栏2的物品。如果快捷栏1的物品加水分，则自动吃快捷栏2的物品时，会预留快捷啦1水分增加物品的值，避免浪费（举例：快捷栏1是鱼汤，2是水，你睡觉后，饥饿剩余21/100，水分剩余0/100，则自动吃1个鱼汤，4个水，饥饿变成61/100，水分变成70/100，预留了30水分的空间，避免下次吃鱼汤时水分溢出导致浪费）。当她跟随你时，如果饿了，会优先吃快捷栏3的物品，如果该物品不存在或者不补充饥饿，则会吃快捷栏1的物品。如果渴了同理，会优先吃快捷栏3，然后快捷栏2。HappyEnd后也请注意多和她说话，如果好感度降为0，她还是会离开的，而且就算再使用神秘印记也无法将她找回来了，因为剧情已经结束了，原因剧情末尾能看到。</p>`,
    '跟随' : '<p>当养成人物的好感度达到亲密后（好感度是隐藏值，你看不到，只能通过对话的亲密程度来判断）可以邀请她跟随你，跟随后无论你走到哪里，她都会跟着你在哪里，方便喂食和对话。当她跟随你时，怪物攻击你将无视等级差，即使你去低级地图也会被怪物攻击，且怪物攻击你将无视自身的日夜限制。</p>',
    '本土居民' : `<p>游戏加入了初步的NPC系统，目前NPC系统还在持续开发中。除了神界，其他每个地图都会刷出NPC。目前点击NPC可以看到NPC说的话，可以和NPC交易，但是不能战斗、接任务等。NPC会移动，在移动时有可能直接消失（可以理解为离开这个地图了或者回家了），也可能有新的NPC进入当前地图。当前地图NPC数量少于NPC最少数量时，必然增加NPC，如果大于最大NPC数量，则必然减少NPC，每个地图最少存在${npcCfg.minNum}个NPC，最多存在${npcCfg.maxNum}个NPC，第一次进入某个地图时，会在最小数量和最大数量中随机一个数量，刷出对应数量的NPC。当前版本NPC种类比较少，只有“${Object.keys(npcCfg.types).join('、')}”，后续会有很多种类的。</p>`,
    '居民交易' : `<p>你可以和NPC交易，NPC在移动时会随机进行采集或者战斗。采集时会随机NPC当前所在地形可以刷出的一个资源，获得将这个资源完全采集可以获得的物品（例如随机到的是浆果丛，就会模拟采集5次浆果丛，并获得模拟采集获得的所有物品）。战斗会触发随机一个NPC所在地形会刷出的位阶不高于NPC位阶的怪物，关于NPC的位阶请参考“图鉴-说明-居民战斗”，并像玩家战胜这个怪物时一样，获得改怪物掉落的物品，但是只会获得正常掉落的物品，不会获得额外掉落的物品。每个NPC都拥有随机数量的金币，交易时，玩家出售物品给NPC时，NPC需要有足够的钱才能购买玩家出售的物品，并且玩家出售后，NPC持有的金币会对应的减少。NPC采集或打怪获得的物品，会出现在NPC的货物列表里，玩家可以购买这些物品，购买花费的金币会加在NPC的持有金币上，NPC出售的物品售价至少为1金币。NPC出售的物品价格为物品价值的80%，即8折购物，出售物品时的价格为物品价值的25%（次元交易所时20%，相当于涨价四分之一）。你出售给NPC的物品，会出现在NPC的出售列表里。</p>`,
    '居民战斗' : `<p>NPC创建时会随机一个位阶，随机方式为先随机1-100的数字，随机出1则为神话，随机出2-10则为传说，11-30为精英，大于30为普通。4个位阶对应怪物的4个位阶。当和NPC触发战斗时，NPC会根据当前地图的等级区间，在这个等级区间内随机一个和自己位阶相同的怪物，作为基础模板。如果没有和自己位阶相同的怪物，向更高位阶取怪物。如果一直到神话都找不到怪物，则会在等级范围内所有位阶寻找怪物。<br><br>假设：你在孤岛和一个普通位阶的NPC触发战斗，则会随机一个1-10级的普通怪物作为基础模板，找不到1-10级的普通怪物（这当然不可能，但是设计里对这个情况做了处理），则会在1-10级的精英怪物里随机，还没找到则会在传说怪里随机，最后是神话怪。如果都没找到，则会在所有1-10级的怪物里随机。需要注意，这里随机的怪物不包含克系怪物。<br><br>随机到的怪物模板，血量、攻击、防御、吸血、经验都会随机提高50%~100%（并非5个属性都固定，可能攻击提高60%，血量提高72%这样），作为NPC的属性面板。<br><br>NPC拥有随机的职业，不同职业的NPC拥有不同的技能，而你无法得知NPC的职业，只能等他使用技能时才能根据技能判断。可能存在的职业有：${createNpcCfg().profession.join('，')}。你可以在怪物图鉴中搜索职业名，来查看这些职业的技能。<br><br>和NPC战斗后，无论胜利还是逃跑，NPC都会从地图上消失，赢了自然是你杀死了他，逃跑了他也就回去汇报情况了。如果是你主动发起进攻，那么无论发起进攻的一瞬间，你将获得1点罪恶值，该罪恶值会参与NPC的属性波动计算。如果是NPC主动攻击你，你击杀了他才会获得罪恶值，没击杀的话不获得罪恶值。每提高1点罪恶值，你在遇到NPC时，将有1%概率被NPC主动攻击。当你有100点以上罪恶值，你将被遭遇到的所有NPC主动攻击，也就是说，你无法再和NPC发生其他交互了。NPC随机属性时，会根据基础模板增幅50%~100%，而你每拥有1点罪恶值，该增幅提高1%，例如你有15点罪恶值，那么随机增幅范围将变为65~105%。罪恶值在跳周目时将会清0。<br><br>战斗胜利除了经验，还会获得一个神恩口袋，神恩口袋里装有这个NPC携带的金币和交易时你可以购买的物品，使用神恩口袋后获得。</p>`,
    '古神入侵' : '<p>贤者之石扭曲时空的波动吸引了一群不可描述的存在的注意，2周目开始，怪物可能会扭曲，导致理智降低，拥有克苏鲁学识后有几率触发灵感触动，遭遇克系怪物。</p>',
    '怪物扭曲' : '<p>从2周目开始，玩家和等级低于自己10级以内的怪物战斗时（即32级玩家，在和22级以及更高等级的怪物战斗时），可能遭遇被古神的力量扭曲的怪物，2周目遭遇的概率为1%，，每提高1周目，遭遇概率增加1%。扭曲的怪物和普通怪物完全一样，无法分辨，但是当该怪物死亡时，会进入扭曲形态，血量完全恢复且清除自身所有状态，血量上限提高3倍，攻击力提高“等级*3*倍率”，防御力提高“等级*2*倍率”，倍率为：神话5，传说3，精英2，普通1。在这里我们将倍率称之为n，为了方便后续的说明。遭遇不可描述的怪物将进行一次克苏鲁学识检定，检定不通过将减少理智，减少的量为“nd6”（即相当于投掷n个6面骰，例如普通怪物将随机减少1-6点理智，精英2-12点，传说3-18点，神话5-30点。NdX这种格式的写法以后可能还会用到，所以不了解的建议百度了解一下）</p>',
    '理智值' : '<p>理智值在1周目不会减少，所以也不会产生作用。每当回合结束时，你都需要进行一次理智检定，检定不通过则陷入疯狂状态，疯狂状态下无法行动。检定使用你的现有理智值进行。当你的理智小于等于0，你将直接死亡。当你的理智上限小于等于0，无论是什么难度，即使是新手和简单难度，也将陷入永恒的疯狂，直接彻底死亡删档</p>',
    '克苏鲁学识' : '<p>克苏鲁学识不会直接显示在属性中。每获得1点克苏鲁学识，则理智上限-1，即可以认为克苏鲁学识=100-理智上限。例如理智上限为78时，克苏鲁学识为22。每1点克苏鲁学识在进行攻击时，可以提供1%的攻击加成，最少1点。例如你有22点克苏鲁学识，你本次造成的攻击为3时，增加22点攻击，最终攻击为25.如果你本次攻击为1000，则增加220点攻击，最终攻击1220点。</p>',
    '旧日笔记' : '<p>在击杀扭曲的怪物时，有几率(1周目0%，即污染者1周目打扭曲怪物也不会掉旧日笔记，之后每提高1周目，爆率提高1%)掉落旧日笔记，触发掉落时，最少掉落1个，最多掉落（神话5，传说3，精英2，普通1）个。每使用一本旧日笔记，可获得1d4点克苏鲁学识，要注意的是，克苏鲁学识获取后无法以任何方式遗忘，跳周目也不行，简单难度的复活也不行，即你的理智上限将永远减少，无法恢复。</p>',
    '检定' : '<p>古神入侵相关玩法中会出现一些“检定”相关的操作。所谓的检定，是会投一个1d100骰子（即随机1-100的整数），当投出来的点数小于等于你检定的这项属性的值时，则检定成功，否则检定失败。例如：进行一次克苏鲁学识检定，你此时有15点克苏鲁学识，然后进行1d100的检定，投出的点数为22，则检定失败。投出了12，则检定成功。检定如果没有特别说明，则为普通检定，和上述检定方式一样。检定还可能遇到困难检定和极难检定，困难检定会讲检定属性变为1/2后再进行判断，极难检定会变为1/5。例如：你有50点克苏鲁学识，那么进行普通检定时，投出1-50都算检定通过。困难检定时，必须投出1-25才算通过，极难检定必须投出1-10才算通过。如果属性取1/2或者1/5时不为整数，则向下取整。检定时可能会出现奖励骰或者惩罚骰，奖励骰和惩罚骰的相关设定建议百度，这里不做大篇幅说明了。</p>',
    '灵感触动' : `<p>当你拥有克苏鲁学识后，在时间流逝时，会进行一次克苏鲁学识的检定。如果检定通过，在地图上会出现一个“灵感触动”元素，点击该元素，可能获得一些物品，包括一些你还没去过的后面地图的克系怪物才会掉落的物品,部分物品要获得的话有克苏鲁学识的要求。也可能触发一场战斗，触发战斗的怪物等级不会超过当前地图的最高等级。获取物品时，根据物品的不同，将有可能减少理智值。触发战斗时，该怪物不会显示扭曲字样，也不会有额外的旧日笔记掉落，但是会该怪物直接获得扭曲怪物的属性加成，你也会扣除对应的理智值（即你在图鉴看到的怪物属性只是初始数据，实际上会按照怪物扭曲规则进行扭曲增强）,而这些怪物死亡时不会再出现扭曲。</p><h4>可能触发战斗的怪物如下：</h4><p>${inspirationStruckList.battle.join('，')}</p><br><br><h4>可能获得的物品如下：</h4><p>${inspirationStruckList.get.map(e => `<h5>${e.name}</h5>需要克苏鲁学识：${e.inspiration}<br>获得时降低理智：${e.reduceSan}`).join('<br><br>')}</p>`,
    '古神祭坛' : '<p>2周目开始，0级家解锁，可以将有吸引值的物品献祭，以换取吸引值，吸引值全存档通用，你可以用一个存档专门刷吸引值</p>',
    '扭曲熔炉' : '<p>2周目开始，0级家解锁，可以消耗吸引值进行祈祷，使未知的存在被吸引来，为你的装备附加扭曲属性。根据装备等级和品质不同，消耗的吸引值也不同，获得的属性条目数量和随机范围也不同。白色品质装备，消耗的吸引值为扭曲等级的立方*3，扭曲等级的算法为：装备等级/10+1，例如7级装备的扭曲等级是1级，30级装备的扭曲等级是4级。优秀品质消耗*2，精良*3，传说*4，神话*5。普通品质随机生成1个词条，品质每提高一级，可生成词条+1，神话品质随机生成5个词条。生成的词条可能是相同属性的，例如神话可能生成5条加攻击的词条，或者5条加防御的词条。后面的词条随机范围中，我们将扭曲等级称为n，周目数-1称为X，同时将nd?视为一个数字，例如当我们看到nd6*X*5,那么应该看成(nd6)*X*5。可生成的词条属性为：攻击（nd6*X），防御（nd6*X），吸血（nd4），减伤（n/2+1），耐久（nd20*X*3），生命（nd20*X*3）</p>',
    '旧日、外神和古神' : '<p>这部分还没做，因为很难设计。和旧日、外神和古神战斗时无法以正常方式逃跑，也无法使用短程传送卷轴，因为你无法逃脱他们的注视。但是如果装备了旧印，则可以逃跑和使用短程传送卷轴，他们将不再对你紧追不舍。</p>',
};
