//节日列表
const festivals = [
    {
        //节日名
        name : '双蛋活动',
        //节日日期文本
        dateText : '12月23日~1月3日',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '1',
            date : '1225',
            text : '圣诞节快乐！',
            dateText : '12月25日',
            gifts : {
                圣诞礼炮 : 20
            }
        },{
            dateType : '1',
            date : '0101',
            text : '元旦快乐！',
            dateText : '1月1日',
            gifts : {
                汤圆 : 20
            }
        }],
        //节日日期
        date : ['1223','1224','1225','1226','1227','1228','1229','1230','1230','1231','0101','0102','0103'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {
            '面粉' : createRecipesCfg({'小麦' : 2}, 1, '厨房'),
            '汤圆' : createRecipesCfg({'面粉' : 3,'水' : 2, '芝麻' : 1}, 1, '厨房'),
        },
        //节日元素
        elements : {
            '小麦丛' : new Element({canGather :true, mopUp : true, time : 2, num : 3, day : 3, getItem : [{name : '小麦',minNum : 1, maxNum : 3}], text : '节日活动专属资源'}),
            '芝麻丛' : new Element({canGather :true, mopUp : true, time : 2, num : 3, day : 3, getItem : [{name : '芝麻',minNum : 1, maxNum : 3}], text : '节日活动专属资源'}),
            '圣诞树' : new Element({canGather :true, time : 20, num : 10, day : 5, canHand : true, needItem : ['木斧','石斧','铁斧'], getItem : [{name : '木材',minNum : 2, maxNum : 3},{name : '树枝',minNum : 1, maxNum : 3},{name : '圣诞彩灯',minNum : 1, maxNum : 3}], text : '节日活动专属资源'}),
            '芝麻' : new Element({text : '节日活动专属物品'}),
            '小麦' : new Element({text : '节日活动专属物品'}),
            '面粉' : new Element({text : '节日活动专属物品'}),
            '汤圆' : new Element({canUse : true, battleUse : true, hunger : 50, water : 10, hp : 50, voidDust : 10, gold : 50, text : '节日活动专属物品'}),
            '圣诞彩灯' : new Element({weight : 0, text : '节日活动专属物品，用于节日商店购买物品'}),
            '圣诞礼物' : new Element({canUse : true, weight : 0,func(){
                    const num = getNumByBag('圣诞礼物');
                    if(num > 1){
                        addItem('圣诞彩灯', randomNum(3 * num, 5 * num))
                        reduceItem('圣诞礼物', num - 1);
                    }else{
                        addItem('圣诞彩灯', randomNum(3, 5))
                    }
                    return true;
                }, text : '节日活动专属物品，用于节日商店购买物品，直接使用可以获得3-5个圣诞彩灯,使用时会直接用掉背包中所有的圣诞礼物'}),
            '圣诞礼炮' : new Element({isThrow : true, endurance : 1, voidDust : 20, gold : 100, throwFunc(){
                    addStatus(data.battleMonster, getStatus('圣诞快乐'))
                },
                myAtk : function(){
                    return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * (1 + (data.battleMonster ? getStatuNum(data.battleMonster, '圣诞快乐') * 0.2 : 0)))
                },
                text : '节日活动专属物品，投掷伤害等于玩家的攻击力+装备武器的攻击力，并给怪物附加圣诞快乐状态，该状态不会自动消失。怪物每有一层圣诞快乐状态，投掷伤害增加20%'}),
        },
        //节日怪物
        monsters : {
            '圣诞麋鹿' : {
                items : [{name : '圣诞礼物',minNum : 1, maxNum : 1}],
                skills : [{
                    name : '雪橇漂移',
                    type : 'atk',
                    text : '10%概率使用，使用装礼物的雪橇进行攻击，造成1.5倍伤害，但是车上的礼物被甩了下来，玩家可以获得1~3个圣诞彩灯，玩家通过这种方式获得的圣诞彩灯不能超过怪物等级/10*5个',
                    getStatus : function(){
                        let addNum = randomNum(1,3);
                        const max = parseInt(data.battleMonster.level / 10 * 5);
                        if(!data.battleMonster.sendItem){
                            data.battleMonster.sendItem = 0;
                        }
                        if(data.battleMonster.sendItem > 0){
                            if(data.battleMonster.sendItem + addNum > max){
                                addNum = max - data.battleMonster.sendItem;
                            }
                        }

                        if(addNum > 0){
                            data.battleMonster.sendItem += addNum;
                            addItem('圣诞彩灯', addNum)
                            addBattleLog(`雪橇上的礼物掉下来了，你获得了${addNum}个圣诞彩灯`)
                        }
                        return null
                    },
                    check : function(){return randomNum(1, 100) <= 10},
                    getNum : function(){return parseInt(data.battleMonster.atk * 1.5)},
                }]
            }
        },
        //节日商定专属商品
        shop : {
            '圣诞礼炮' : {
                '圣诞彩灯' : 10,
                '圣诞礼物' : 1,
            },
        },
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {
            '草原' : {
                elements : {
                    ...terrainElement('小麦丛', [1,3], 5),
                    ...terrainElement('芝麻丛', [1,3], 5),
                }
            },
            '丘陵' : {
                elements : {
                    ...terrainElement('小麦丛', [1,3], 5),
                    ...terrainElement('芝麻丛', [1,3], 5),
                }
            },
            '森林' : {
                elements : {
                    ...terrainElement('圣诞树', [1,3], 5),
                }
            },
        },
    },
    {
        //节日名
        name : '春节活动',
        //节日日期文本
        dateText : '农历腊月廿八~正月初八',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '2',
            date : '0101',
            text : '新年快乐！',
            dateText : '正月初一',
            gifts : {
                大红包 : 100
            }
        }],
        //节日日期
        date : ['1228','1229','1230','0101','0102','0103','0104','0105','0106','0107','0108'],
        //日期类型，1=公历，2=农历
        dateType : '2',
        //节日配方
        recipes : {
            '面粉' : createRecipesCfg({'小麦' : 2}, 1, '厨房'),
            '饺子皮' : createRecipesCfg({'面粉' : 10,'水' : 3}, 1, '厨房', 5),
            '冬笋馅' : createRecipesCfg({'冬笋' : 5,'肉' : 10}, 1, '厨房', 5),
            '野菜馅' : createRecipesCfg({'野菜' : 10,'肉' : 10}, 1, '厨房', 5),
            '蘑菇馅' : createRecipesCfg({'蘑菇' : 10,'肉' : 10}, 1, '厨房', 5),
            '冬笋饺子' : createRecipesCfg({'冬笋馅' : 5,'饺子皮' : 5,'水' : 5}, 1, '厨房', 5),
            '野菜饺子' : createRecipesCfg({'野菜馅' : 5,'饺子皮' : 5,'水' : 5}, 1, '厨房', 5),
            '蘑菇饺子' : createRecipesCfg({'蘑菇馅' : 5,'饺子皮' : 5,'水' : 5}, 1, '厨房', 5),
        },
        //节日元素
        elements : {
            '小麦丛' : new Element({canGather :true, mopUp : true, time : 2, num : 3, day : 3, getItem : [{name : '小麦',minNum : 1, maxNum : 3}], text : '节日活动专属资源'}),
            '竹林' : new Element({canGather :true, mopUp : true, time : 10, num : 10, day : 5, getItem : [{name : '冬笋',minNum : 0, maxNum : 2}], text : '节日活动专属资源'}),
            '野菜丛' : new Element({canGather :true, mopUp : true, time : 5, num : 1, day : 3, getItem : [{name : '野菜',minNum : 1, maxNum : 1}], text : '节日活动专属资源'}),
            '小麦' : new Element({text : '节日活动专属物品'}),
            '面粉' : new Element({text : '节日活动专属物品'}),
            '饺子皮' : new Element({text : '节日活动专属物品'}),
            '冬笋' : new Element({text : '节日活动专属物品'}),
            '野菜' : new Element({text : '节日活动专属物品'}),
            '冬笋馅' : new Element({text : '节日活动专属物品'}),
            '野菜馅' : new Element({text : '节日活动专属物品'}),
            '蘑菇馅' : new Element({text : '节日活动专属物品'}),
            '冬笋饺子' : new Element({canUse : true, battleUse : true, weight : 5, voidDust : 20, gold : 100, func(){
                    const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
                    let text = `你吃了1个冬笋饺子，恢复${battleAddHp(data, addHp)}HP`;
                    if(data.battleMonster && !data.battleMonster.cjz){
                        data.battleMonster.cjz = true;
                        let number = parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 0.2);
                        data.atk += number;
                        text += '，攻击力提高' + number
                    }
                    addBattleLog(text)
                    return true;
                },
                myHp : function(){
                    let num = parseInt(data.maxHp * 0.05);
                    if(num < 50){
                        num = 50;
                    }
                    return num;
                },
                text : '节日活动专属物品，回复5%生命值，最少50点。如果是在战斗中使用，则增加20%攻击力(人物攻击+武器攻击总和的20%)，但是只有吃的第一个饺子才会获得属性加成，后面吃的饺子不会再获得属性加成，即使是吃其他馅的饺子也不会获得加成'
            }),
            '野菜饺子' : new Element({canUse : true, battleUse : true, weight : 5, voidDust : 20, gold : 100, func(){
                    const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
                    let text = `你吃了1个野菜饺子，恢复${battleAddHp(data, addHp)}HP`;
                    if(data.battleMonster && !data.battleMonster.cjz){
                        data.battleMonster.cjz = true;
                        let number = parseInt(data.def * 0.2);
                        data.def += number;
                        text += '，防御力提高' + number
                    }
                    addBattleLog(text)
                    return true;
                },
                myHp : function(){
                    let num = parseInt(data.maxHp * 0.05);
                    if(num < 50){
                        num = 50;
                    }
                    return num;
                },
                text : '节日活动专属物品，回复5%生命值，最少50点。如果是在战斗中使用，则增加20%防御力，但是只有吃的第一个饺子才会获得属性加成，后面吃的饺子不会再获得属性加成，即使是吃其他馅的饺子也不会获得加成'
            }),
            '蘑菇饺子' : new Element({canUse : true, battleUse : true, weight : 5, voidDust : 20, gold : 100, func(){
                    const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
                    let text = `你吃了1个蘑菇饺子，恢复${battleAddHp(data, addHp)}HP`;
                    if(data.battleMonster && !data.battleMonster.cjz){
                        data.battleMonster.cjz = true;
                        data.suck += 20;
                        text += '，吸血提高20%'
                    }
                    addBattleLog(text)
                    return true;
                },
                myHp : function(){
                    let num = parseInt(data.maxHp * 0.05);
                    if(num < 50){
                        num = 50;
                    }
                    return num;
                },
                text : '节日活动专属物品，回复5%生命值，最少50点。如果是在战斗中使用，则增加20%吸血，但是只有吃的第一个饺子才会获得属性加成，后面吃的饺子不会再获得属性加成，即使是吃其他馅的饺子也不会获得加成'
            }),
            '福到万家' : new Element({battleUse : true, weight : 0, voidDust : 0, gold : 0, func(){
                    if(data.battleMonster && !data.battleMonster.fdwj){
                        const addHp = (this.myHp ? this.myHp() : elementCfgs[this.name].myHp());
                        let text = `你使用了福到万家，恢复${battleAddHp(data, addHp)}HP`;
                        data.battleMonster.fdwj = true;
                        let addAtk = parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 0.5);
                        let addDef = parseInt(data.def * 0.5);
                        if(addAtk > 200){
                            addAtk = 200;
                        }
                        if(addDef > 200){
                            addDef = 200;
                        }
                        data.atk += addAtk;
                        data.def += addDef;
                        text += `，攻击力提高${addAtk}，防御力提高${addDef}`;
                        addBattleLog(text)
                        return true;
                    }else{
                        winMsg('你已经使用过福到万家了', false, false)
                        return false;
                    }
                },
                myHp : function(){
                    return data.maxHp;
                },
                text : '节日活动专属物品，回复100%生命值，且攻击力(人物攻击+武器攻击总)和防御力提高50%(最多200点)，每场战斗只能使用一次'
            }),
            '大红包' : new Element({canUse : true, weight : 0, voidDust : 0, gold : 0, func(){
                    const num = getNumByBag('大红包');
                    if(num > 1){
                        const items = {};
                        const arr = '门迎百福人财旺户纳千祥阖家欢'.split('');
                        for(let i = 0 ; i < num ; i++){
                            const random = arr.getRandom();
                            if(!items[random]) {
                                items[random] = 0;
                            }
                            items[random]++;
                        }

                        Object.keys(items).forEach(e => {
                            addItem(e, items[e]);
                        })
                        reduceItem('大红包', num - 1);
                    }else{
                        addItem('门迎百福人财旺户纳千祥阖家欢'.split('').getRandom())
                    }
                    return true;
                },
                text : '节日活动专属物品，使用时一次打开背包中所有大红包。打开大红包可以获得“门迎百福人财旺”“户纳千祥阖家欢”这14个字中的随机1个字，也可以用于在节日商店直接购买指定的字'
            }),
            ...getBatchItem('门迎百福人财旺户纳千祥阖家欢'.split(''), new Element({canUse : true, weight : 0, voidDust : 0, gold : 0, func(){
                    let min = 99999999999999;
                    let flag = true;
                    '门迎百福人财旺户纳千祥阖家欢'.split('').forEach(e => {
                        const num = getNumByBag(e, data.location.join() === data.world.home.location.join())
                        if(num > 0){
                            if(num < min){
                                min = num;
                            }
                        }else{
                            flag = false;
                        }
                    })
                    if(flag){
                        '门迎百福人财旺户纳千祥阖家欢'.split('').forEach(e => {
                            reduceItemByAll(e, min)
                        })
                        addItem('福到万家', min)
                        winMsg(`你凑齐了${min}组对联，获得${min}个福到万家`)
                        return true;
                    }else{
                        winMsg('你还没有凑齐对联', false, false)
                        return false;
                    }
                },
                text : '当背包和仓库中凑齐了“门迎百福人财旺”“户纳千祥阖家欢”这14个字时，则组成一组对联。使用任意一个字，将消耗掉这一组对联，并获得1个[福到万家]。如果凑齐了多组对联，使用时会全部兑换为[福到万家]'
            }))
        },
        //节日怪物
        monsters : {
            '年兽' : {
                items : [{name : '大红包',minNum : 3, maxNum : 3}],
                skills : [{
                    name : '恭喜发财',
                    type : 'atk',
                    text : '10%概率使用，造成1.5倍伤害，使用时玩家可以获得1个大红包，玩家通过这种方式获得的大红包不能超过怪物等级/10*3个',
                    getStatus : function(){
                        let addNum = 1;
                        const max = parseInt(data.battleMonster.level / 10 * 3);
                        if(!data.battleMonster.sendItem){
                            data.battleMonster.sendItem = 0;
                        }
                        if(data.battleMonster.sendItem > 0){
                            if(data.battleMonster.sendItem + addNum > max){
                                addNum = max - data.battleMonster.sendItem;
                            }
                        }

                        if(addNum > 0){
                            data.battleMonster.sendItem += addNum;
                            addItem('大红包', addNum)
                            addBattleLog(`你获得了${addNum}个大红包`)
                        }
                        return null
                    },
                    check : function(){return randomNum(1, 100) <= 10},
                    getNum : function(){return parseInt(data.battleMonster.atk * 1.5)},
                }]
            }
        },
        //节日商定专属商品
        shop : {
            '门' : {
                '大红包' : 20,
            },
            '迎' : {
                '大红包' : 20,
            },
            '百' : {
                '大红包' : 20,
            },
            '福' : {
                '大红包' : 20,
            },
            '人' : {
                '大红包' : 20,
            },
            '财' : {
                '大红包' : 20,
            },
            '旺' : {
                '大红包' : 20,
            },
            '户' : {
                '大红包' : 20,
            },
            '纳' : {
                '大红包' : 20,
            },
            '千' : {
                '大红包' : 20,
            },
            '祥' : {
                '大红包' : 20,
            },
            '阖' : {
                '大红包' : 20,
            },
            '家' : {
                '大红包' : 20,
            },
            '欢' : {
                '大红包' : 20,
            },
        },
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {
            '草原' : {
                elements : {
                    ...terrainElement('野菜丛', [3,5], 7),
                    ...terrainElement('小麦丛', [1,3], 5),
                }
            },
            '丘陵' : {
                elements : {
                    ...terrainElement('野菜丛', [3,5], 7),
                    ...terrainElement('小麦丛', [1,3], 5),
                }
            },
            '河滩' : {
                elements : {
                    ...terrainElement('野菜丛', [3,5], 7),
                }
            },
            '森林' : {
                elements : {
                    ...terrainElement('竹林', [1,3], 5),
                }
            },
            '山脉' : {
                elements : {
                    ...terrainElement('竹林', [1,3], 5),
                }
            },
        },
    },
    {
        //节日名
        name : '情人节活动',
        //节日日期文本
        dateText : '2月12日~2月16日',
        //赠送礼物的时间和赠送的礼物
        giftDate : [{
            dateType : '1',
            date : '0214',
            text : '祝有情人终成眷属！',
            dateText : '2月14日',
            gifts : {
                爱神羽翼 : 100
            }
        }],
        //节日日期
        date : ['0212','0213','0214','0215','0216'],
        //日期类型，1=公历，2=农历
        dateType : '1',
        //节日配方
        recipes : {
            '秘银锭' : createRecipesCfg({'秘银' : 20}, 1, '熔炉'),
            '巧克力' : createRecipesCfg({'可可豆' : 50}, 1, '厨房'),
            '戒托' : createRecipesCfg({'秘银锭' : 10}, 1),
            '灵魂晶核' : createRecipesCfg({'灵魂结晶' : 1000}, 1),
            '白水晶戒指' : createRecipesCfg({'戒托' : 1, '神性结晶' : 1}, 1),
            '紫水晶戒指' : createRecipesCfg({'戒托' : 1, '神性紫晶' : 1}, 1),
            '灵晶戒指' : createRecipesCfg({'戒托' : 1, '灵魂晶核' : 1}, 1),
        },
        //节日元素
        elements : {
            '可可树' : new Element({canGather :true, time : 20, num : 10, day : 5, canHand : true, needItem : ['木斧','石斧','铁斧'], getItem : [{name : '木材',minNum : 2, maxNum : 3},{name : '树枝',minNum : 1, maxNum : 3},{name : '可可豆',minNum : 3, maxNum : 5}], text : '节日活动专属资源'}),
            '可可豆' : new Element({text : '节日活动专属物品'}),
            '爱神羽翼' : new Element({weight : 0, text : '节日活动专属物品，用于节日商店兑换物品'}),
            '秘银' : new Element({text : '节日活动专属物品'}),
            '秘银锭' : new Element({text : '节日活动专属物品'}),
            '灵魂晶核' : new Element({text : '节日活动专属物品'}),
            '巧克力' : new Element({canUse : true, hunger : 10, voidDust : 5, gold : 25, text : '节日活动专属物品，送给好感达到亲密的养成人物，如果是该养成人物第一次收到，则增加1000好感度。需要注意，只有好感达到亲密后送巧克力才会增加好感度，没达到亲密送了也白送，而且以后再送也不会加好感度了'}),
            '戒托' : new Element({text : '节日活动专属物品'}),
            '白水晶戒指' : new Element({battleUse : true, voidDust : 0, gold : 0, weight : 10, func(){
                    const name = '白水晶戒指';
                    if(!data.edu || !data.edu.over || !data.edu.follow){
                        winMsg('养成人物以HappyEnd完成剧情且跟随你时才能使用', false, false)
                        return false;
                    }
                    if(!data.edu.items.includes(name)){
                        winMsg('你没有送她这个戒指', false, false)
                        return false;
                    }
                    if(data.battleMonster.syjz){
                        winMsg('你已经使用过戒指了', false, false)
                        return false;
                    }

                    if(hasStatus(data.battleMonster, '封印')){
                        winMsg('对方已经被封印', false, false);
                        return false;
                    }
                    addStatus(data.battleMonster, getStatus('封印', {num : 5}))
                    addBattleLog(`你使用了${name}，${data.battleMonster.showName || data.battleMonster.name}获得了封印状态`)

                    data.battleMonster.syjz = true;
                    //渲染战斗页面
                    renderBattlePage();
                    //本回合结束，存档记录
                    save();
                    return false;
                }, text : '节日活动专属物品，只有给养成人物送了相同的戒指后才能使用，只能送给养成人物一种戒指（送了草编戒指也不能送节日活动的戒指了），养成人物以HappyEnd完成剧情且跟随你时才能使用，每场战斗只能使用一次，使用戒指不占用回合数，使用后戒指也不会消失，可以无限次数使用。给怪物增加封印状态，持续5回合'}),
            '紫水晶戒指' : new Element({battleUse : true, voidDust : 0, gold : 0, weight : 10, func(){
                    const name = '紫水晶戒指';
                    if(!data.edu || !data.edu.over || !data.edu.follow){
                        winMsg('养成人物以HappyEnd完成剧情且跟随你时才能使用', false, false)
                        return false;
                    }
                    if(!data.edu.items.includes(name)){
                        winMsg('你没有送她这个戒指', false, false)
                        return false;
                    }
                    if(data.battleMonster.syjz){
                        winMsg('你已经使用过戒指了', false, false)
                        return false;
                    }

                    const num = parseInt(data.battleMonster.def * 0.2)
                    data.battleMonster.def -= num;
                    data.def += num;
                    addBattleLog(`你使用了${name}，${data.battleMonster.showName || data.battleMonster.name}的防御力减少了${num}，你的防御力增加了${num}`)

                    data.battleMonster.syjz = true;
                    //渲染战斗页面
                    renderBattlePage();
                    //本回合结束，存档记录
                    save();
                    return false;
                }, text : '节日活动专属物品，只有给养成人物送了相同的戒指后才能使用，只能送给养成人物一种戒指（送了草编戒指也不能送节日活动的戒指了），养成人物以HappyEnd完成剧情且跟随你时才能使用，每场战斗只能使用一次，使用戒指不占用回合数，使用后戒指也不会消失，可以无限次数使用。减少对方20%的防御力，减少的数值加在你的防御力上'}),
            '灵晶戒指' : new Element({battleUse : true, voidDust : 0, gold : 0, weight : 10, func(){
                    const name = '灵晶戒指';
                    if(!data.edu || !data.edu.over || !data.edu.follow){
                        winMsg('养成人物以HappyEnd完成剧情且跟随你时才能使用', false, false)
                        return false;
                    }
                    if(!data.edu.items.includes(name)){
                        winMsg('你没有送她这个戒指', false, false)
                        return false;
                    }
                    if(data.battleMonster.syjz){
                        winMsg('你已经使用过戒指了', false, false)
                        return false;
                    }

                    addStatus(data, getStatus('灵魂守护'))
                    addBattleLog(`你使用了${name}，获得了灵魂守护状态`)

                    data.battleMonster.syjz = true;
                    //渲染战斗页面
                    renderBattlePage();
                    //本回合结束，存档记录
                    save();
                    return false;
                }, text : '节日活动专属物品，只有给养成人物送了相同的戒指后才能使用，只能送给养成人物一种戒指（送了草编戒指也不能送节日活动的戒指了），养成人物以HappyEnd完成剧情且跟随你时才能使用，每场战斗只能使用一次，使用戒指不占用回合数，使用后戒指也不会消失，可以无限次数使用。获得灵魂守护状态，本场战斗中死亡时复活，并恢复50%血量，如果理智小于等于0，则恢复为1点理智'}),
        },
        //节日怪物
        monsters : {
            '丘比特' : {
                items : [{name : '爱神羽翼',minNum : 1, maxNum : 1}],
                skills : [{
                    name : '羽毛攻击',
                    type : 'atk',
                    text : '10%概率使用，飞射出羽毛进行攻击，造成1.5倍伤害，玩家可以获得1~3个爱神羽翼，玩家通过这种方式获得的爱神羽翼不能超过怪物等级/10*5个',
                    getStatus : function(){
                        let addNum = randomNum(1,3);
                        const max = parseInt(data.battleMonster.level / 10 * 5);
                        if(!data.battleMonster.sendItem){
                            data.battleMonster.sendItem = 0;
                        }
                        if(data.battleMonster.sendItem > 0){
                            if(data.battleMonster.sendItem + addNum > max){
                                addNum = max - data.battleMonster.sendItem;
                            }
                        }

                        if(addNum > 0){
                            data.battleMonster.sendItem += addNum;
                            addItem('爱神羽翼', addNum)
                            addBattleLog(`你获得了${addNum}个爱神羽翼`)
                        }
                        return null
                    },
                    check : function(){return randomNum(1, 100) <= 10},
                    getNum : function(){return parseInt(data.battleMonster.atk * 1.5)},
                }]
            }
        },
        //节日商定专属商品
        shop : {
            '秘银' : {
                '爱神羽翼' : 10,
            },
        },
        //节日特定地图上允许出现的资源和怪物
        terrainElements : {
            '森林' : {
                elements : {
                    ...terrainElement('可可树', [1,3], 5),
                }
            },
        },
    },
];

//格式化节日特定地图上允许出现的资源和怪物，图鉴用的
function formatFestivalTerrainElements(festivalTerrainElements){
    const items = {};
    Object.keys(festivalTerrainElements).forEach(e => {
        Object.keys(festivalTerrainElements[e].elements).forEach(el => {
            if(!items[el]){
                items[el] = [];
            }
            items[el].push(e);
        })
    })

    return Object.keys(items).map(e => `${e}：${items[e].join('，')}`).join('<br>') + '<br>'
}

//获取当前节日
function getFestival(){
    const thisDay = new Date();
    const monthDay = thisDay.format('MMdd')
    const chineseMonthDay = thisDay.getChinese();
    const arr = festivals.filter(e => {
        return e.dateType === '1' ? e.date.indexOf(monthDay) !== -1 : e.date.indexOf(chineseMonthDay) !== -1;
    });
    if(arr.length > 0){
        return arr[0];
    }
    return null;
}
const festival = getFestival();

//获取节日赠礼
function getFestivalGift(){
    if(festival){
        const thisDay = new Date();
        const monthDay = thisDay.format('MMdd')
        const chineseMonthDay = thisDay.getChinese();
        const ts = festival.giftDate.filter(e => e.dateType === '1' ? e.date === monthDay : e.date === chineseMonthDay);
        if(ts.length > 0){
            if(!data.getedGift){
                data.getedGift = [];
            }
            if(!data.getedGift.includes(new Date().format('yyyy-MM-dd'))){
                return ts[0];
            }
        }
        return null;
    }
}

//获取节日专属配方
function getFestivalRecipes(){
    if(festival){
        return festival.recipes;
    }
    return {}
}

//获取节日专属资源
function getFestivalElements(){
    let datas = {};
    festivals.forEach(e => {
        datas = {
            ...datas,
            ...e.elements
        }
    })
    return datas
}

//加载节日专属资源所在地形
function loadFestivalTerrainElements(){
    if(festival){
        Object.keys(festival.terrainElements).forEach(e => {
            terrainElements[e].elements = {
                ...terrainElements[e].elements,
                ...festival.terrainElements[e].elements
            }
        })


        const dungeonMaps = Object.keys(dungeons).map(e => dungeons[e].map);
        Object.keys(terrainElements).forEach(e => {
            if(dungeonMaps.includes(e)){
                return;
            }
            Object.keys(festival.monsters).forEach(fm => {
                mapCfgs.forEach(m => {
                    terrainElements[e].monster = {
                        ...terrainElements[e].monster,
                        ...terrainMonster(`${m.level[1]}级${fm}`, 1)
                    }
                })
            })
        })
    }
    return {}
}

function loadFestivalMonsters(){
    if(festival){
        Object.keys(festival.monsters).forEach(e => {
            mapCfgs.forEach((m, index) => {
                monsterCfgs = {
                    ...monsterCfgs,
                    [`${m.level[1]}级${e}`] : {
                        atkTime : '全天',
                        atkProb : 0,
                        level : m.level[1],
                        hp : monsterCfgs[m.finalBoss].hp / 10,
                        atk : monsterCfgs[m.finalBoss].atk,
                        def : monsterCfgs[m.finalBoss].def,
                        exp : monsterCfgs[m.finalBoss].exp / 10,
                        type : '精英',
                        items : festival.monsters[e].items.map(i => ({name : i.name, minNum : i.minNum * (index + 1), maxNum : i.maxNum * (index + 1)})),
                        text : '节日活动专属怪物'
                    },
                }

                const skills = [];
                if(festival.monsters[e].skills.length > 0){
                    festival.monsters[e].skills.forEach(e => {
                        skills.push(e.name);
                    })
                }
                monsterSkillMapping = {
                    ...monsterSkillMapping,
                    [`${m.level[1]}级${e}`] : skills,
                }
            })

            //添加技能
            if(festival.monsters[e].skills.length > 0){
                festival.monsters[e].skills.forEach(e => {
                    monsterSkills = {
                        ...monsterSkills,
                        [e.name] : e
                    }
                })
            }
        })
    }
    return {}
}
loadFestivalMonsters();

//渲染节日商店
function renderFestivalShop(){
    $('.wandering-merchant-shop').show();
    $('.wandering-merchant-shop .buy').html('');
    Object.keys(festival.shop).forEach(e => {
        let html = '';
        html += `<div class="buy-good">`;
        html += `<div><div class="good-name" style="width:100%;text-align: center"><h4 style="margin: 0px">${e}<span class="to-cybernet" data-name="${e}">🔍</span></h4></div></div>`;
        html += `<div style="height: ${(Object.keys(festival.shop[e]).length + 1) * 40}px">${Object.keys(festival.shop[e]).map(i => `<div class="price" style="float: unset">${i}：${festival.shop[e][i]}/${getNumByBag(i, data.location.join() === data.world.home.location.join())}</div>`).join('')}<div class="buy-btns">`;
        html += `<button class="buy-festival-good-btn" data-name="${e}" data-num="1">买1个</button>`;
        html += `<button class="buy-festival-good-btn" data-name="${e}" data-num="10">买10个</button>`;
        html += `</div></div>`;
        $('.wandering-merchant-shop .buy').append(html);
    })
}

//购买节日商店
$('.wandering-merchant-shop .buy').on('click','.buy-festival-good-btn',function(){
    const name = $(this).attr('data-name');
    const num = parseInt($(this).attr('data-num'));

    const needs = festival.shop[name];

    for(const key in needs){
        if(getNumByBag(key, data.location.join() === data.world.home.location.join()) < needs[key] * num){
            winMsg(key + '不足',false,false)
            return;
        }
    }

    for(const key in needs){
        reduceItemByAll(key, needs[key] * num)
    }

    winMsg(`购买了${name}*${num}`)
    addItem(name,num);
    renderFestivalShop();

    save();
});
